/*
 * $Id:$
 */

package $block{jfcpackagename}.app.jfcworkflow_setting;

import java.io.*;
import java.util.*;
import jp.jasminesoft.jfc.JFCErrorManager;
import jp.jasminesoft.jfc.JFCUtils;
import jp.jasminesoft.jfc.ActionParameter;
import jp.jasminesoft.jfc.ProcessBean;
import jp.jasminesoft.jfc.ResultBean;
import jp.jasminesoft.jfc.WorkflowSettingUtil;
import jp.jasminesoft.jfc.dao.DataBindingContext;
import jp.jasminesoft.jfc.hibernate.DetachedCriteria;
import jp.jasminesoft.jfc.service.JFCEntityService;
import jp.jasminesoft.util.*;
import $block{jfcpackagename}.model.jfcworkflow_setting_c.*;
import $block{jfcpackagename}.model.jfcworkflow_setting_cp.*;
import $block{jfcpackagename}.model.jfcworkflow_setting_p.*;
import $block{jfcpackagename}.model.jfcparticipant_setting.JfcparticipantSettingMeta;
import $block{jfcpackagename}.model.jfcworkflow_setting.*;
import $block{jfcpackagename}.model.jfcworkflow_setting.ParticipantsCont;
import $block{jfcpackagename}.app.*;
import org.apache.log4j.Logger;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.hibernate.criterion.Subqueries;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineFactory;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

/**
 * JfcworkflowSettingServiceImpl
 *
 * @version $Revision:$ $Date:$
 * @author JasmineSoft
 */
public class JfcworkflowSettingServiceImpl implements JfcworkflowSettingService
{
    private final static Logger logger = Logger.getLogger(JfcworkflowSettingServiceImpl.class);

    private JFCErrorManager errorManager;

    @Autowired
    public void setJFCErrorManager(JFCErrorManager errorManager) {
        this.errorManager = errorManager;
    }

    public JFCErrorManager getJFCErrorManager() {
        return errorManager;
    }

    public String getFlowIdByParticipantId(String participantsId, ActionParameter p) {
        String flowId = null;
        $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[] jfcworkflow_setting_ary = null;

        ProcessBean pbean_jfcworkflowSetting = 
            (ProcessBean)p.appctx.getBean("ShowArrayJfcworkflowSettingProcessBean");
        pbean_jfcworkflowSetting.setActionParameter(p);

        try {
            pbean_jfcworkflowSetting.setParameter("participants", participantsId);
            Object o_jfcworkflowSetting = pbean_jfcworkflowSetting.process();

            if (o_jfcworkflowSetting != null && o_jfcworkflowSetting instanceof $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[]) {
                jfcworkflow_setting_ary =
                    ($block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[])o_jfcworkflowSetting;
                $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting jfcworkflowSetting = jfcworkflow_setting_ary[0];
                flowId = String.valueOf(jfcworkflowSetting.getFlow());
            }
        } catch (Exception e) {
            logger.error("occurs exception", e);
            Object[] ep = { e.getMessage() };
            p.errors.addJfcerror
                (errorManager.getJfcerror("error.dbaccess", ep, p.locale));
        } finally {
            if (pbean_jfcworkflowSetting != null) {
                pbean_jfcworkflowSetting.release();
            }
        }
        return flowId;
    }

    public String getFlowDefinitionFile(String participantId, ActionParameter p) {
        return getFlowDefinitionFile(getFlowIdByParticipantId(participantId, p));
    }

    public String getFlowDefinitionFile(String pkey) {
        WorkflowSettingUtil workflowSettingUtil = WorkflowSettingUtil.getInstance();

        StringBuilder sb = new StringBuilder();
        sb.append(workflowSettingUtil.getFlowDefinitionOutputDirectory());
        sb.append(File.separator);
        sb.append("flow-definition-");
        sb.append(pkey);
        sb.append(".xml");
        return sb.toString();
    }

    public String getParticipantDefinitionFile(String pkey) {
        WorkflowSettingUtil workflowSettingUtil = WorkflowSettingUtil.getInstance();

        StringBuilder sb = new StringBuilder();
        sb.append(workflowSettingUtil.getParticipantDefinitionOutputDirectory());
        sb.append(File.separator);
        sb.append("participant-map-");
        sb.append(pkey);
        sb.append(".xml");
        return sb.toString();
    }

    public JfcworkflowSettingP[] getAllJfcworkflowSettingPArray(String modelname, ActionParameter p) { 
        return getJfcworkflowSettingPArray(modelname, p, null, true, null);
    }

    public JfcworkflowSettingP[] getJfcworkflowSettingPArray(String modelname, ActionParameter p) { 
        return getJfcworkflowSettingPArray(modelname, p, p.user.getGroupId(), false, null);
    }

    public JfcworkflowSettingP[] getJfcworkflowSettingPArray(String modelname, String currentNodeName, ActionParameter p) {
        return getJfcworkflowSettingPArray(modelname, p, p.user.getGroupId(), false, currentNodeName);
    }

    private JfcworkflowSettingP[] getJfcworkflowSettingPArray(String modelname, ActionParameter p, int[] groupid, boolean isall, String currentNodeName) { 
        Object obj = p.request.getAttribute(modelname);
        List<JfcworkflowSettingP> jfcworkflowSettingPList = getJfcworkflowSettingPArray(modelname, obj, currentNodeName, p);
        return jfcworkflowSettingPList.toArray(new JfcworkflowSettingP[0]);
    }

    private List<JfcworkflowSettingP> getJfcworkflowSettingPArray(String modelname, Object obj, String currentNodeName, ActionParameter p) {
        $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[] jfcworkflow_setting_ary = null;
        List<JfcworkflowSettingP> jfcworkflowSettingPList = new ArrayList<JfcworkflowSettingP>();

        try {
            jfcworkflow_setting_ary = getJfcworkflowSettingArray(modelname, currentNodeName, p);
            for (JfcworkflowSetting jfcworkflowSetting : jfcworkflow_setting_ary) {
                if (isSelectable(modelname, obj, jfcworkflowSetting, p)) {
                    jfcworkflowSettingPList.add((($block{jfcpackagename}.app.jfcworkflow_setting.JfcworkflowSettingPHelper)p.appctx.getBean("JfcworkflowSettingPHelper")).s2p(jfcworkflowSetting, p, $block{jfcpackagename}.app.jfcworkflow_setting.JfcworkflowSettingPHelper.SHOW));
                }
            }
        } catch (Exception e) {
            logger.error("occurs exception", e);
            Object[] ep = { e.getMessage() };
            p.errors.addJfcerror
                (errorManager.getJfcerror("error.dbaccess", ep, p.locale));
        } finally {
        }
        return jfcworkflowSettingPList;
    }

    public JfcworkflowSetting[] getJfcworkflowSettingArray(String modelname, String currentNodeName, ActionParameter p) {
    	return getJfcworkflowSettingArray(modelname, currentNodeName, p.user.getGroupId(), false, p);
    }

    public JfcworkflowSetting[] getJfcworkflowSettingArray(String modelname, String currentNodeName, int[] groupid, boolean isall, ActionParameter p) {
        ProcessBean pbean_jfcworkflowSetting = 
                (ProcessBean)p.appctx.getBean("ShowArrayJfcworkflowSettingProcessBean");
        pbean_jfcworkflowSetting.setActionParameter(p);
        pbean_jfcworkflowSetting.setParameter("modelname", modelname);
        pbean_jfcworkflowSetting.setParameter("isall", new Boolean(isall));
        pbean_jfcworkflowSetting.setParameter("username", p.user.getUsername());
        pbean_jfcworkflowSetting.setParameter("groupids", groupid);
        if (currentNodeName != null) {
            pbean_jfcworkflowSetting.setParameter("layerId", currentNodeName);// "1", "2", ...
        }
        Object obj = p.request.getAttribute(modelname);
        List<JfcworkflowSetting> jfcworkflowSettingList = new ArrayList<JfcworkflowSetting>();
        $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[] jfcworkflowSettingArray = new $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[0];
        try {
            Object o_jfcworkflowSetting = pbean_jfcworkflowSetting.process();
            if (o_jfcworkflowSetting != null && o_jfcworkflowSetting instanceof $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[]) {
                jfcworkflowSettingArray =
                    ($block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting[])o_jfcworkflowSetting;
            }
            jfcworkflowSettingList.addAll(Arrays.asList(jfcworkflowSettingArray));
            jfcworkflowSettingList.addAll(getJfcworkflowSettingListFromScript(modelname, currentNodeName, p));
        } catch (Exception e) {
            logger.error("occurs exception", e);
            Object[] ep = { e.getMessage() };
            p.errors.addJfcerror
                (errorManager.getJfcerror("error.dbaccess", ep, p.locale));
        } finally {
            if (pbean_jfcworkflowSetting != null) {
            	pbean_jfcworkflowSetting.release();
            }
        }
        return jfcworkflowSettingList.toArray(new JfcworkflowSetting[0]);
    }

    public JfcworkflowSettingP[] getJfcworkflowSettingPs(String modelname, Integer flowId, ActionParameter p) { 
        jp.jasminesoft.jfc.service.JFCEntityService entityService = (jp.jasminesoft.jfc.service.JFCEntityService)p.appctx.getBean("JfcworkflowSettingEntityService");
        JfcworkflowSettingMeta meta = new JfcworkflowSettingMeta();
        DetachedCriteria criteria = DetachedCriteria.forClass(meta.entityClass());
        criteria.eq(meta.modelname, modelname);
        if (flowId != null) {
            criteria.eq(meta.participants, flowId);
        }
        List<$block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting> list = entityService.find(criteria);
        if (list.isEmpty()) {
            return null;
        }
        List<JfcworkflowSettingP> jfcworkflowSettingPList = new ArrayList<JfcworkflowSettingP>();
        for ($block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting jfcworkflowSetting : list) {
            jfcworkflowSettingPList.add(
                (($block{jfcpackagename}.app.jfcworkflow_setting.JfcworkflowSettingPHelper) p.appctx.getBean("JfcworkflowSettingPHelper")).s2p(jfcworkflowSetting,
                                                                                                                                             ((ActionParameter) p),
                                                                                                                                             $block{jfcpackagename}.app.jfcworkflow_setting.JfcworkflowSettingPHelper.SHOW));
        }
        return jfcworkflowSettingPList.toArray(new JfcworkflowSettingP[0]);
    }

    private List<JfcworkflowSettingP> getJfcworkflowSettingPArrayFromScript(String modelname, String layer_id, ActionParameter p) { 
        List<JfcworkflowSetting> list = getJfcworkflowSettingListFromScript(modelname, layer_id, p);
        List<JfcworkflowSettingP> jfcworkflowSettingPList = new ArrayList<JfcworkflowSettingP>();
        if (list.isEmpty()) {
            return jfcworkflowSettingPList;
        }
        for (JfcworkflowSetting jfcworkflowSetting : list) {
            jfcworkflowSettingPList.add(
                (($block{jfcpackagename}.app.jfcworkflow_setting.JfcworkflowSettingPHelper) p.appctx.getBean("JfcworkflowSettingPHelper"))
                    .s2p(jfcworkflowSetting, p, $block{jfcpackagename}.app.jfcworkflow_setting.JfcworkflowSettingPHelper.SHOW));
        }
        return jfcworkflowSettingPList;
    }

    private List<JfcworkflowSetting> getJfcworkflowSettingListFromScript(String modelname, String layer_id, ActionParameter p) { 
        @SuppressWarnings("unchecked")
        JFCEntityService<JfcworkflowSetting, Integer> entityService =
                (JFCEntityService<JfcworkflowSetting, Integer>) p.appctx.getBean("JfcworkflowSettingEntityService");
        DataBindingContext context = new DataBindingContext();
        context.setTargetItemSet(new HashSet<String>(Arrays.asList(
            new String[] { "participant_script","flow" })));// 2021.2.25 add "flow"

        JfcworkflowSettingMeta meta = new JfcworkflowSettingMeta();
        DetachedCriteria criteria = DetachedCriteria.forClass(meta.entityClass());
        criteria.eq(meta.modelname, modelname);
        
        // Acquire the data for which the script field of the application node of the flow participant setting is set.
        //criteria.isNotNull(meta.participant_script); // Not supported, look up container.
        JfcparticipantSettingMeta psMeta = new JfcparticipantSettingMeta();
        DetachedCriteria subquery = criteria.createSubqueries(psMeta);
        subquery.setProjection(Projections.id());
        // Binding condition of subquery.
        subquery.add(Restrictions.eqProperty(
                criteria.getAlias() + "." + meta.participants.name(),
                meta.participants.roleid().name()));
        criteria.add(Subqueries.exists(subquery));
        subquery.isNotNull(psMeta.participant_script);
        // FIXME: What happens when the hierarchy ID is blank? layer_id = "1" is right ?
        // @see ShowArrayJfcworkflowSettingProcessBean#outputWhereMain(boolean, StringBuilder, Map)
        if (StringUtils.isBlank(layer_id)) {
            layer_id = "1";
        }
        subquery.eq(psMeta.layer_id, layer_id);
        
        List<JfcworkflowSetting> jfcworkflowSettingList = new ArrayList<JfcworkflowSetting>();
        List<JfcworkflowSetting> list = entityService.find(criteria, context);
        if (list.isEmpty()) {
            return jfcworkflowSettingList;
        }
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        for (JfcworkflowSetting jfcworkflowSetting : list) {
            ParticipantsCont[] cont = jfcworkflowSetting.getParticipantsCont();
            String script = null;
            String admitUserOrGroup = null;
            if (cont != null) {
                for (ParticipantsCont participants : cont) {
                    if (!participants.getLayerId().equals(layer_id)) {
                        continue;
                    }
                    script = participants.getParticipantScript();
                    if (StringUtils.isBlank(script)) {
                        continue;
                    }
                    admitUserOrGroup = wman.getAdmitUsersOrGroupFromScript(modelname, null, script, p); 
                    if (!StringUtils.contains(admitUserOrGroup, p.user.getUsername()) &&
                        !wman.isUserBelongToParticipantGroup(modelname, p.user.getUsername(), admitUserOrGroup, p)) {
                        continue;
                    }
                    jfcworkflowSettingList.add(jfcworkflowSetting);
                    break;
                }
            }
        }
        return jfcworkflowSettingList;
    }

    private boolean isSelectable(String modelname, Object model, $block{jfcpackagename}.model.jfcworkflow_setting.JfcworkflowSetting wfs, ActionParameter p) {
        String code = wfs.getSelectableCode();
        if (StringUtils.isBlank(code)) {
            logger.debug("No condition code is found. return true.");
            //System.out.println("No condition code is found. return true.");
            return true;
        }
        return checkCondition(modelname, model, code, p, true);
    }

    private boolean checkCondition(String modelname, Object model, String code, ActionParameter p, boolean defaultReturnValue) {
        if (modelname == null) {
            logger.debug("modelname is null.");
            return defaultReturnValue;
        }
        if (model == null) {
            logger.debug("model is null.");
            return defaultReturnValue;
        }
        boolean isRhino = false;
        try {
            ScriptEngineManager manager = new ScriptEngineManager();
            ScriptEngine engine = manager.getEngineByName("JavaScript");
            if (engine == null) {
                logger.warn("No JavaScript Engine is found.");
                //System.out.println("No JavaScript Engine is found.");
                return defaultReturnValue;
            } else {
                ScriptEngineFactory factory = engine.getFactory();
                String engineName = factory.getEngineName();
                /*
                getEngineName=Mozilla Rhino
                getEngineVersion=1.7 release 3 PRERELEASE
                getLanguageName=ECMAScript
                getLanguageVersion=1.8
                getNames=[js, rhino, JavaScript, javascript, ECMAScript, ecmascript]
                */
                List<String> names = factory.getNames();
                if (engineName.toLowerCase().indexOf("rhino") >= 0 || names.contains("rhino")) {
                    isRhino = true;
                }
            }
            engine.put(modelname, model);
            engine.put("p", p);

            StringBuilder sb = new StringBuilder();
            if (isRhino) {
                sb.append("importClass(Packages.jp.jasminesoft.util.ExcelFunction);");
            }
            sb.append("function process() {");
            if (!isRhino) { // Nashhorn
                sb.append("var ExcelFunction = Java.type(\"jp.jasminesoft.util.ExcelFunction\");");
            }
            sb.append(code).append("}");
            //System.out.println("code="+sb.toString());

            engine.eval(sb.toString());
            Invocable inv = (Invocable)engine;
            Object status = inv.invokeFunction("process");
	    
            if (status != null && status instanceof Boolean) {
                Boolean b = (Boolean)status;
                return b.booleanValue();
            }
        } catch (ScriptException e) {
            e.printStackTrace();
            logger.warn("An error has detected in the script code. Check the grammar and variable name.",e);
            return false;
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
            logger.warn("Script has no 'process' function.",e);
            return false;
        } catch (Exception e) {
            e.printStackTrace();
        }
        return defaultReturnValue;
    }

    // BR4892 2009.11.05
    // Method for getting setting of remand point of workflow setting model.
    // Returns true if you want to return it to the applicant.
    public boolean isBackToApplicant(String modelname, Integer participants, ActionParameter p) {
        Object obj = p.request.getAttribute(modelname);
        List<JfcworkflowSettingP> jfcworkflowSettingPList =
                getJfcworkflowSettingPArray(modelname, obj, null, p);
        if (jfcworkflowSettingPList == null || jfcworkflowSettingPList.isEmpty()) {
            return false;
        }
        RemandType[] remandType = jfcworkflowSettingPList.get(0).getRemandType();
        if (remandType == null || remandType.length == 0) {
            return false;
        }
        if (remandType[0].getId() == 2) {
            return true;
        }
        return false;
    }

    // BR 8220, 2014.12.06
    // Determining whether to display the decision button in the middle of the node.
    public boolean isEndButtonEnable(String modelname, String pkey, String currentNodeName, ActionParameter p) { 
        if (currentNodeName == null) {
            return false;
        }
        WorkFlowManager wman = WorkFlowManager.getInstance(p);
        int flowId = wman.getFlowId(modelname, pkey, p);
        JfcworkflowSettingP[] jfcworkflowSettingPArray = wman.getJfcworkflowSettingPs(modelname, flowId, p);
        if (jfcworkflowSettingPArray == null || jfcworkflowSettingPArray.length == 0) {
            return false;
        }
        $block{jfcpackagename}.model.jfcworkflow_setting_p.EndbuttonSetting[] endbuttonSettings = 
            jfcworkflowSettingPArray[0].getEndbuttonSetting();
        for ($block{jfcpackagename}.model.jfcworkflow_setting_p.EndbuttonSetting endbuttonSetting : endbuttonSettings) {
            String beginnode = endbuttonSetting.getEsbeginnode().getContent();
            if (!currentNodeName.equals(beginnode)) {
                continue;
            }
            //System.out.println("Bingo!, "+endbuttonSetting);
            String code = endbuttonSetting.getEscondition().getContent();
            if (StringUtils.isNotBlank(code)) {
                Object obj = p.request.getAttribute(modelname);
                return checkCondition(modelname, obj, code, p, false);
            }
        }
        return false;
    }
}
