/*
   manages initialize and finalize
*/
// 定数の定義
var httpXMLRequest_DefaultTimerTimeoutSec = 60; //タイムアウトの秒数
var httpXMLRequest_IsShowProcessTime = false;
var parameter_limit_size=2083;

// メニュー二重押し防止用の変数
var clickedMenu = false;

// グローバル変数の定義
var tips = new Array();
var httpObj = false;
var timerId = '';
var timerBeginTime;
var timerTimeoutSec;
var failedFuncRef;
var isReplaceFirstYearOfImperialEra = true;
var wareki_date_a = new Array(
      new Date(1868,  9-1,  8),
      new Date(1912,  7-1, 30),
      new Date(1926, 12-1, 25),
      new Date(1989,  1-1,  8),
      new Date(2019,  5-1,  1)
);
var wareki_regexp_a = new Array(
      new RegExp("明[治]?", "g"),
      new RegExp("大[正]?", "g"),
      new RegExp("昭[和]?", "g"),
      new RegExp("平[成]?", "g"),
      new RegExp("令[和]?", "g")
);
var wareki_fullname_a = new Array("明治", "大正", "昭和", "平成", "令和");
var wareki_shortcharpattern_a = new Array("Mm", "Tt", "Ss", "Hh", "Rr");

/* 日本では1873年(明治6年)1月1日より、太陽暦となる。 */
var wareki_date_start = new Date(1873, 1-1, 1);

var month_mmm_table = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
var youbi_ddd_table = new Array("sun","mon","tue","wed","thu","fri","sat");
var youbi_dddd_table =
    new Array("Sunday","Monday","Tuesday","Wednesday",
              "Thursday","Friday","Saturday");
var youbi_aaa_table = new Array("日","月","火","水","木","金","土");
var warekiFullnameStr = "明治|大正|昭和|平成|令和";
var warekiFullnameRegExpStr = "(?:" + warekiFullnameStr + ")";
var warekiShortnameRegExpStr = "(?:[MmTtSsHhRr])";
var dateFormatRegExpStr = {
  "ggge年MM月dd日": "(" + warekiFullnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月(\\d{1,2})日",
  "ggge年M月d日": "(" + warekiFullnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月(\\d{1,2})日",
  "ggge年MM月": "(" + warekiFullnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月",
  "ggge年M月": "(" + warekiFullnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月",
  "ggge年": "(" + warekiFullnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年",
  "ge年MM月dd日": "(" + warekiShortnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月(\\d{1,2})日",
  "ge年M月d日": "(" + warekiShortnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月(\\d{1,2})日",
  "ge年MM月": "(" + warekiShortnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月",
  "ge年M月": "(" + warekiShortnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年(\\d{1,2})月",
  "ge年": "(" + warekiShortnameRegExpStr + "\\d{1,2}|" + warekiFullnameRegExpStr + "元)年",
  "ge": "(" + warekiShortnameRegExpStr + "\\d{1,2})",
  "ge-MM-dd": "(" + warekiShortnameRegExpStr + "\\d{1,2})-(\\d{1,2})-(\\d{1,2})",
  "ge-M-d": "(" + warekiShortnameRegExpStr + "\\d{1,2})-(\\d{1,2})-(\\d{1,2})",
  "ge-MM": "(" + warekiShortnameRegExpStr + "\\d{1,2})-(\\d{1,2})",
  "ge-M": "(" + warekiShortnameRegExpStr + "\\d{1,2})-(\\d{1,2})",
  "ge/MM/dd": "(" + warekiShortnameRegExpStr + "\\d{1,2})/(\\d{1,2})/(\\d{1,2})",
  "ge/M/d": "(" + warekiShortnameRegExpStr + "\\d{1,2})/(\\d{1,2})/(\\d{1,2})",
  "ge/MM": "(" + warekiShortnameRegExpStr + "\\d{1,2})/(\\d{1,2})",
  "ge/M": "(" + warekiShortnameRegExpStr + "\\d{1,2})/(\\d{1,2})",
  "yyyy年MM月dd日": "(\\d{1,4})年(\\d{1,2})月(\\d{1,2})日",
  "yyyy年M月d日": "(\\d{1,4})年(\\d{1,2})月(\\d{1,2})日",
  "yyyy-MM-dd": "(\\d{1,4})-(\\d{1,2})-(\\d{1,2})",
  "yyyy-M-d": "(\\d{1,4})-(\\d{1,2})-(\\d{1,2})",
  "yyyy/MM/dd": "(\\d{1,4})/(\\d{1,2})/(\\d{1,2})",
  "yyyy/M/d": "(\\d{1,4})/(\\d{1,2})/(\\d{1,2})",
  "yy/MM/dd": "(\\d{1,2})/(\\d{1,2})/(\\d{1,2})",
  "yyyy.MM.dd": "(\\d{1,4})\\.(\\d{1,2})\\.(\\d{1,2})",
  "yyyy.M.d": "(\\d{1,4})\\.(\\d{1,2})\\.(\\d{1,2})",
  "yyyyMMdd": "(\\d{1,4})(\\d{1,2})(\\d{1,2})",
  "yyyy年MM月": "(\\d{1,4})年(\\d{1,2})月",
  "yyyy年M月": "(\\d{1,4})年(\\d{1,2})月",
  "yyyy-MM": "(\\d{1,4})-(\\d{1,2})",
  "yyyy-M": "(\\d{1,4})-(\\d{1,2})",
  "yyyy/MM": "(\\d{1,4})/(\\d{1,2})",
  "yyyy/M": "(\\d{1,4})/(\\d{1,2})",
  "yyyy.MM": "(\\d{1,4})\\.(\\d{1,2})",
  "yyyy.M": "(\\d{1,4})\\.(\\d{1,2})",
  "yyyyMM": "(\\d{1,4})(\\d{1,2})",
  "yyyyM": "(\\d{1,4})(\\d{1,2})",
  "yyyy年": "(\\d{1,4})年",
  "yyyy": "(\\d{1,4})",
  "yyyy-MM-dd HH:mm:ss": "(\\d{1,4})-(\\d{1,2})-(\\d{1,2}) (\\d{1,2}):(\\d{1,2}):(\\d{1,2})",
  "yyyy/MM/dd HH:mm:ss": "(\\d{1,4})/(\\d{1,2})/(\\d{1,2}) (\\d{1,2}):(\\d{1,2}):(\\d{1,2})",
  "yyyy.MM.dd HH:mm:ss": "(\\d{1,4})\\.(\\d{1,2})\\.(\\d{1,2}) (\\d{1,2}):(\\d{1,2}):(\\d{1,2})",
  "yyyy年MM月dd日 HH:mm:ss": "(\\d{1,4})年(\\d{1,2})月(\\d{1,2})日 (\\d{1,2}):(\\d{1,2}):(\\d{1,2})",
  "yyyy年M月d日 HH:mm:ss": "(\\d{1,4})年(\\d{1,2})月(\\d{1,2})日 (\\d{1,2}):(\\d{1,2}):(\\d{1,2})",
  "dd-MMM-yyyy": "(\\d{1,2})-(\\w{3}|\\d{1,2})-(\\d{1,4})",
  "dd-MM-yyyy": "(\\d{1,2})-(\\d{1,2})-(\\d{1,4})"
};

var browser_locale = "";

// 国際化リソースファイル
var res;
function setLocale(locale) {
    if (locale != undefined) {
        dojo.registerModulePath("apphome", "../..");
        dojo.requireLocalization("apphome", "common", locale);
        res = dojo.i18n.getLocalization("apphome", "common", locale);
        browser_locale = locale;
    }
}


function Initializer() {
}
Initializer.initList = new Array();
Initializer.addInit = function(fnc) {
   Initializer.initList.push(fnc);
}
Initializer.addCustomizeInit = function(fnc) {
  var deleteIndex = 0;
  for (deleteIndex; deleteIndex<Initializer.initList.length; deleteIndex++) {
    if (Initializer.initList[deleteIndex].name === "init") {
      break;
    }
  }
  Initializer.initList.splice(deleteIndex, 1);
  Initializer.addInit(fnc);
}
Initializer.init = function() {
   for (i in Initializer.initList) {
      (Initializer.initList[i])();
   }
}
Initializer.finList = new Array();
Initializer.addFin = function(fnc) {
   Initializer.finList.push(fnc);
}
Initializer.fin = function() {
   for (i in Initializer.finList) {
      (Initializer.finList[i])();
   }
}

function doConfirm(f, msg) {
  return doConfirm(f, msg, false);
}
function doConfirm(f, msg, b) {
  if (confirm(msg)) {
    if (b)
      buttonOff();
    return true;
  } else {
    return false;
  }
}

function buttonOn() {
  setButtonDisabled(false);
}
function buttonOff() {
  setButtonDisabled(true);
}
var disabledPropertyOfButtons = {};
function setButtonDisabled(disabled) {
  require(["dojo/query", "dijit/registry"], function(query, registry) {
    query("span[role='button']").forEach(function(button) {
      var widget = registry.byId(button.id);
      if (widget) {
        if (disabled) {
          if (!widget.get("disabled")) {
            disabledPropertyOfButtons[button.id] = true;
            widget.set("disabled", true);
          }
        } else {
          if (window.disabledPropertyOfButtons[button.id]) {
            widget.set("disabled", false);
            delete disabledPropertyOfButtons[button.id];
          }
        }
      }
    });
  });
}

function doClear(f) {
  f.reset();
  require(["dojo/_base/array", "dojo/query", "dijit/registry"], function(array, query, registry){
    var rejfcpkey = new RegExp('_ulp\\$002fitem\\$005b[0-9]*\\$005d\\$002f\\$0040(jfcpkey|jfcpkeygroupnum)$');
    // 引数の form 下の Dojo Widget を全てクリアする
    var widgets = getAllWidgets();
    for (var i=0,l=widgets.length; i<l; i++) {
      var widget = widgets[i];
      var widgetBaseClass = widget.baseClass;
      if (widget.type === "submit" || widget.type === "button" ||
            widgetBaseClass === "dijitTabContainerTop" || widgetBaseClass === "" ||
            widget.name.match(rejfcpkey)) {
        continue;
      }
      if (widgetBaseClass.indexOf("dijitRadio") !== -1 || widgetBaseClass.indexOf("dijitCheckBox") !== -1) {
        // ラジオ、チェックボックスのクリア
        widget.set("checked", false);
      } else if (widgetBaseClass.indexOf("dijitDateTextBox") !== -1) {
        // 日付のクリア
        widget.set("displayedValue", "");
      } else if (widgetBaseClass.indexOf("dijitSelect") !== -1 ||
                 (widgetBaseClass.indexOf("dijitTextBox") !== -1 && !widget.get("readOnly"))) {
        // リストボックス、テキストボックス(読み込み専用以外)、サジェストのクリア
        widget.set("value", "");
        // サジェストの場合
        if (widget.declaredClass.indexOf("FilteringSelect") !== -1) {
          widget.set("_lastValueReported", "");
          widget.item = null;
          widget.textbox.value = "";
        }
      } else if (widgetBaseClass.indexOf("dijitTextBox") !== -1 && widget.get("readOnly") &&
                 widget.id.lastIndexOf("_", 0) === 0 && widget.tabIndex === "-1") {
        // 検索画面の値をクリア
        // 検索画面で値が設定されるテキストボックスは id が「_」で始まり「_content」で終わる
        var lengthWithoutContent = widget.id.length - "_content".length;
        if ((lengthWithoutContent > 0) && (widget.id.lastIndexOf("_content") === lengthWithoutContent)) {
          widget.set("value", "");
        }
      }
    }
    // リッチテキストエリアのクリア
    query('div[class="dijitEditor"]').forEach(function(node) {
      registry.byId(node.id).set("value", "");
    });
    // ファイル型のクリア
    query('input[name$="_jshclear"]').forEach(function(node) {
      node.value = "aaa";
    });
  });

  eval("individualClear(\""+f.name+"\");");
  return true;
}
// bodyタグのonloadイベントが行われたことを示す
// フックをセットします。
function setOnloadHook() {
   dc = null;
   if (document.getElementsByTagName) {
      dc = document
   } else
   if (document.all.getElementsByTagName) {
      dc = document.all;
   }

   elemArray = dc.getElementsByTagName("body");
   if (elemArray == null || elemArray.length == 0) {
      return;
   }
   bElem = elemArray[0];

   bElem["isLoaded"] = true;
}

Initializer.addInit(setOnloadHook);

Initializer.addInit( function () {
  if (!dojo.isIE) {
      return;
  }
  // IE autocomplete で change イベントが発生しない問題への対策。
  // この処理で対応できるのは HTML に onChange 属性を記述したもののみ。
  // addEventListener や attachEvent で追加された change イベントは
  // 対応できない。これらについては addListener で対応する。
  dojo.query("input[type='text']").forEach(function (element) {
      if (!autocompleteOn(element)) {
          return;
      }
      if (element.onchange == null) {
          return;
      }
      dojo.connect(element, "onfocus", function() {
        this._oldValue = this.value;
      });
      element._onchange = element.onchange;
      element.onchange = function () {};
      dojo.connect(element, "onblur", function() {
        if (this.value != this._oldValue) {
          element._onchange();
        }
      });
  });
});

function autocompleteOn(element) {
  return false;
/*
  if (element.autocomplete == "off") {
      return false;
  }
  return true;
*/
}

// bodyタグのonloadイベントが行われたことを示す
// フックがセットされているか確認します。
// フックがセットされていればtrueを返します。
function isOnloadHook() {
   dc = null;

   if (document.getElementsByTagName) {
      dc = document
   } else
   if (document.all.getElementsByTagName) {
      dc = document.all;
   }

   elemArray = dc.getElementsByTagName("body");
   if (elemArray == null || elemArray.length == 0) {
      return false;
   }
   bElem = elemArray[0];
   if (bElem["isLoaded"] == null) {
       return false;
   }
   return bElem["isLoaded"];
}

//--表示属性set(表示)
function showLAYER(layName){
    if (! isOnloadHook()) {
        return;
    }

    if(document.getElementById) {        //e5,e6,n6,n7,m1,o6,o7,s1用
      document.getElementById(layName).style.visibility='visible'
    } else
    if(document.all) {               //e4用
      document.all(layName).style.visibility='visible'
    } else
    if(document.layers) {            //n4用
      document.layers[layName].visibility='show'
    }
}
//--表示属性set(非表示)
  function hideLAYER(layName){
    if(document.getElementById) {         //e5,e6,n6,n7,m1,o6,o7,s1用
      document.getElementById(layName).style.visibility='hidden'
    } else
    if(document.all) {              //e4用
      document.all(layName).style.visibility='hidden'
    } else
    if(document.layers) {           //n4用
      document.layers[layName].visibility='hide'
    }
}

//ポップアップメニューを表示する。
function showMenuLAYER(layName){
    if (! isOnloadHook()) {
        return;
    }

    if(document.getElementById) {        //e5,e6,n6,n7,m1,o6,o7,s1用
      document.getElementById(layName).style.visibility='visible'
      if (isIE() && getIEVersion() < 7) {
        openShim(document.getElementById(layName));
      }
    } else
    if(document.all) {               //e4用
      document.all(layName).style.visibility='visible'
    } else
    if(document.layers) {            //n4用
      document.layers[layName].visibility='show'
    }
}
//ポップアップメニューを非表示にする。
function hideMenuLAYER(layName){
    if(document.getElementById) {         //e5,e6,n6,n7,m1,o6,o7,s1用
      document.getElementById(layName).style.visibility='hidden'
      if (isIE() && getIEVersion() < 7) {
        closeShim(document.getElementById(layName));
      }
    } else
    if(document.all) {              //e4用
      document.all(layName).style.visibility='hidden'
    } else
    if(document.layers) {           //n4用
      document.layers[layName].visibility='hide'
    }
}

// IE5.5以降のウィンドウコントロール(コンボボックス)はHTML要素の
// 上に表示されます。そのためポップアップメニューがコンボボックスの
// 下にもぐりこむ現象が発生します。これを防ぐために、ポップアップ
// メニュと同じ位置、同じ大きさのiframe要素を置き、その上に
// ポップアップメニューを表示します。
// このiframe要素を使った技術はシム(Shim:クサビ)技術と呼ばれています。

function openShim(menu)
{

    if (menu==null) return;
    var shim = getShim(menu);
    if (shim==null) {
        shim = createMenuShim(menu,getShimId(menu));
    }

    menu.style.zIndex = 100;

    shim.style.width = menu.offsetWidth;
    shim.style.height = menu.offsetHeight;
    shim.style.top = menu.offsetTop;
    shim.style.left = menu.offsetLeft;
    shim.style.zIndex = menu.style.zIndex - 1;
    shim.style.position = "absolute";
    shim.style.display = "block";
}


function closeShim(menu)
{
    if (menu==null) return;
    var shim = getShim(menu);
    if (shim!=null) shim.style.display = "none";
}

// シムを生成します。
function createMenuShim(menu)
{
    if (menu==null) return null;

    var shim = document.createElement("<iframe src='javascript:false;' "+
                                      "scrolling='no' frameborder='0'"+
                                      "style='position:absolute; top:0px;"+
                                      "left:0px; display:none'></iframe>");
    shim.name = getShimId(menu);
    shim.id = getShimId(menu);

    if (menu.offsetParent==null || menu.offsetParent.id=="") {
        window.document.body.appendChild(shim);
    } else {
        menu.offsetParent.appendChild(shim);
    }

    return shim;
}

// シムのidを作成します。
function getShimId(menu)
{
    if (menu.id==null) return "__shim";
    return "__shim"+menu.id;
}

//生成ずみのシムを取得します。
function getShim(menu)
{
    return document.getElementById(getShimId(menu));
}


//--背景色set
function setBGCOLOR(layName,color){
    //opera6 は透明が効かないのでページ背景色と同色(ここではwhite)へ便宜修正
    if(color=='')(navigator.userAgent.search("Opera(\ |\/)6")!= -1)
          ?color='white':color='transparent'; //←このwhiteを背景色に書換える
    if(document.getElementById)         //e5,e6,n6,n7,m1,o6,o7,s1用
      document.getElementById(layName).style.backgroundColor =color
    else if(document.all)               //e4用
      document.all(layName).style.backgroundColor=color
    else if(document.layers){           //n4用
      if(color=='transparent')color=null
        document.layers[layName].bgColor=color
    }
}
//--背景画像set
  function setBGIMG(layName,image){
    if(document.getElementById)         //e5,e6,n6,n7,m1,o6,o7,s1用
      document.getElementById(layName).style.backgroundImage
         = (image=='')?'':'url('+image+')'
    else if(document.all)               //e4用
      document.all(layName).style.backgroundImage='url('+image+')'
    else if(document.layers)            //n4用
      document.layers[layName].background.src=(image=='')?null:image
}
//--マウスX座標get
function getCmnMouseX(e){
    if(navigator.userAgent.search(
             "Opera(\ |\/)6") != -1 )   //o6用
        return e.clientX
    else if(document.all)               //e4,e5,e6用
        return document.body.scrollLeft+event.clientX
    else if(document.layers ||
            document.getElementById)    //n4,n6,n7,m1,o7,s1用
        return e.pageX
}
//--マウスY座標get
function getCmnMouseY(e){
    if(navigator.userAgent.search(
             "Opera(\ |\/)6") != -1 )   //o6用
        return e.clientY
    else if(document.all)               //e4,e5,e6用
        return document.body.scrollTop+event.clientY
    else if(document.layers ||
            document.getElementById)    //n4,n6,n7,m1,o7,s1用
        return e.pageY
}
//--HTML出力
function outputLAYER(layName,html){
    if(document.getElementById){        //e5,e6,n6,n7,m1,o7,s1用
		document.getElementById(layName).innerHTML=html
		if (isIE() && getIEVersion() < 7) {
			//IE7以前のバージョンではコンボボックスが透過するバグがあるため、
			//shim をセットする
			setShim2Element(layName);
		}
    } else if(document.all){            //e4用
        document.all(layName).innerHTML=html
    } else if(document.layers) {        //n4用
        with(document.layers[layName].document){
            open()
            write(html)
            close()
        }
    }
}
//--レイヤー移動
function moveLAYER(layName,x,y){
    if(document.getElementById){        //e5,e6,n6,n7,m1,o6,o7,s1用
        document.getElementById(layName).style.left = x
        document.getElementById(layName).style.top  = y
    } else if(document.all){            //e4用
        document.all(layName).style.pixelLeft = x
        document.all(layName).style.pixelTop  = y
    } else if(document.layers)          //n4用
        document.layers[layName].moveTo(x,y)
}
//--レイヤーオブジェクトを取得
//  (必ずonload後に実行すること)
function getLayOj(layName){
    if(document.getElementById)         //e5,e6,n6,n7,m1,o6,o7,s1用
      return document.getElementById(layName)
    else if(document.all)               //e4用
      return document.all(layName)
    else if(document.layers)            //n4用
      return document.layers[layName]
}
//ウインドウ有無確認関数
//e4,e5,e6,n4,n6,n7,m1,o6,o7,s1用
function win_closed(winOj) {
      var ua = navigator.userAgent
      if( !!winOj )
          if( ( ua.indexOf('Gecko')!=-1 || ua.indexOf('MSIE 4')!=-1 )
               && ua.indexOf('Win')!=-1 )
               return winOj.closed
          else return typeof winOj.document  != 'object'
      else return true
}

function includeClickTag(srcElement, rootElement) {
  if (srcElement == null) {
    return false;
  }
  var tag = srcElement.tagName;
  // Dojo1.5 の dijit.form.Button は表示時に span とinput に
  // 展開されるため、dijit の span タグのみを条件に加える
  if (isClickTag(tag) || isDojoButtonContainer(srcElement)) {
      return true;
  } else if (srcElement == rootElement) {
      return false;
  }

  return includeClickTag(srcElement.parentNode, rootElement);
}

function isClickTag(tag) {
  if (tag == 'INPUT' || tag == 'A' || tag == 'IMG' || tag == 'BUTTON' || tag == 'FORM') {
    return true;
  }
  return false;
}

// span タグが dijit.form.Button のコンテナノードか
// 属性値を確認する
function isDojoButtonContainer(srcElement) {
  // コンテナノードは span タグのみ
  if (srcElement.tagName != 'SPAN') {
    return false;
  }
  if (dojo.hasAttr(srcElement, "dojoattachpoint") ||
        dojo.hasAttr(srcElement, "dojoattachevent") ||
        dojo.hasAttr(srcElement, "widgetid")) {
    return true;
  }
  return false;
}

function jumpto(url) {
    window.opener.location = url;
}
function getTipsMessage(key) {
  return tips[key];
}
function showTipsMessage(key) {
  var msg = getTipsMessage(key);
  var height = 90 + (msg.length / 40) * 30;
  var w = window.open("", "_help", "width=400,height=" + height + ",resizable,scrollbars");
  var d = w.document;
  d.open("text/html");
  d.write('<style type="text/css">');
  d.write('.helpMsg { font-size: 14px; font-family: "Lucida Grande", "Hiragino Kaku Gothic ProN", Meiryo, sans-serif; white-space: pre-wrap; }');
  d.write('</style>');
  d.write('<div class="helpMsg">');
  d.write(msg);
  d.write('</div>');
  d.write('<br>');
  d.write('<div align="center">');
  d.write('<input type="button" onClick="window.close(self);" value="' + res.BUTTON_CLOSE + '">');
  d.write('</div>');
  d.close();
}

function SystemError() {
  return true;
}

window.onerror = SystemError;

function selmenu(menuref, selected) {
    selmenu2(menuref, selected, selected);
}

function selmenu2(menuref, selected_box, selected_head) {
    setCookie_menu(selected_box, selected_head);
    window.location.href = menuref;
}

function setCookie_menu(selected_box, selected_head) {
    setCookie("__jfc_cookie_tabindex", selected_box);
    setCookie("__jfc_cookie_tabindex_head", selected_head);
}

function seltab(bpref, hpref, selected) {
    seltab2(bpref, hpref, selected, selected);
}

function seltab2(bpref, hpref, selected_box, selected_head) {
    for (i = 1; ; i++) {
        var box_object = getLayOj(bpref+i);
        var head_object = getLayOj(hpref+i);
        if (!box_object) {
            break;
        }
        if (i == selected_box) {
            setCookie("__jfc_cookie_tabindex", i);
            showLAYER(bpref + i);
            box_object.style.position = "";
        } else {
            hideLAYER(bpref + i);
            box_object.style.position = "absolute";
        }
        if (head_object) {
            if (i == selected_head) {
                setCookie("__jfc_cookie_tabindex_head", i);
                head_object.className = "open";
            } else {
                head_object.className = "close";
            }
        }
    }
    clickedMenu = false;
}

function setCookie(setname, setdata, setexpires) {
  var str = setname + "=" + encodeURIComponent(setdata);
  if (setexpires) {
    var t = new Date();
    t.setTime(t.getTime()+(setexpires*1000*60*60*24));
    var expt = t.toGMTString();
    str += ";expires=" + expt;
  }
  document.cookie = str;
}

function getCookie(getname) {
  var cName = getname + "=";
  var getdata = null;
  var cCookie = document.cookie+";";
  var start = cCookie.indexOf(cName);
  if (start != -1) {
    var end = cCookie.indexOf(";", start);
    getdata = decodeURIComponent(cCookie.substring(start+cName.length, end));
  }
  return getdata;
}

function displayHTML(event, layName, html) {
    var x = getCmnMouseX(event);
    var y = getCmnMouseY(event);
    moveLAYER(layName, x+20, y+10);
    outputLAYER(layName, html);
    showLAYER(layName);

}

// 引数に与えられたURLにHTTPリクエストを行ない、値をタグ要素にセットする
function httpXMLRequest(
    target_url, param, method, functionReference, failedFunctionReference)
{
    // タイマーが動作中の場合は、タイマーをストップする。
    if (timerId != '') {
        clearInterval(timerId);
        timerId = '';
    }
    // HTTPリクエストを送信中の場合は、HTTPリクエストを中断する
    if (httpObj != false) {
        httpObj.abort();
        httpObj = false;
    }
    // 処理失敗時の関数参照を格納する
    failedFuncRef = failedFunctionReference;
    // httpObjの作成
    try {
        if(window.XMLHttpRequest) {
            httpObj = new XMLHttpRequest();
        } else if(window.ActiveXObject) {
            httpObj = new ActiveXObject("Microsoft.XMLHTTP");
        } else {
            httpObj = false;
        }
    } catch(e) {
        httpObj = false;
    }
    if(! httpObj) {
        // httpObjの作成に失敗した場合
        showAlertDialog('not supported your web browser!!');
        failedFuncRef();
        return false;
    }
    // タイマーをセット
    timerTimeoutSec = httpXMLRequest_DefaultTimerTimeoutSec;
    timerBeginTime = new Date().getTime();
    timerId = setInterval('timeoutCheck()', 1000);

    // HTTPリクエストを送信
    httpObj.open(method, target_url, true);
    httpObj.onreadystatechange = function() {
        if (typeof(httpObj) != 'undefined' && httpObj.readyState == 4) {
            // タイマーをストップする
            if (timerId != '') {
                clearInterval(timerId);
                timerId = '';
            }
            var timerEndTime = new Date().getTime();

            if (httpObj.status == 200) {
                // リクエストの受信に成功した場合
                functionReference(httpObj.responseXML);
                if (httpXMLRequest_IsShowProcessTime) {
                  showAlertDialog('process time '+(timerEndTime-timerBeginTime)+'ms');
                }
                httpObj = false;
            } else {
                // リクエストの受信に失敗した場合
                failedFuncRef();
                var alertmsg = 'httpXMLRequest '+httpObj.status + ' : ' + httpObj.statusText;
                if (httpXMLRequest_IsShowProcessTime) {
                    alertmsg =
                        alertmsg + '\n' +
                        'process time '+(timerEndTime-timerBeginTime)+'ms';
                }
                window.status = alertmsg;
                httpObj = false;
                return false;
            }
        }
    };
    if (param != '') {
        httpObj.setRequestHeader(
            'Content-Type', 'application/x-www-form-urlencoded');
    }
    httpObj.send(param);
    return true;
}

// タイムアウト処理
function timeoutCheck() {
    timerTimeoutSec --;
    if(timerTimeoutSec <= 0) {
        // タイムアウトした場合
        // タイマーをストップする
        if (timerId != '') {
            clearInterval(timerId);
            timerId = '';
        }
        var timerEndTime = new Date().getTime();

        // HTTPリクエストを中断する
        if (httpObj != false) {
            httpObj.abort();
            httpObj = false;
        }

        // エラーメッセージを表示
        failedFuncRef();
        if (httpXMLRequest_IsShowProcessTime) {
          showAlertDialog(
                'Http connection timeout!!\n'+
                'process time '+(timerEndTime-timerBeginTime)+'ms');
        }
        return false;
    }
}

function addListener(elem, eventType, func, cap) {
    // IE autocomplete で change イベントが発生しない問題への対策。
    // HTML に記述された onChange 属性への対応は別のところで処理している。
    if (dojo.isIE && autocompleteOn(elem)
            && elem.type == "text" && eventType == "change") {
        addListener(elem, 'focus', function() {
          elem._oldValue = elem.value;
        }, cap);
        eventType = "blur";
        var _func = func;
        func = function() {
          if (elem.value != elem._oldValue) {
            _func();
          }
        }
    }

    if(elem.addEventListener) {
        elem.addEventListener(eventType, func, cap);
    } else if(elem.attachEvent) {
        elem.attachEvent('on' + eventType, func);
    } else {
        showAlertDialog('not supported your web browser!!');
        return false;
    }
}

function getFieldboxPosition(id) {
  // 繰り返しコンテナの見出しは、CSS のクラスが field_box となっている div 要素
  // 内部に押下されたボタンが存在している繰り返しコンテナを取得する
  var fieldbox;
  var query = "input[name='" + id + "']";
//  dojo.query("div[class='field_box']").forEach(function(node) {
  dojo.query("fieldset").forEach(function(node) {
    var button = dojo.query(query, node)[0];
    if (button) {
      fieldbox = node;
    }
  });
  // タブが設定されている場合は、fieldbox がタブ内に存在しているか確認する
  var tabContainer;
  dojo.query("div[class~='dijitTabContainer']").forEach(function(node) {
    var button = dojo.query(query, node)[0];
    if (button) {
      tabContainer = node;
    }
  });
  var scrollPosition;
  if (fieldbox) {
    var scrollTop = fieldbox.offsetTop - 10; // コンテナの見出しが見えるように 10px 上部へ補正する
    if (tabContainer){
      // タブ内に繰り返しコンテナが存在している場合、タブの表示位置だけ補正する
      scrollTop += tabContainer.offsetTop + 20; // コンテナの見出しが見えるように 20px 上部へ補正する
    }
    var scrollLeft = fieldbox.scrollLeft;
    scrollPosition = {
      'scrollTop': scrollTop,
      'scrollLeft': scrollLeft
    };
  }
  return scrollPosition;
}

function getWindowPosition() {
  var scrollPosition;
  var scrollTop;
  var scrollLeft;
  // 繰り返しコンテナの枠が取得できなかった場合
  // Dojo レイアウトの有無で window、div の位置を取得する
  var dojoLayout = dojo.byId("dojolayout");
  if (dojoLayout) {
    // マルチペイン(Dojo レイアウト)の場合
    var container = dojo.byId('centerarea');
    scrollTop = container.scrollTop;
    scrollLeft = container.scrollLeft;
  } else {
    // シングルペインの場合
    scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
    scrollLeft = document.body.scrollLeft || document.documentElement.scrollLeft;
  }
  if (scrollTop !== undefined && scrollLeft !== undefined) {
    scrollPosition = {
      scrollTop: scrollTop,
      scrollLeft: scrollLeft
    };
  }
  return scrollPosition;
}

function setScrollPosition(id) {
  removeScrollPosition();
  var scrollTop = 0;
  var scrollLeft = 0;
  var scrollPosition;

  // isScrollToFieldbox 関数でスクロール位置をコンテナの見出しにするかどうか切り替える
  if (isScrollToFieldbox()) {
    scrollPosition = getFieldboxPosition(id);
  }
  // スクロール位置がウィンドウまたは、繰り返しコンテナの見出し位置が取得できなかった場合
  if (!isScrollToFieldbox() || !scrollPosition) {
    scrollPosition = getWindowPosition();
  }
  if (scrollPosition) {
    scrollTop = scrollPosition.scrollTop;
    scrollLeft = scrollPosition.scrollLeft;
  }
  // 垂直スクロール量
  setCookie("__jfc_cookie_scrollTop", scrollTop);
  // 水平スクロール量
  setCookie("__jfc_cookie_scrollLeft", scrollLeft);
  //スクロール先になるボタンのIDをクッキーにセットする
  require(["dojo/cookie"], function(cookie) {
    cookie("scrollAnchorId", changeContainerRemoveButtonId(id));
  });
}

function changeContainerRemoveButtonId(id) {
  // 押下されたボタンがコンテナの削除ボタンでない場合、id を返す
  if (!id || id.indexOf('btnRemove_') === -1) {
    return id;
  }
  // コンテナの1番目の削除ボタンでない場合、id を返す
  var results = id.match(/btnRemove_((.*\$005b)(\d)(\$005d))/);
  if (!results || results.length !== 5 || results[3] !== "0") {
    return id;
  }
  // コンテナの削除ボタンの数を確認する
  var removeButtons;
  var queryString = "input[name^='btnRemove_" + results[2] + "'][name$='" + results[4] + "']";
  require(['dojo/query'], function(query) {
    removeButtons = query(queryString);
  });
  if (removeButtons.length === 1) {
    // コンテナの項目がない場合、追加ボタンにフォーカスをあてる
    // 追加ボタンがない場合、画面の先頭の入力項目にフォーカスがあたる
    return 'btnAdd_' + results[1];
  } else {
    // コンテナの項目が存在する場合、1番目の削除ボタンにフォーカスをあてる
    return 'btnRemove_' + results[2] + '1' + results[4];
  }
}

function scrollPosition(callback) {
  require(["dijit/registry", "dojo/cookie", "dojo/dom"], function(registry, cookie, dom) {
    id = cookie("scrollAnchorId");
    if (!id) {
      if (callback) {
        callback();
      }
      return;
    }
    var scrollTop = getCookie("__jfc_cookie_scrollTop");
    var scrollLeft = getCookie("__jfc_cookie_scrollLeft");
    //クッキーからスクロール先のIDを削除
    removeScrollPosition();
    if (!scrollTop || scrollTop == null) {
      scrollTop = 0;
    }
    if (!scrollLeft || scrollLeft == null) {
      scrollLeft = 0;
    }
    // Dojo のレイアウトを使用しているか
    var dojoLayout = registry.byId("dojolayout");
    if (dojoLayout) {
      var container = dom.byId('centerarea');
      container.scrollTop = scrollTop;
      container.scrollLeft = scrollLeft;
    } else {
      window.scrollTo(scrollLeft, scrollTop);
    }
    obj = registry.byId(id);
    if (obj) {
      if (obj.type !== "button" && (obj.get("disabled") || obj.get("readOnly"))) {
        obj = null;
      }
    } else {
      obj = dom.byId(id);
      if (!obj || !obj.focus() || obj.disabled || obj.readOnly) {
        obj = null;
      }
    }
    if (obj) {
      setTimeout(function() {
        obj.focus();
      }, 30);
    } else {
      if (callback) {
        callback();
      }
    }
  });
}

function removeScrollPosition() {
  setCookie("__jfc_cookie_scrollTop",0,0);
  setCookie("__jfc_cookie_scrollLeft",0,0);
  require(["dojo/cookie"], function(cookie) {
    cookie("scrollAnchorId", "");
  });
}

// スクロール位置を繰り返しコンテナの見出しにするかどうか
// mycommon.js でこの関数をオーバーライドして動作を変更する
function isScrollToFieldbox() {
  return false;
}

function masterInputCheck(f) {
  var error_fields = "";

  for (var i=0; i<f.length; i++) {
    var e = f.elements[i];
    // item[-1]/content のように index が -1 のものはチェック対象外
    if (e.name.match(/^master_lp\$item\[([0-9]+)\]\$content$/g)) {
      if ((e.value == null) || (e.value == "")) {
        error_fields += "\n            " + res.ERROR_MSG_CODE + " " + RegExp.$1;
        continue;
      }
    }
  }
  if (error_fields.length > 0) {
    var msg = res.ERROR_MSG_HISSU_1 + "\n";
    msg += res.ERROR_MSG_HISSU_2 + "\n\n"
    msg += error_fields + "\n";
    showAlertDialog(msg);
    return false;
  }

  return true;
}

function focusFirstElement() {
  var d = window.document;
  if (d.URL.indexOf("#", 0) > 0) {
    removeScrollPosition();
    return;
  }
  scrollPosition(function() {
    var widgets = getAllWidgets(function(widget) {
      // ボタン、「ページにおける表示数の変更」リストボックスはフォーカス対象から除く
      if (widget.type !== "button" && widget.type !== "hidden" &&
          (widget.name && widget.name !== "__jfc_size_per_page0")) {
        return true;
      }
      return false;
    });
    // タブインデックスでソートする
    sortWidgetsByTabindex(widgets);
    for (var i=0,l=widgets.length; i<l; i++) {
      var widget = widgets[i];
      if ((widget.type === "text" || widget.type === "textarea"  || widget.type === "password" ||
           widget.type === "radio" || widget.type === "checkbox" || widget.declaredClass === "wagby.DateTimeTextBox") &&
          !(widget.get("disabled") || widget.get("readOnly") || widget.get("tabIndex") === "-1")) {
        widget.focus();
        break;
      }
    }
  });
}

function sortWidgetsByTabindex(widgets) {
  if (!widgets || widgets.length === 0) {
    return;
  }
  widgets.sort(function(a, b) {
    try {
      var aTabIndex = parseInt(a.tabIndex, 10);
      var bTabIndex = parseInt(b.tabIndex, 10);
      return aTabIndex - bTabIndex;
    } catch(e) {
    }
    return 0;
  });
}

/**
 * テキストフィールドなどに入力された文字列について、
 * パディングを行います。
 *
 * パディング文字は、文字列の左側につきます。
 *
 * event   イベント
 * padChar パディング文字
 * size    パディングの結果文字列の長さ
 */
function padding(widget, padChar, size) {
  if (!widget || !widget.get) {
    return;
  }
  if (!padChar || padChar === "" || !size || size <= 0) {
    return;
  }
  var value = widget.get("displayedValue");
  if (!value || value === "") {
    return;
  }
  var str = _zenkakuNum2hankaku(value);
  // パディング文字をつけます。
  while (str.length < size) {
    str = padChar + str;
  }
  // 余分についたパディング文字を取り除きます。
  while (str.length > size) {
    if (str.charAt(0) != padChar) {
      break;
    } else {
      str = str.substring(1);
    }
  }
  widget.set("value", str);
}

/**
 * テキストフィールドなどに入力された日付を
 * 規定のフォーマットに変換します。
 */
function normalizeDate(widget) {
  if (!widget) {
    return;
  }
  try {
    var formattedDateValue = formatDate(convText2Date(widget.get("displayedValue")));
    widget.set("value", formattedDateValue);
  } catch (e){
    // 変換に失敗した場合はそのままにしておく。
  }
}

/**
 * テキストフィールドなどに入力された日付を
 * 指定した日付のフォーマットに変換します。
 *
 * @param event
 * @param format
 */
function setDateWithFormat(widget, format) {
  if (!widget || widget.get("value") === "") {
    return;
  }
  var dateFormat = format || "yyyy-MM-dd";
  try {
    widget.set("value", _setDateWithFormat(widget.get("value"), dateFormat));
  } catch (excptn){
    // 変換に失敗した場合はそのままにしておく。
  }
}

function _setDateWithFormat(/* string */ value, /* string */ dateFormat) {
  if (!value || value === "") {
    return "";
  }
  var formattedValue = "";
  var datearray;
  datearray = createDateArray(value, false, dateFormat) ;
  if (datearray == null || datearray.length == 0 || datearray[0] == -1 ) {
    return formattedValue;
  }

  var dateJson;
  dateJson = convDateJSON(datearray);

  var dateText;
  dateText = formatYYYYMMddhhmmss(
    dateJson.year, dateJson.month, dateJson.day_of_month,
    dateJson.hour, dateJson.minute, dateJson.second);

  try {
    formattedValue = formatDateObject(convText2Date(dateText), dateFormat);
  } catch (excptn) {
  }
  return formattedValue;
}

/*
 * @return "YYYY-MM-dd hh:mm:ss"
 */
function formatYYYYMMddhhmmss(
     /* int */ year,
     /* int */ month,
     /* int */ day,
     /* int */ hour,
     /* int */ minute,
     /* int */ second) {

  var s = year;
  if (month == null) {
      // yyyy
      return s;
  }
  s = s + '-' + month;
  if (day == null) {
      // yyyy-MM
      return s;
  }
  s = s + '-' + day;
  if (hour == null) {
      // yyyy-MM-dd
      return s;
  }
  s = s + ' ' + hour;
  if (minute == null) {
      // yyyy-MM-dd hh
      return s;
  }
  s = s + ':' + minute;
  if (second == null) {
      // yyyy-MM-dd hh:mm
      return s;
  }
  // yyyy-MM-dd hh:mm:ss
  s = s + ':' + second;
  return s;

}

/*
 * @return "YYYY-MM-dd"
 */
function formatYYYYMMdd(
     /* int */ year,
     /* int */ month,
     /* int */ day) {

  var s = year;
  if (month == null) {
      // yyyy
      return s;
  }
  s = s + '-' + month;
  if (day == null) {
      // yyyy-MM
      return s;
  }
  s = s + '-' + day;
  return s;
}

function convDateJSON(/* Array of int*/ datearray) {

  var year = datearray[0];

  var month;
  if (datearray[1] != -1) {
      month = datearray[1];
  } else {
      month = 1;
  }

  var day_of_month;

  if (datearray[2] != -1) {
      day_of_month = datearray[2];
      var lastday = getLastDayOfThisMonth(year,month-1);
      if (lastday < day_of_month) {
          day_of_month = lastday;
      }
  } else {
      day_of_month = 1;
  }
  var hour = 0;
  if (datearray[3] != -1) {
    hour = datearray[3];
  }
  var minute = 0;
  if (datearray[4] != -1) {
    minute = datearray[4];
  }
  var second = 0;
  if (datearray[5] != -1) {
    second = datearray[5];
  }
  return {year:year,
      month:month,
      day_of_month:day_of_month,
      hour:hour,
      minute:minute,
      second:second};
}


/**
 * イベントが発生したHTMLの要素を返します。
 *
 */
function getEventSrc(event) {
  if (! event) {
    return null;
  }
  if (event.srcElement) {
    // IE 6, Opera 9
    return event.srcElement;
  } else
  if (event.target) {
    // FireFox 2
    return event.target;
  }
}

/**
 * Dateオブジェクトの情報から、フォーマットされた日付字列を作成します。
 */
function formatDate(date) {
  // 年月日を分ける文字
  sep = "-";

  s = "" + date.getFullYear() + sep;
  if (date.getMonth() < 10 - 1) {
    s = s + "0";
  }
    s = s + (date.getMonth() + 1) + sep;
  if (date.getDate() < 10) {
    s = s + "0";
  }
  s = s + date.getDate();
  return s;
}

/**
 * 文字列を年、月、日に分解して、Dateオブジェクトを返します。
 *
 * 返戻されるオブジェクトの属性year,month,dayがそれぞれ
 * 年、月、日にあたります。
 *
 * 不正な西暦の場合はExceptionをthrowします。
 */
function convText2Date(text) {
  if (!text || text === "" || text === "undefined-undefined-undefined" || text === "Invalid Date") {
    return;
  }
  if (text.length > 8) {
    var ret = new Date(text);
    if (!isNaN(ret)) {
      return ret;
    }
  }
  var before = text;

  // '-','/','年','月','日'をスペースに置換します。

  text = text.replace(/[年月日\/-]/g, " ");
  text = _zenkakuNum2hankaku(text);
  text = replaceWarekiNengouFullnameToShortchar(text);
  // 前後のスペースを取り除きます。
  text = text.replace(/^ +/, "");
  text = text.replace(/ +$/, "");

  // 1個以上のスペースを1つのスペースに置換します。
  text = text.replace(/ +/g, " ");

  // スペースで区切ってトークンを得る
  elems = text.split(" ");
  var date = new Date();
  var year = date.getFullYear();
  var month = date.getMonth() + 1 ;
  var day = date.getDate();
  var hour = 0;
  var minute = 0;
  var second = 0;

  switch (elems.length) {
    case 1:
      var dateText = elems[0];
      if (dateText.length === 8) {
        year = dateText.slice(0, 4);
        month = dateText.slice(4, 6);
        day = dateText.slice(6, 8);
      } else {
        year = _getYearFor3Token(dateText);
        month = 1;
        day = 1;
      }
      break;
    case 2:
      // 和暦年月の場合
      if ((new RegExp(warekiShortnameRegExpStr + "\\d{1,2}")).test(elems[0])) {
        year = _getYearFor3Token(elems[0]);
        month = parseInt(elems[1],10);
        day = 1;
      } else {
        month = parseInt(elems[0],10);
        day = parseInt(elems[1],10);
      }
      break;
    case 3:
      year = _getYearFor3Token(elems[0]);
      month = parseInt(elems[1],10);
      day = parseInt(elems[2],10);
      break;
    case 4:
      // 日付と時刻の場合、最後の配列要素にはコロンを含む文字列が入る
      if (elems[3].indexOf(":") > 0) {
        year = _getYearFor3Token(elems[0]);
        month = parseInt(elems[1],10);
        day = parseInt(elems[2],10);
        var dateTime = convText2Date_time(elems[3], new Date(year, month - 1, day));
        hour = dateTime.getHours();
        minute = dateTime.getMinutes();
        second = dateTime.getSeconds();
      } else {
        year = _getYearFor4Token(elems[0], elems[1]);
        month = parseInt(elems[2],10);
        day = parseInt(elems[3],10);
      }
      break;
    default:
      throw res.EXCEPTION_MSG_UNEXPECTED + before;
  }

  if (month < 1 || month > 12) {
      throw res.EXCEPTION_MSG_ILLEGAL_MONTH + month;
  }

  if (day < 1 || day > 31) {
      throw res.EXCEPTION_MSG_ILLEGAL_DATE + day;
  }

  ret = new Date(year, month - 1, day, hour, minute, second);
  if (month-1 != ret.getMonth() || day != ret.getDate()) {
      throw res.EXCEPTION_MSG_ILLEGAL_MONTH_OR_DATE + month+"-"+day;
  }
  return ret;
}

function convText2Date_time(text, date1) {
    if (!text || !date1) {
        return;
    }
    var rObj;

    rObj = new RegExp('([012]?[0-9])[:時]([0-5]?[0-9])[:分]([0-5]?[0-9])[秒]?');
    if (text.match(rObj)) {
        // HH:mm:ss
        return new Date(
            date1.getFullYear(), date1.getMonth(), date1.getDate(),
            RegExp.$1, RegExp.$2, RegExp.$3);
    }

    rObj = new RegExp('([012]?[0-9])[:時]([0-5]?[0-9])[分]?');
    if (text.match(rObj)) {
        // HH:mm
        return new Date(
            date1.getFullYear(), date1.getMonth(), date1.getDate(),
            RegExp.$1, RegExp.$2, 0);
    }

    rObj = new RegExp('([012][0-9])([0-5][0-9])([0-5][0-9])');
    if (text.match(rObj)) {
        // HHmmss
        return new Date(
            date1.getFullYear(), date1.getMonth(), date1.getDate(),
            RegExp.$1, RegExp.$2, RegExp.$3);
    }

    rObj = new RegExp('([012][0-9])([0-5][0-9])');
    if (text.match(rObj)) {
        // HHmm
        return new Date(
            date1.getFullYear(), date1.getMonth(), date1.getDate(),
            RegExp.$1, RegExp.$2, 0);
    }

    return date1;
}

/**
 * 全角数字を半角に変換します。
 */
function _zenkakuNum2hankaku(str) {
  var zNums = "０１２３４５６７８９";
  var ret = ""
  var i;
  for (i = 0; i < str.length;i++) {
    if (zNums.indexOf(str.charAt(i)) >= 0) {
      ret = ret + zNums.indexOf(str.charAt(i));
    } else {
      ret = ret + str.charAt(i);
    }
  }
  return ret;
}

/**
 * 3トークンの場合の西暦を取得します。
 *
 * <p> str 年を示します。</p>
 * 不正な西暦の場合はExceptionをthrowします。
 */
function _getYearFor3Token(str) {
    return _getYearArrayFor3Token(str)[0];
}

/**
 * 3トークンの場合の西暦を取得します。
 *
 * <p> str 年を示します。</p>
 * 不正な西暦の場合はExceptionをthrowします。
 */
function _getYearArrayFor3Token(str) {
  var i;
  var year;
  var lastMatch;
  for (i=0;i<wareki_date_a.length;i++) {
    var warekiletter = new RegExp("^["+wareki_shortcharpattern_a[i]+"]([0-9]+|元)([^0-9])");
    if (warekiletter.test(str)) {
        var ra = warekiletter.exec(str);
        var re = ra[0].substring(0, ra[0].length - ra[2].length);
        lastMatch = new Array(re, ra[1]);
    } else {
        warekiletter = new RegExp("^["+wareki_shortcharpattern_a[i]+"]\\s*([0-9]{1,2}|元)");
        if (warekiletter.test(str)) {
            //RegExp.$1がstr.match("^[Hh][0-9]+")の結果を記録する。
            lastMatch = warekiletter.exec(str);
        } else {
            continue;
        }
    }
    var warekiYear;
    if (RegExp.$1 === "元") {
      warekiYear = 1;
    } else {
      warekiYear = parseInt(RegExp.$1,10);
    }
    year = wareki_date_a[i].getFullYear() - 1 + warekiYear;

    return new Array(year, lastMatch);
  }
  var re4letter = new RegExp("(^[0-9]{4})");
  var re2letter = new RegExp("(^[0-9]{2})");
  if (re4letter.test(str)){
    lastMatch = re4letter.exec(str)
    year = parseInt(lastMatch);
  } else
  if (re2letter.test(str)){
    // 2桁入力
    var curr = new Date();
    // 現在から75年前を基準とする。
    var baseYear = curr.getFullYear() - 75 ;
    lastMatch = re2letter.exec(str);
    var input = parseInt(lastMatch,10);
    for (year = baseYear;year < baseYear + 100;year++) {
      if (year % 100 == input) {
        break;
      }
    }
  } else {
    throw res.EXCEPTION_MSG_CANTGET_YEAR + str;
  }
  return new Array(year, lastMatch);
}

/**
 * 4トークンの場合の西暦を取得します。
 *
 * <p> era 年号を示します。</p>
 * <p> str 年を示します。</p>
 */
function _getYearFor4Token(era, str) {
  var i;
  for (i=0;i<wareki_date_a.length;i++) {
    if (era.match("^["+wareki_shortcharpattern_a[i]+"]")) {
      return wareki_date_a[i].getFullYear() - 1 + parseInt(str,10);
    }
  }
  throw res.EXCEPTION_MSG_CANTGET_YEAR + era + str;
  return year;
}

/**
 * 指定された文字列内の長い和暦を短い和暦に置き換えます。
 */
function replaceWarekiNengouFullnameToShortchar(s) {
  var i;
  for (i=0;i<wareki_regexp_a.length;i++) {
    s = s.replace(wareki_regexp_a[i], wareki_shortcharpattern_a[i].charAt(0));
  }
  return s;
}

/**
 * 指定された和暦年号コードと西暦年から和暦の年を取得します。
 * 和暦年号コードが負の数の場合は、西暦の年を返します。
 */
function getWarekiYear(code,fullyear) {
  if (code < 0) {
    return fullyear;
  }
  return fullyear-(wareki_date_a[code].getFullYear()-1);
}
/**
 * 指定された日付から和暦年号コードを取得します。
 * 和暦に該当しない場合は、-1を返します。
 */
function getWarekiNengouCode(d) {
  if (d < wareki_date_start) {
    return -1;
  }
  var i;
  for (i=0;i<wareki_date_a.length-1;i++) {
    if (d >= wareki_date_a[i] && d < wareki_date_a[i+1]) {
      return i;
    }
  }
  i=wareki_date_a.length-1;
  if (d >= wareki_date_a[i]) {
    return i;
  }
  return -1;
}
/**
 * 指定された西暦年から和暦年号コードを取得します。
 * 和暦に該当しない場合は、-1を返します。
 */
function getWarekiNengouCodeByYear(fullyear) {
  if (fullyear < wareki_date_start.getFullYear()) {
    return -1;
  }
  var i;
  for (i=0;i<wareki_date_a.length-1;i++) {
    if (fullyear >= wareki_date_a[i].getFullYear() && fullyear < wareki_date_a[i+1].getFullYear()) {
      return i;
    }
  }
  i=wareki_date_a.length-1;
  if (fullyear >= wareki_date_a[i].getFullYear()) {
    return i;
  }
  return -1;
}

/*
 * 日付文字を日付オブジェクトに変換します。
 *
 * 不正な西暦の場合はExceptionをthrowします。
 */
function createDateObject(text, dateFormat) {
    var ret;
    var da = createDateArray(text, true, dateFormat);
    var year = da[0];
    var month = da[1]-1;
    if (month < 0) {
        month = 0;
    }
    var day = da[2];
    if (da[2] == -1) {
        day = 1;
    }
    if (da[3] == -1 && da[4] == -1 && da[5] == -1) {
        ret = new Date(year,month,day);
        if (month != ret.getMonth() || day != ret.getDate()) {
            throw res.EXCEPTION_MSG_ILLEGAL_MONTH_OR_DATE + month+"-"+day;
        }
        return ret;
    }

    var hour = da[3];
    if (da[2] == -1) {
        hour = 0;
    }
    var minutes = da[4];
    if (da[4] == -1) {
        minutes = 0;
    }
    var seconds = da[5];
    if (da[5] == -1) {
        seconds = 0;
    }

    ret = new Date(year,month,day,hour,minutes,seconds);
    if (month != ret.getMonth() || day != ret.getDate()) {
        throw res.EXCEPTION_MSG_ILLEGAL_MONTH_OR_DATE + month+"-"+day;
    }
    if (hour != ret.getHours() || minutes != ret.getMinutes() ||
        seconds != ret.getSeconds())
    {
        throw res.EXCEPTION_MSG_ILLEGAL_TIME_OR_MINUTE_OR_SECOND + hour+":"+minutes+":"+seconds
    }
    return ret;
}

/*
 * 日付文字を年月日を格納した配列に変換します。
 *
 * 不正な西暦や、strictがtrueで完全一致しない場合はExceptionをthrowします。
 *
 * 例：1999-1-1 -> { 1999, 1, 1 }
 * 例：1999     -> { 1999, -1, -1 }
 * 例：1999-aaa -> { 1999, -1, -1 } (strictがfalse)
 * 例：1999-aaa -> Exceptionがthrowされる (strictがtrue)
 *
 * @param text 評価する文字列
 * @param strict 完全一致による評価を行うかどうか
 * @return 年、月、日の数値を格納した配列。値が存在しない場合は -1 となる。
 */
function createDateArray(text, strict, dateFormat) {
    if (!text || text === "") {
      return [];
    }
    if (!(text instanceof Date) && dateFormat) {
      var dateArray = createDateArrayWithDateFormat(text, dateFormat);
      if (dateArray) {
        return dateArray;
      }
    }
    if (text instanceof Date) {
      var inputDate = new Date(text);
      if (!isNaN(inputDate)) {
        var dateArray = new Array(inputDate.getFullYear(), inputDate.getMonth() + 1, inputDate.getDate(), inputDate.getHours(), inputDate.getMinutes(), inputDate.getSeconds());
        return dateArray;
      }
    } else {
      // 前後のスペースを取り除きます。
      text = text.replace(/^\s+/, "");
      text = text.replace(/\s+$/, "");

      // 全角数値を半角数値に変換します。
      text = _zenkakuNum2hankaku(text);

      text = replaceWarekiNengouFullnameToShortchar(text);
    }

    var year;
    if (text.match("^([0-9]{1,2})[^0-9年nNyY]") || text.match("^([0-9]{1,2})$")) {
        var i = parseInt(RegExp.$1,10);
        if (i >= 1 && i <= 12) {
            // 年は今年とし、月の入力として扱う。
            var curr = new Date();
            year = curr.getFullYear();
            text = "-" + text;
        } else {
            var ar = _getYearArrayFor3Token(text);
            year = ar[0]
            text = text.substring(ar[1][0].length);
        }
    } else {
        var ar = _getYearArrayFor3Token(text);
        year = ar[0]
        text = text.substring(ar[1][0].length);
    }
    var month;
    var day;
    var hour = -1;
    var minute = -1;
    var second = -1;
    var ret;

    var sepy = "[^0-9]"; // [-\/年]
    var sepm = "[^0-9]"; // [-\/月]
    var sepd = "[^0-9]";
    var seph = "[^0-9]";
    var sepMin = "[^0-9]";
    var pattern_ymdhms1 = sepy+"([01]?[0-9])"+sepm+"([0-3]?[0-9])"+sepd+"([0-2]?[0-9])"+seph+"([0-5]?[0-9])"+sepMin+"([0-5]?[0-9])";
    var pattern_ymdhm1 = sepy+"([01]?[0-9])"+sepm+"([0-3]?[0-9])"+sepd+"([0-2]?[0-9])"+seph+"([0-5]?[0-9])";
    var pattern_ymdh1 = sepy+"([01]?[0-9])"+sepm+"([0-3]?[0-9])"+sepd+"([0-2]?[0-9])";
    var pattern_ymd1 = sepy+"([01]?[0-9])"+sepm+"([0-3]?[0-9])[日]?";
    var pattern_ym1 = sepy+"([01]?[0-9])"+sepm+"?";
    var pattern_ymdhms2 = "([01][0-9])([0-3][0-9])([0-2][0-9])([0-5][0-9])([0-5][0-9])";
    var pattern_ymdhm2 = "([01][0-9])([0-3][0-9])([0-2][0-9])([0-5][0-9])";
    var pattern_ymdh2 = "([01][0-9])([0-3][0-9])([0-2][0-9])";
    var pattern_ymd2 = "([01][0-9])([0-3][0-9])";
    var pattern_ym2 = "([01][0-9])";
    if (strict) {
        // 日付に完全一致するかを評価する
    	pattern_ymdhms1 = "^"+pattern_ymdhms1+"$";
    	pattern_ymdhm1 = "^"+pattern_ymdhm1+"$";
    	pattern_ymdh1 = "^"+pattern_ymdh1+"$";
    	pattern_ymd1 = "^"+pattern_ymd1+"$";
    	pattern_ym1 = "^"+pattern_ym1+"$";
    	pattern_ymdhms2 = "^"+pattern_ymdhms2+"$";
    	pattern_ymdhm2 = "^"+pattern_ymdhm2+"$";
    	pattern_ymdh2 = "^"+pattern_ymdh2+"$";
    	pattern_ymd2 = "^"+pattern_ymd2+"$";
    	pattern_ym2 = "^"+pattern_ym2+"$";
    }

    if (text == "") {
        month = -1;
        day = -1;
    } else if (text.match(pattern_ymdhms1)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
        hour = parseInt(RegExp.$3, 10);
        minute = parseInt(RegExp.$4, 10);
        second = parseInt(RegExp.$5, 10);
    } else if (text.match(pattern_ymdhm1)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
        hour = parseInt(RegExp.$3, 10);
        minute = parseInt(RegExp.$4, 10);
    } else if (text.match(pattern_ymdh1)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
        hour = parseInt(RegExp.$3, 10);
    } else if (text.match(pattern_ymd1)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
    } else if (text.match(pattern_ym1)) {
        month = parseInt(RegExp.$1,10);
        day = -1;
    } else if (text.match(pattern_ymdhms2)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
        hour = parseInt(RegExp.$3, 10);
        minute = parseInt(RegExp.$4, 10);
        second = parseInt(RegExp.$5, 10);
    } else if (text.match(pattern_ymdhm2)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
        hour = parseInt(RegExp.$3, 10);
        minute = parseInt(RegExp.$4, 10);
    } else if (text.match(pattern_ymdh2)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
        hour = parseInt(RegExp.$3, 10);
    } else if (text.match(pattern_ymd2)) {
        month = parseInt(RegExp.$1,10);
        day = parseInt(RegExp.$2, 10);
    } else if (text.match(pattern_ym2)) {
        month = parseInt(RegExp.$1,10);
        day = -1;
    } else if (strict) {
        // 日付に完全一致しない場合
        throw res.EXCEPTION_MSG_UNMATCHED + text;
    } else {
        month = -1;
        day = -1;
    }

    var ret = new Array(year, month, day, hour, minute, second);
    return ret;
}

/**
 * 日付フォーマットの正規表現オブジェクトを返す
 */
function getUserDefinedFormatRegExp(format) {
  var reStr = dateFormatRegExpStr[format];
  if (!reStr) {
    // ユーザ定義フォーマット
    return null;
  }
  return new RegExp(reStr);
}

/**
 * 短縮英語月名を数字に変換する
 * 数字の場合は、数値変換して返す
 */
function getMonthFromMonthMMMFormat(monthMMM) {
  for (var i=0; i<month_mmm_table.length; i++) {
    if (month_mmm_table[i] === monthMMM) {
      return (i + 1);
    }
  }
  var month = parseInt(monthMMM, 10);
  if (isNaN(month) || month < 1 || month > 12) {
    return -1;
  }
  return month;
}

/**
 * 日付フォーマットの情報を利用して日付文字を年月日を格納した配列に変換します。
 */
function createDateArrayWithDateFormat(text, format) {
  re = getUserDefinedFormatRegExp(format);
  if (!re) {
    return null;
  }
  // 年月日を正規表現で切り出す
  var splitDate = re.exec(text);
  // 日付フォーマットから年月日の情報を正規表現で切り出す
  var splitFormat = /(g{1,3}e|y{2,4}|M{1,3}|d{1,2})?[.年月/-]?(g{1,3}e|y{2,4}|M{1,3}|d{1,2})?[.年月/-]?(g{1,3}e|y{2,4}|M{1,3}|d{1,2})?(?:\s)?(H{1,2})?:?(m{1,2})?:?(s{1,2})?/.exec(format);
  if (!splitDate || !splitFormat || splitDate[0] === "" || splitFormat[0] === "") {
    return null;
  }
  var result = {
    year: -1,
    month: 1,
    day: 1,
    hour: -1,
    minute: -1,
    second: -1
  };

  for (var i=1; i<splitFormat.length; i++) {
    var formatPart = splitFormat[i];
    if (!formatPart) {
      continue;
    }
    if (formatPart.indexOf("e") !== -1) {
      // 和暦を西暦に変換する
      result.year = _getYearFor3Token(replaceWarekiNengouFullnameToShortchar(splitDate[i]));
    } else if (formatPart === "MMM") {
      // 短縮英語月名を数字に変換する
      result.month = getMonthFromMonthMMMFormat(splitDate[i]);
    } else if (i === 1 && formatPart === "yy") {
      // yy/MM/dd フォーマットの場合、2桁年の値から4桁年の値を取得する
      result.year = _getYearFor3Token(splitDate[i]);
    } else {
      var resultKey;
      if (formatPart.indexOf("y") !== -1) {
        resultKey = "year";
      } else if (formatPart.indexOf("M") !== -1) {
        resultKey = "month";
      } else if (formatPart.indexOf("d") !== -1) {
        resultKey = "day";
      } else if (formatPart.indexOf("H") !== -1) {
        resultKey = "hour";
      } else if (formatPart.indexOf("m") !== -1) {
        resultKey = "minute";
      } else if (formatPart.indexOf("s") !== -1) {
        resultKey = "second";
      }
      // 年月日時刻の場合、数値変換する
      if (resultKey) {
        var value;
        if (resultKey === "year") {
          // 年の値を2桁省略入力を許容するため、入力値から4桁年の値を取得する
          value = _getYearFor3Token([splitDate[i]]);
        } else {
          value = parseInt(splitDate[i], 10);
        }
        result[resultKey] = value;
      }
    }
  }
  return new Array(result.year, result.month, result.day, result.hour, result.minute, result.second);
}

/**
 * 指定された日付を書式を指定して文字列にします。
 * formatに指定できる書式の例：
 * ggge年m月d日aaa曜日 - 平成5年3月4日水曜日
 * gge-m-d             - 平5-3-4
 * ge-m-d              - H5-3-4
 *
 * Excelで指定できる書式記号のうち、※マークのないものをサポートしている。
 * 書式記号     表示結果
 * yy           00～99（西暦の年）
 * yyyy         1900～9999（西暦の年）
 * [DBNum1]yyyy 一九〇〇～九九九九（年）※
 * [DBNum2]yyyy 壱九〇〇～九九九九（年）※
 * [DBNum3]yyyy １９００～９９９９（年）※
 * e            1～99（和暦の年）
 * ee           01～99（和暦の年）
 * g            H（元号のアルファベット）
 * gg           平（元号の1文字目）
 * ggg          平成（元号）
 * [DBNum1]ggge 平成一～平成九十九（年）※
 * [DBNum2]ggge 平成壱～平成九拾九（年）※
 * [DBNum3]ggge 平成１～平成９９（年）※
 * r            01～（和暦の年） # eeと同じ？
 * rr           平成01～（元号つき和暦の年） # gggeeと同じ？
 * m            1～12（月の数字表記）
 * mm           01～12（月の数字表記）
 * mmm          Jan～Dec（月の短縮英語表記）※
 * mmmm         January～December（月の英語表記）※
 * mmmmm        J～D（月のアルファベット1文字目）※
 * d            1～31（日）
 * dd           01～31（日）
 * ddd          sun～sat（曜日の短縮英語表記）
 * dddd         Sunday～Satrday（曜日の英語表記）
 * aaa          日～土（曜日の日本語1文字表記）
 * aaaa         日曜日～土曜日（曜日の日本語表記）
 *
 * [wagby:reki_japanoldstyle]
 *              旧暦モードにする。
 *              和暦は元年の1月1日から開始される。
 *              使用するには、qreki.jsを読み込む必要がある。
 * [wagby:reki_default]
 *              通常の暦に戻す。
 * rokuyo       六曜。使用するには、qreki.jsを読み込む必要がある。
 */
function formatDateObject(d,format) {
    if (!d) {
      return "";
    }
    var dfullyear = d.getFullYear();
    var dmonth = d.getMonth();
    var ddate = d.getDate();
    var dhours = d.getHours();
    var dminutes = d.getMinutes();
    var dseconds = d.getSeconds();
    var default_warekicode = getWarekiNengouCode(d);
    var dwarekicode = default_warekicode;

    var japanoldstyle_date;
    if (format.indexOf("[wagby:reki_japanoldstyle]") >= 0) {
        japanoldstyle_date = new kyureki(d.getJD());
    }

    var ret = "";
    var i;
    for (i=0;i<format.length;) {
        if (format.indexOf("[wagby:reki_japanoldstyle]",i) == i) {
            dfullyear = japanoldstyle_date.year;
            dmonth = japanoldstyle_date.month-1;
            ddate = japanoldstyle_date.day;
            dwarekicode = getWarekiNengouCodeByYear(dfullyear);
            i += 26;
        } else if (format.indexOf("[wagby:reki_default]",i) == i) {
            dfullyear = d.getFullYear();
            dmonth = d.getMonth();
            ddate = d.getDate();
            dwarekicode = default_warekicode;
            i += 20;
        } else if (format.indexOf("yyyy",i) == i) {
            ret += dfullyear;
            i += 4;
        } else if (format.indexOf("yy",i) == i) {
            ret += get2ketastr(dfullyear);
            i += 2;
        } else if (format.indexOf("ggg",i) == i) {
            if (dwarekicode >= 0) {
                ret += wareki_fullname_a[dwarekicode];
            }
            i += 3;
        } else if (format.indexOf("gg",i) == i) {
            if (dwarekicode >= 0) {
                ret += wareki_fullname_a[dwarekicode].charAt(0);
            }
            i += 2;
        } else if (format.indexOf("g",i) == i) {
            if (dwarekicode >= 0) {
                ret += wareki_shortcharpattern_a[dwarekicode].charAt(0);
            }
            i++;
        } else if (format.indexOf("ee",i) == i) {
            ret += get2ketastr(getWarekiYear(dwarekicode,dfullyear));
            i+=2;
        } else if (format.indexOf("e",i) == i) {
            ret += getWarekiYear(dwarekicode,dfullyear);
            i++;
        } else if (format.indexOf("rokuyo",i) == i) {
            if (japanoldstyle_date == null) {
                japanoldstyle_date = new kyureki(d.getJD());
            }
            ret += japanoldstyle_date.rokuyo;
            i+=6;
        } else if (format.indexOf("rr",i) == i) {
            if (dwarekicode >= 0) {
                ret += wareki_fullname_a[dwarekicode];
            }
            ret += get2ketastr(getWarekiYear(dwarekicode,dfullyear));
            i+=2;
        } else if (format.indexOf("r",i) == i) {
            ret += get2ketastr(getWarekiYear(dwarekicode,dfullyear));
            i++;
        } else if (format.indexOf("MMM",i) == i) {
            if (browser_locale.lastIndexOf("en", 0) == 0) {
                ret += month_mmm_table[dmonth];
            } else {
                ret += (dmonth+1);
            }
            i+=3;
        } else if (format.indexOf("MM",i) == i) {
            ret += get2ketastr(dmonth+1);
            i+=2;
        } else if (format.indexOf("M",i) == i) {
            ret += (dmonth+1);
            i++;
        } else if (format.indexOf("dddd",i) == i) {
            ret += youbi_dddd_table[d.getDay()];
            i += 4;
        } else if (format.indexOf("ddd",i) == i) {
            ret += youbi_ddd_table[d.getDay()];
            i += 3;
        } else if (format.indexOf("dd",i) == i) {
            ret += get2ketastr(ddate);
            i += 2;
        } else if (format.indexOf("d",i) == i) {
            ret += ddate;
            i++;
        } else if (format.indexOf("aaaa",i) == i) {
            ret += youbi_aaa_table[d.getDay()] + res.FORMAT_DATE_YOUBI;
            i += 4;
        } else if (format.indexOf("aaa",i) == i) {
            ret += youbi_aaa_table[d.getDay()];
            i += 3;
        } else if (format.indexOf("HH",i) == i) {
            ret += get2ketastr(dhours);
            i += 2;
        } else if (format.indexOf("mm",i) == i) {
            ret += get2ketastr(dminutes);
            i += 2;
        } else if (format.indexOf("ss",i) == i) {
            ret += get2ketastr(dseconds);
            i += 2;
        } else {
            ret += format.substring(i,i+1);
            i++;
        }
    }
    return ret;
}

function get2ketastr(i) {
    var s = ""+i;
    if (s.length == 0) return "00";
    if (s.length == 1) return "0"+s;
    if (s.length == 2) return s;
    return s.substring(s.length-2);
}

/**
 * 入力可・不可の制御対象コントロールと条件を保持するクラス
 */
var TargetCtrl = function() {
  this.initialize.apply(this, arguments);
}
TargetCtrl.prototype = {
  //コンストラクタ
  initialize: function(ctrl, flag, values) {
	this.ctrl = ctrl;     //制御対象コントロール
    this.flag = flag;     //入力可・不可フラグ(enabel|disable)
    this.values = values; //条件値(複数指定可能とするため配列が引き渡される)
  },

  getCtrl: function() {
	return this.ctrl;
  },

  getFlag: function() {
	return this.flag;
  },

  getConditionValues: function() {
	return this.values;
  },

  //条件値によりコントロールの入力可・不可を切り替える
  changeDisabled: function(srcCtrlValues) {
    var disableFlag = true;

	//disable フラグの初期値を設定する
	//enable:条件が成立した時に入力可になるため、初期値は入力不可にする
	//disable:条件が成立した時に入力不可になるため、初期値は入力可にする
    if (this.getFlag() == "enabled") {
	  disableFlag = true;
    } else if (this.getFlag() == "disabled") {
	  disableFlag = false;
    }

    //入力可・不可の条件値
	var conditionValues = this.getConditionValues();

    //条件が成立した時には disable フラグを反転させる
    //enable:入力不可→入力可
    //disable:入力可→入力不可
    EXIT:
    for (var i=0,l=conditionValues.length; i<l; i++) {
      for (var j=0,m=srcCtrlValues.length; j<m; j++) {
        //条件の値が空文字の場合
        if (conditionValues[i].length == 0) {
          //制御元に入力があれば条件成立
          if (srcCtrlValues[j].length != 0) {
            disableFlag = !disableFlag;
            break EXIT;
		  } else {
			//条件不成立の場合には次の条件値を調べる
			continue;
          }
        }
        //条件の値が空文字以外の場合
        if (conditionValues[i] == srcCtrlValues[j]) {
          disableFlag = !disableFlag;
          break EXIT;
        }
      }
    }
    //制御対象のコントロールの disabled プロパティをセットする
    var ctrls = this.getCtrl();
    for (var i=0,l=ctrls.length; i<l; i++) {
      // BR4946 2009.09.25
      // ストアモデル参照(検索画面)のボタンの入力可・不可制御対応
      // BR5377 2010.03.24
      // ファイル名項目のクリアボタン(submit)対応
      if (ctrls[i].type == 'button' || ctrls[i].type == 'submit') {
          // 対象コントロールがボタンの場合、Dojo の dijit ライブラリで制御を行なう
          // BR5696 2010.10.07
          // Dojo 1.5.0 から dijit.form.Button の button タグがid 属性のない
          // input タグへ変更になったため、代わりに name 属性から取得するよう
          // に修正しました
          // また、setDisabled メソッドが廃止になったため、set(name, value)
          // メソッドへ変更しました
          dijit.byId(ctrls[i].name).set('disabled', disableFlag);
      } else if (ctrls[i].nodeName.toUpperCase() == "DIV") {
          // use rich text, dijit.Editor
          var dijitEditor = dijit.byId(ctrls[i].id);
          if (dijitEditor) {
            dijitEditor.set('disabled', disableFlag);
          }
      } else {
          // 数値型の入力項目が hidden となっているため、id で取得できない場合は
          // name でも取得してみる
          var widget = dijit.registry.byId(ctrls[i].id) || dijit.registry.byId(ctrls[i].name);
          if (widget) {
            widget.set("disabled", disableFlag);
          } else {
            ctrls[i].disabled = disableFlag;
          }
      }
    }
  }
};
/**
 * コントロールの入力可・不可を制御するクラス
 */
var CtrlDisableManager = function() {
  this.initialize.apply(this, arguments);
}
//コントロールの入力可・不可を制御するクラスの関数プロトタイプ宣言
CtrlDisableManager.prototype = {
  //コンストラクタ
  initialize: function(srcCtrlName) {
    //制御元コントロールを保持する配列
    this.srcCtrls = new Array();
    //制御元コントロールの名称を取得する
    var ctrlsName = this.getCtrlsName(srcCtrlName);
    //取得した制御元コントロールをインスタンス変数へ追加する
    for (var i=0,l=ctrlsName.length; i<l; i++) {
      var srcCtrl = document.getElementsByName(ctrlsName[i]);
      for (var j=0,m=srcCtrl.length; j<m; j++) {
        this.srcCtrls.push(srcCtrl[j]);
      }
    }
    //制御対象コントロールを保持する配列
    this.targetCtrls = new Array();
  },

  //制御対象コントロールを追加するメソッド
  addTargetCtrl: function(targetCtrlName, flag, value) {
    //制御対象コントロールの名称を取得する
    var targetCtrlsName = this.getCtrlsName(targetCtrlName);
    //制御対象コントロールを追加する
    for (var i=0,l=targetCtrlsName.length; i<l; i++) {
      var targetCtrl = document.getElementsByName(targetCtrlsName[i]);
      if (targetCtrl != null && targetCtrl.length > 0) {
        this.targetCtrls.push(new TargetCtrl(targetCtrl, flag, value));
      }
      var targetCtrl_editor = document.getElementById(targetCtrlsName[i]+"_editor");
      if (targetCtrl_editor != null) {
        var a = new Array(1);
        a[0] = targetCtrl_editor;
        this.targetCtrls.push(new TargetCtrl(a, flag, value));
      }
      var suggest = dojo.byId("_" + targetCtrlsName[i] + "_content_displayed");
      if (suggest) {
        this.targetCtrls.push(new TargetCtrl(new Array(suggest), flag, value));
      }
      var subwindowTextbox = dojo.byId("_" + targetCtrlsName[i] + "_content");
      if (subwindowTextbox) {
        this.targetCtrls.push(new TargetCtrl(new Array(subwindowTextbox), flag, value));
      }
    }
  },

  //制御元コントロールで選択された値を取得する
  getSrcCtrlValues: function() {
	//制御元コントロールで選択された値を保持する配列
	var srcCtrlValues = new Array();
    for (var i=0,l=this.srcCtrls.length; i<l; i++) {
      var ctrl = this.srcCtrls[i];
      var ctrlType = ctrl.type;
      var value = ctrl.value;
      //選択された値を配列へ追加する
      if ((ctrlType == 'text') || (ctrlType == 'textarea') || (ctrlType == 'file') ||
		  (ctrlType == 'select-one') || (ctrlType == 'hidden')) {
        srcCtrlValues.push(value);
      } else if ((ctrlType == 'radio') || (ctrlType == 'checkbox')) {
        require(["dijit/registry"], function(registry) {
          var widget = registry.byId(ctrl.id);
          if (widget && widget.get('checked')) {
            srcCtrlValues.push(value);
          }
        });
	  }
    }
    return srcCtrlValues;
  },

  //制御対象コントロールの disabled 属性を変更するメソッド
  //条件に一致する
  changeTargetCtrlDisabled: function() {
    //制御対象コントロールで選択された値を取得する
	var srcCtrlValues = this.getSrcCtrlValues();
	//制御対象のコントロール全ての条件をチェックする
    for (var i=0,l=this.targetCtrls.length; i<l; i++) {
      var targetCtrl = this.targetCtrls[i];
	  targetCtrl.changeDisabled(srcCtrlValues);
	}
  },

  //引数のコントロール名が存在するフォームのインデックス値を返すメソッド
  getFormIndexContainsByName: function(ctrlName) {
    var formIndex = 0;

    //フォームが 1 つだけの場合 0 を返して終了
    if (document.forms.length == 1) {
      return 0;
    }

    EXIT:
    for (var i=0,l=document.forms.length; i<l; i++) {
      var elements = document.forms[i].elements;
      for (var j=0,m=elements.length; j<m; j++) {
        if (!elements[j].name) {
          continue;
        }
        var matchedCtrlName = (elements[j].name).match(ctrlName);
        if (matchedCtrlName != null) {
          formIndex = i;
          break EXIT;
        }
      }
    }
    return formIndex;
  },

  //引数で指定したコントロールの名称を返す
  //正規表現型で指定された場合のため、正規表現にマッチするコントロールの名称を配列に入れて返す
  //文字列型で指定された場合、そのまま名称を配列に入れて返す
  getCtrlsName: function(ctrlName) {
    if (Array.isArray(ctrlName)) {
      return ctrlName;
    }
    var ctrlsName = new Array();

    if (typeof(ctrlName) == 'string') {
      ctrlsName[0] = ctrlName;
    } else if (ctrlName instanceof RegExp) {
      //引数のタイプが正規表現の場合、フォーム内の全コントロールの name 属性を
      //正規表現で検索を行ないマッチしたコントロールの name を配列へ保持する
      var formIndex = this.getFormIndexContainsByName(ctrlName);
      var ctrls = document.forms[formIndex].elements;

      for (var i=0,l=ctrls.length; i<l; i++) {
        var matchedCtrlName = (ctrls[i].name).match(ctrlName);
        if (matchedCtrlName != null) {
          ctrlsName.push(matchedCtrlName);
        }
      }
    }
    return ctrlsName;
  },

  //制御元コントロールにイベントを登録する
  addEvent: function(me) {
    var that = this;
    var eventSetClearButton;
    for (var i=0,l=this.srcCtrls.length; i<l; i++) {
      var fireEvent;
      var id = this.srcCtrls[i].id || this.srcCtrls[i].name;
      // Dojo の Widget を取得する
      var ctrl = dijit.registry.byId(id);
      if (!ctrl) {
        continue;
      }
      if (ctrl.declaredClass === "dijit.form.CheckBox" || ctrl.declaredClass === "dijit.form.RadioButton") {
        // チェックボックス、ラジオボタンの場合
        var clearButtonId = this.srcCtrls[i].name;
        var count = 0;
        if (ctrl.declaredClass === "dijit.form.RadioButton") {
          // 繰り返しコンテナ内のクリアボタンのIDはチェックボックスと同様項目IDのみとなるため、
          // 2番目の$005b以降の文字列を削除する
          count = (clearButtonId.match(/\$005b/g) || []).length;
        }
        if (ctrl.declaredClass === "dijit.form.CheckBox" || count === 2) {
          clearButtonId = this.srcCtrls[i].name.substring(0, this.srcCtrls[i].name.lastIndexOf("$005b"));
        }
        var clearButton = this.getClearButton(clearButtonId);
        if (eventSetClearButton !== clearButton && clearButton && clearButton.iconClass === "clearButtonIcon") {
          clearButton.on("click", function() {
            that.changeTargetCtrlDisabled();
          });
          eventSetClearButton = clearButton;
        }
        fireEvent = "click";
      } else if (ctrl.declaredClass === "dijit.form.Select" || ctrl.type === "file") {
        // リストボックス、ファイル型の場合
        fireEvent = "change";
      } else if (ctrl.declaredClass === "dijit.form.ValidationTextBox" || ctrl.declaredClass === "dijit.form.NumberTextBox" ||
          ctrl.baseClass === "dijitTextBox dijitTextArea") {
        // テキストボックス、数値入力テキストボックス、テキストエリアの場合
        fireEvent = "keyup";
        ctrl.on("blur", function() {
          that.changeTargetCtrlDisabled();
        });
      } else {
        fireEvent = "change";
      }
      ctrl.on(fireEvent, function() {
        that.changeTargetCtrlDisabled();
      });
    }
  },

  getClearButton: function(id) {
    var clearButton;
    require(["dijit/registry"], function(registry) {
      clearButton = registry.byId("btnClear_" + id);
    });
    return clearButton;
  }
};

function getElementValueByName(f, name) {
  var e = f.elements[name];
  if (e == null) {
      // checkbox ? ...
      return getElementValueByName_checkbox(f, name);
  }
  var element = e[0];
  if (element == null) {
      element = e;
  }
  if (element.type == 'radio') {
      for (var j=0,m=e.length; j<m; j++) {
        if (e[j].checked) {
          return e[j].value;
        }
      }
  } else if (element.type == 'checkbox') {
      // ignore case
  } else if (element.type == 'select-one') {
      // case of dualinput
      if (e[1] != null && e[1].value !=null && e[1].value != '') {
          return e[1].value;
      } else if (e[0].value != null && e[0].value != '') {
          return e[0].value;
      } else {
          return null;
      }
  } else {
    // Dojo のウィジェットから値を取得する
    var value;
    require(["dijit/registry"], function(registry) {
      var widget = registry.byId(name);
      if (widget) {
        if (widget.baseClass.indexOf("DateTextBox") !== -1 ||
            widget.baseClass.indexOf("dijitComboBox") !== -1) {
          value = widget.get("displayedValue");
        } else {
          value = widget.get("value");
        }
      }
    });
    if (value) {
      return value;
    }
    if (e.value != null && e.value != '') {
      return e.value;
    } else {
      return null;
    }
  }
  return null;
}

function getElementValueByName_checkbox(f, name) {
  var values = new Array();
  name += "$005b";
  for (var j=0,m=f.length; j<m; j++) {
    var e = f.elements[j];
    if (e.name.indexOf(name) == 0) {
      if ((e.type == "checkbox" && e.checked == true) || e.type == "hidden") {
        values.push(e.value);
      }
    }
  }
  return values;
}

function createActionParam(name, values) {
  if (values instanceof Array) {
      if (values[0] != null && values[0] != '') {
          return "&" + name + "=" + encodeURIComponent(values[0]);
      }
  } else {
      if (values != null && values != '') {
          return "&" + name + "=" + encodeURIComponent(values);
      }
  }
  return "";
}

function createActionParam_checkbox(name, values) {
  var actionParam = "";
  if (values instanceof Array) {
    for (var j=0,m=values.length; j<m; j++) {
      if (values[j] != null && values[j] != '') {
        actionParam += "&" + name + "$005b" + values[j] + "$005d$002f$0040id="+values[j];
      }
    }
    return actionParam;
  }

  return "&" + name + "$005b" + values + "$005d$002f$0040id="+values;
}

// 指定した年月の最後の日を返します。
function getLastDayOfThisMonth(year, month) {
    var d = new Date(year, month+1, 1);
    d.setSeconds(-1);
    return d.getDate();
}

function changeSizePerPageComboOff() {
  var d = window.document;
  var length = d.forms.length;

  for (var i=0,l=length; i<l; i++) {
    var f = d.forms[i];
    for (var j=0,m=f.length; j<m; j++) {
      var e = f.elements[j];
      if ((e.type == "submit" || e.type == "button") && e.name != "__jfc_changeSizePerPage") {
        e.disabled = true;
      } else if (e.name == "__jfc_size_per_page0") {
	f.__jfc_size_per_page.value = e.options[e.selectedIndex].value;
        e.disabled = true;
      }
    }
  }
}

function isIE() {
  if (navigator.userAgent.indexOf("MSIE") == -1) {
    return false;
  }
  return true;
}
function getIEVersion() {
  navigator.appVersion.match(/MSIE (\d\.\d)/);
  return parseFloat(RegExp.$1);
}
function getShimedElement(id) {
    var ifrmhtml = "<iframe src='javascript:false;' " +
                   "scrolling='no' frameborder='0'" +
                   "style='position:absolute; top:0px;" +
                   "left:0px; z-index: -1; filter:Alpha(Opacity=\"0\");'></iframe>";
    ifrm = document.createElement(ifrmhtml);
    ifrm.tabIndex = -1;
	var width = document.getElementById(id).offsetWidth - 1;
    ifrm.style.setExpression("width", width);
    ifrm.style.setExpression("height", "document.getElementById(id).offsetHeight");
	return ifrm;
}
function setShim2Element(id) {
	element = document.getElementById(id);
	element.appendChild(getShimedElement(id));
}
//カレンダーポップアップの DIV 要素に iframe を追加する
//
//IE 7 以前のバージョンでリストボックスがカレンダーポップアッ
//プ画面を透過して表示されるバグを回避するため
function setShim2Calendar() {
  var calendar = document.getElementById("calendar");
  if (!calendar) {
    return;
  }
  if (!isIE()) {
    return;
  }
  if (getIEVersion() < 7) {
    var ifrmhtml="<iframe src='javascript:false;' "+
          "scrolling='no' frameborder='0'"+
          "style='position:absolute; top:0px;"+
          "left:0px; z-index: -1; filter:Alpha(Opacity=\"0\");'></iframe>";
    ifrm = document.createElement(ifrmhtml);
    ifrm.tabIndex = -1;
    ifrm.style.setExpression("width", "document.getElementById('calendar').offsetWidth");
    ifrm.style.setExpression("height", "document.getElementById('calendar').offsetHeight");
    calendar.appendChild(ifrm);
  }
}

//Dojo dijit.layout.TabContainer 用の関数
//選択されたタブをクッキーに保存する
function setSelectedTabId(key, tabId) {
  if (tabId) {
    require(["dojo/cookie"], function(cookie) {
      cookie(key, tabId);
    });
  }
  //選択されていたサブメニューを表示する
  showSubMenu(getVisibleMenuId(), getInvisibleMenuId());
}
//クッキーから選択されたタブを取得する
function getSelectedTabId(key) {
  var selectedTabId;
  require(["dojo/cookie"], function(cookie) {
    selectedTabId = cookie(key);
  });
  return selectedTabId;
}

//メニューリンクをクリックした際に、選択していたサブメニューを
//再表示するため、選択されたサブメニュー、非表示にするメニュー
//のMenuId をクッキーに保存しておく
function setSubMenuId(visibleMenuId, invisibleMenuId) {
  require(["dojo/cookie"], function(cookie) {
    cookie("visibleMenu", visibleMenuId);
    cookie("invisibleMenu", invisibleMenuId);
  });
}
function getVisibleMenuId() {
  var visibleMenuId;
  require(["dojo/cookie"], function(cookie) {
    visibleMenuId = cookie("visibleMenu");
  });
  return visibleMenuId;
}
function getInvisibleMenuId() {
  var invisibleMenuId;
  require(["dojo/cookie"], function(cookie) {
    invisibleMenuId = cookie("invisibleMenu");
  });
  return invisibleMenuId;
}
function removeSubMenuCookies() {
  require(["dojo/cookie"], function(cookie) {
    cookie('visibleMenu', null, {expires: -1});
    cookie('invisibleMenu', null, {expires: -1});
  });
}
function showSubMenu(visibleMenuId, hiddenMenuId) {
  require(["dojo/dom", "dojo/dom-style", "dojo/query"], function(dom, domStyle, query) {
    var hiddenMenu = dom.byId(hiddenMenuId);
    var visibleMenu = dom.byId(visibleMenuId);
    if (!hiddenMenu || !visibleMenu) {
      return;
    }
    setSubMenuId(visibleMenuId, hiddenMenuId);
    var isContainHiddenMenu = false;
    var selectedTabId = getSelectedTabId("mainMenuSelectedTab") || "menuTab1";
    var submenus = query("div[id='" + selectedTabId + "'] nav[id^='menuId']");
    for (var i=0,l=submenus.length; i<l; i++) {
      if (submenus[i].id === hiddenMenuId) {
        isContainHiddenMenu = true;
        break;
      }
    }
    // 選択されたタブ内に非表示にするサブメニューがない場合は何もしない
    if (!isContainHiddenMenu) {
      return;
    }
    // 選択されたメニュータブ内のサブメニューを一旦全て非表示にする
    for (var i=0,l=submenus.length; i<l; i++) {
      domStyle.set(submenus[i], "display", "none");
    }
    // 表示するサブメニューのみ、display 属性の none を外す
    domStyle.set(visibleMenu, "display", "flex");
  });
}
//OnLoad 時にタブが選択された状態にする
function selectTabOnLoad(tabContainerId, key, defaultTab) {
  require(["dijit/registry", "dojo/ready"], function(registry, ready) {
    ready(function() {
      var tabContainer = registry.byId(tabContainerId);
      if (!tabContainer) {
        return;
      }
      var id = getSelectedTabId(key);
      if (!id) {
        if (defaultTab && registry.byId(defaultTab)) {
          // デフォルトのタブが選択可能な場合、デフォルトタブを選択状態にする
          id = defaultTab;
        } else {
          // id が取得できずデフォルトタブの指定も無い場合、1番目のタブを選択状態にする
          var firstTab = tabContainer.getChildren()[0];
          if (firstTab) {
            id = firstTab.id;
          }
        }
      }
      var selectedTab = registry.byId(id);
      if (id && selectedTab) {
        //サブメニューの MenuId を取得する
        var visibleMenuId = getVisibleMenuId();
        var invisibleMenuId = getInvisibleMenuId();
        if (visibleMenuId && invisibleMenuId) {
          //選択されていたサブメニューを表示する
          showSubMenu(visibleMenuId, invisibleMenuId);
        }
        tabContainer.selectChild(id);
      }
    });
  });
}
//TabContainer 用のクッキーを削除する
function removeTabCookies() {
  require(["dojo/cookie"], function(cookie) {
    cookie('mainMenuSelectedTab', null, {expires: -1});
    cookie('calendarConditionTabContainer', null, {expires: -1});
  });
  removeSubMenuCookies();
}

//ナビゲーションバーのボタン用
function submitNavigationCommand(form, action, name, target) {
  if (action) {
    document.forms[form].action = action;
  }
  if (name) {
    document.forms[form].SENDACTION.name = name;
  }
  if (target && target !== 'null') {
    document.forms[form].target = target;
    document.forms[form].submit();
    document.forms[form].elements[name].name = "SENDACTION";
  } else {
    document.forms[form].target = '_self';
    buttonOff();
    document.forms[form].submit();
  }
}

//ナビゲーションバーのボタン用
function submitNavigationCommand_skipButtonOff(form, action, name, target) {
  if (action) {
    document.forms[form].action = action;
  }
  if (name) {
    document.forms[form].SENDACTION.name = name;
  }
  if (target && target !== 'null') {
    document.forms[form].target = target;
    document.forms[form].submit();
    document.forms[form].elements[name].name = "SENDACTION";
  } else {
    document.forms[form].target = '_self';
    document.forms[form].submit();
  }
}

//一覧表示画面における一括処理チェックボックスの一斉ON/OFF処理
function toggleJshCheckBox(form, checkedValue) {
  require(["dijit/registry"], function(registry) {
    for (var i=0,l=form.length; i<l; i++) {
      var e = form.elements[i];
      if (e.type !== 'checkbox' && e.name.indexOf('_jsh_cb') === -1) {
        continue;
      }
      var widget = registry.byId(e.id);
      if (widget) {
        widget.set("checked", checkedValue);
      } else {
        e.checked = checkedValue;
      }
    }
  });
}

//一覧表示画面における一括処理チェックボックスの数
function countJshCheckBox(form) {
  var count = 0;
  require(["dijit/registry"], function(registry) {
    for (var i=0,l=form.length; i<l; i++) {
      var e = form.elements[i];
      if (e.type !== 'checkbox' && e.name.indexOf('_jsh_cb') === -1) {
        continue;
      }
      if (e.checked) {
        count++;
      }
    }
  });
  return count;
}

function getWidgetsInTabContainer(tabContainer) {
  var widgetsInTabContainer = [];
  // 初期表示されているタブ内の widget を優先するため、非表示のタブ内の
  // widget を保持する配列
  var widgetsInUnselectedTab = [];
  var tabs = tabContainer.getChildren();
  for (var i=0,l=tabs.length; i<l; i++) {
    var widgets = tabs[i].getChildren();
    if (tabs[i].get("selected")) {
      for (var j=0,m=widgets.length; j<m; j++) {
        if (widgets[j].declaredClass === "dijit.layout.TabContainer") {
          Array.prototype.push.apply(widgetsInTabContainer, getWidgetsInTabContainer(widgets[j]));
        } else {
          widgetsInTabContainer.push(widgets[j]);
        }
      }
    } else if (!tabs[i].get("selected") && !this.ignoreWidgetsInUnselectedTab) {
      for (var j=0,m=widgets.length; j<m; j++) {
        if (widgets[j].declaredClass === "dijit.layout.TabContainer") {
          Array.prototype.push.apply(widgetsInTabContainer, getWidgetsInTabContainer(widgets[j]));
        } else {
          widgetsInUnselectedTab.push(widgets[j]);
        }
      }
    }
  }
  // 非表示のタブ内の widget を追加する
  Array.prototype.push.apply(widgetsInTabContainer, widgetsInUnselectedTab);
  return widgetsInTabContainer;
}

function getAllWidgets(filterFunc) {
  var allWidgets = [];
  require(["dijit/registry", "dojo/_base/array", "dojo/dom"], function(registry, array, dom) {
    for (var i=0,l=document.forms.length; i<l; i++) {
      var widgets;
      var id = document.forms[i].id;
      if (id) {
        widgets = registry.findWidgets(dom.byId(id));
      }
      if (!widgets || widgets.length === 0) {
        continue;
      }
      for (var j=0,m=widgets.length; j<m; j++) {
        // widget がタブコンテナの場合は、タブ内部の widget を取得する
        if (widgets[j].declaredClass === "dijit.layout.TabContainer" ||
            widgets[j].declaredClass === "dojox.mobile.RoundRect") {
          Array.prototype.push.apply(allWidgets, getWidgetsInTabContainer(widgets[j]));
        } else if (widgets[j].declaredClass === "wagby.TitlePane") {
          Array.prototype.push.apply(allWidgets, widgets[j].getChildren());
        } else {
          allWidgets.push(widgets[j]);
        }
      }
    }
    if (filterFunc) {
      allWidgets = array.filter(allWidgets, filterFunc);
    }
  });
  return allWidgets;
}

/**
 * Enterキーの取り扱いを制御するクラス
 */
var EnterKeyHandler = function() {
  this.initialize.apply(this, arguments);
}
EnterKeyHandler.prototype = {
  //コンストラクタ
  initialize: function(args) {
    // フォーカス移動対象の要素を保持する連想配列
    // key：name 属性値
    // value：フォーカス対象となる要素
    this.targetElements = new Array();
    // フォーカス対象となる要素の数
    this.targetElementsLength = 0;
    // Enterキーを無視する要素名を保持する配列
    this.ignoreElementNames = new Array();
    // Enterキーを無視する要素名をセットする
    this.setIgnoreElements(args);
    // 選択されていないタブ内の入力欄にはフォーカス移動しないフラグ
    // デフォルトでは選択されていないタブ内の入力欄にフォーカス移動する
    this.ignoreWidgetsInUnselectedTab = false;
    if (args && args.ignoreWidgetsInUnselectedTab !== undefined) {
      this.ignoreWidgetsInUnselectedTab = args.ignoreWidgetsInUnselectedTab;
    }
    var that = this;
    // 隠し項目、読み取り専用、無視する要素名として
    // 設定された項目は追加しない
    var targetWidgets = getAllWidgets(function(widget) {
      if (widget.id && widget.id !== "" &&
          widget.name && widget.name !== "" &&
          widget.type !== "hidden" && !widget.get("readOnly") &&
          !that.isIgnoreElement(widget.name)) {
        return true;
      } else {
        return false;
      }
    });
    sortWidgetsByTabindex(targetWidgets);
    var firstElement;
    var previousElementName;
    for (var i=0,l=targetWidgets.length; i<l; i++) {
      this.targetElementsLength++;
      if (!firstElement) {
        // フォーカス対象の最初の要素を保持する
        firstElement = targetWidgets[i];
        previousElementName =  targetWidgets[i].id || targetWidgets[i].name;
        continue;
      }
      this.targetElements[previousElementName] = targetWidgets[i];
      previousElementName = targetWidgets[i].id || targetWidgets[i].name;
    }
    // 最後の要素の次のフォーカス対象は先頭要素
    this.targetElements[previousElementName] = firstElement;
  },

  // フォーカス対象となる要素を取得する
  getNextElement: function(focusedElement, callCount) {
    var id = focusedElement.id || focusedElement.name;
    callCount = callCount || 0; // デフォルト値をセット
    var nextElement = this.targetElements[id];
    if (!nextElement) {
      return null;
    }
    if (nextElement.type === 'radio') {
      nextElement = this.getNextElementOfRadio(focusedElement, nextElement);
    }
    var tabIndex;
    require(["dojo/dom-attr"], function(domAttr) {
      tabIndex = domAttr.get(nextElement, "tabIndex");
    });
    // 入力不可、読み取り専用、tabIndex が -1、タブ内で利用不可(タブが非表示、disable)の場合、
    // さらに次の要素を取得する
    if (nextElement.disabled || nextElement.readOnly || tabIndex === "-1" ||
        !this.isWidgetAvailable(nextElement)) {
      if (callCount > this.targetElementsLength) {
        // 呼び出し回数がフォーカス対象項目数を超えた場合は終了させる
        return null;
      }
      return this.getNextElement(nextElement, callCount++);
    }
    return nextElement;
  },

  getNextElementOfRadio: function(focusedElement, element) {
    var nextElement = element;
    if (focusedElement.type === 'radio') {
      // ラジオボタンでEnterキーを押下した場合は、ラジオボタン項目の
      // 次の項目を返す
      do {
        nextElement = this.targetElements[nextElement.id];
      } while(focusedElement.name === nextElement.name && nextElement.type === 'radio');
      if (nextElement.type !== 'radio') {
        return nextElement;
      } else {
        // 次の項目もラジオボタンだった場合、チェック対象項目を入れ替える
        element = nextElement;
      }
    }
    // チェック済みのラジオボタンにフォーカスをセットする
    // チェック無しの場合、先頭のラジオボタンを返す
    if (nextElement.get('checked')) {
      return nextElement;
    }
    var focusedRadio = nextElement;
    do {
      focusedRadio = this.targetElements[focusedRadio.id];
    } while(element.name === focusedRadio.name && !focusedRadio.get('checked'));
    if (focusedRadio.get('checked')) {
      return focusedRadio;
    }
    return nextElement;
  },

  isWidgetAvailable: function(nextElement) {
    var widget;
    require(["dijit/registry"], function(registry) {
      widget = registry.byId(nextElement.id);
    });
    if (!widget) {
      return false;
    }
    // タブを取得する
    var tab = widget.getParent();
    if (!tab || tab.declaredClass === undefined || tab.declaredClass !== "dijit.layout.ContentPane") {
      return true;
    }
    // タブが非活性の場合
    if (tab.get("disabled")) {
      return false;
    }
    // タブコンテナが取得できないか、タブコンテナの子としてタブが存在していない場合
    var tabContainer = tab.getParent();
    if (!tabContainer || tabContainer.getIndexOfChild(tab) === -1) {
      return false;
    }
    return true;
  },

  // 引数の次の要素にフォーカスをセットする
  focusNextElement: function(element, event) {
    // Enter キー、Tab キー以外、Shift + Tab キーの入力では何もしない
    if (!event.keyCode || !(event.keyCode == 0x0d || event.keyCode == 0x09) || event.keyCode == 0x09 && event.shiftKey) {
      return;
    }
    dojo.stopEvent(event);
    var nextElement = this.getNextElement(element);
    if (!nextElement) {
      return;
    }
    // BR8468 2015.09.14
    // サジェスト利用時にEnterキーをタブキー扱いにしているとフォーカスセット時に
    // サジェストのxhr通信でエラーが発生するため、フォーカスのセットを300ms遅延させる
    var that = this;
    var isSuggest = false;
    if (element.id && element.id.indexOf("_content_displayed") !== -1) {
      isSuggest = true;
    }
    if (!isSuggest) {
      that.setFocusAndSelect(nextElement);
    } else {
      setTimeout(function() {
        that.setFocusAndSelect(nextElement);
      }, 300);
    }
  },

  setFocusAndSelect: function(element) {
    // タブ内の widget で、自信を含むタブが非表示の場合、選択状態にする
    var tab = element.getParent();
    if (tab && tab.declaredClass === "dijit.layout.ContentPane" && !tab.get("selected")) {
      var tabContainer = tab.getParent();
      if (tabContainer) {
        tabContainer.selectChild(tab);
      }
    }
    if (element.declaredClass === "wagby.DateTimeTextBox") {
      element.dateTextBox.focus();
    } else {
      element.focus();
    }
    if (element.type == "text" && element.select) {
      element.select();
    }
  },

  setIgnoreElements: function(args) {
    // デフォルトでEnterキーを無視する要素名
    // 前方一致の要素名を先に列挙する
    this.ignoreElementNames["btnClear_"] = 1;    // クリアボタン
    this.ignoreElementNames["btnCalendar_"] = 1; // カレンダボタン
    this.ignoreElementNames["btnAdd_"] = 1;      // 繰り返し項目の追加ボタン
    this.ignoreElementNames["btnInsert_"] = 1;   // 繰り返しコンテナの挿入ボタン
    this.ignoreElementNames["btnRemove_"] = 1;   // 繰り返しコンテナの削除ボタン
    this.ignoreElementNames["jfcdelete_"] = 1;   // 親子同時更新画面の削除チェックボックス
    // 完全一致の要素名
    this.ignoreElementNames["__jfc_size_per_page0"] = 1; // ページ表示数の変更
    this.ignoreElementNames["btnSizePerPage"] = 1;       // ページ表示数変更ボタン
    this.ignoreElementNames["btnULCopy"] = 1;            // 親子同時更新画面のコピーボタン
    this.ignoreElementNames["btnULInsert"] = 1;          // 親子同時更新画面の新規ボタン

    if (!args || args.ignoreElements === undefined) {
      return;
    }
    // カスタマイズで無視する要素名が引き渡されたら追加する
    for (var i=0,l=args.ignoreElements.length; i<l; i++) {
      this.ignoreElementNames[args.ignoreElements[i]] = 1;
    }
  },

  isIgnoreElement: function(name) {
    // 完全一致の要素名を先にチェックする
    if (this.ignoreElementNames[name]) {
      return true;
    }
    // 前方一致で要素名をチェックする
    for (var key in this.ignoreElementNames) {
      if (name.lastIndexOf(key, 0) == 0) {
        return true;
      }
    }
    return false;
  }
};

// サブメニュー、ログオフで引数のlocationへの画面遷移を行なう
function goPage(location) {
  if (clickedMenu) {
    return;
  }
  if (!window.confirm_destruction) {
    clickedMenu = true;
    window.location.href = location;
  } else {
    window.confirm_destruction(function() {
      clickedMenu = true;
      window.location.href = location;
    }, function() {
      clickedMenu = false;
    });
  }
}

function openPage(location, winname) {
  window.open(location, winname);
}

function getCheckboxesByName(form, checkboxNameRE) {
  var checkboxes = [];
  for (var i=0,l=form.elements.length; i<l; i++) {
    var element = form.elements[i];
    if (element.type != "checkbox" || element.name.match(checkboxNameRE) === null) {
      continue;
    }
    checkboxes.push(element);
  }
  return checkboxes;
}

function isAllSelected(checkboxes) {
  if (!checkboxes || checkboxes.length === 0) {
    return false;
  }
  var isSelected = true;
  require(["dijit/registry"], function(registry) {
    for (var i=0,l=checkboxes.length; i<l; i++) {
      var checkbox = registry.byId(checkboxes[i].id);
      if (!checkbox.get("checked")) {
        isSelected = false;
        break;
      }
    }
  });
  return isSelected;
}

function doClearOrCheckItem(checkboxes, state) {
  var changeelem = null;
  var checked = state["clear"];
  for (var i=0,l=checkboxes.length; i<l; i++) {
    if (checkboxes[i].checked) {
      changeelem = checkboxes[i];
    }
    // 入力可・不可制御の制御元がチェックボックス型にも対応したため
    // click イベントを発生させる
    if (checkboxes[i].checked ^ checked) {
      require(["dijit/registry"], function(registry) {
        var checkbox = registry.byId(checkboxes[i].id);
        if (checkbox) {
          checkbox.set("checked", checked);
          checkbox.onClick();
        }
      });
    }
  }
  return changeelem;
}

function getChangeToggleButtonStateFunc(buttonId, targetCheckboxes) {
  var checkIconClass = "dijitCheckBoxIcon";  // 全選択ボタンのアイコンクラス名
  var clearIconClass = "clearButtonIcon";    // クリアボタンのアイコンクラス名
  var tooltipContainerId = buttonId + "_TooltipContainer";
  var tooltipId = buttonId + "_Tooltip";
  var checkTooltip = res.CHECK_ALL;    // 全選択ボタンのツールチップメッセージ
  var clearTooltip = res.UNCHECK_ALL;  // クリアボタンのツールチップメッセージ

  // 全選択・クリアボタンの状態を変更する関数
  var changeToggleButtonState = function() {
    var toolTipMessage;
    var iconClass;
    // チェックボックスの選択状態を確認する
    if (isAllSelected(targetCheckboxes)) {
      // チェックボックスが全選択の場合は、クリアボタンを表示する
      iconClass = clearIconClass;
      toolTipMessage = clearTooltip;
    } else {
      // 対象のチェックボックスの中で選択されていないものがある場合、
      // 全選択ボタンを表示する
      iconClass = checkIconClass;
      toolTipMessage = checkTooltip;
    }
    require(["dijit/registry", "dojo/dom", "dojo/dom-construct"], function(registry, dom, domConstruct) {
      // ボタンアイコン設定
      checkboxToggleButton = registry.byId(buttonId);
      if (checkboxToggleButton) {
        checkboxToggleButton.set("iconClass", iconClass);
      }
      // ツールチップメッセージ設定
      domConstruct.destroy(tooltipId);
      domConstruct.create("span", {id:tooltipId, innerHTML: toolTipMessage}, dom.byId(tooltipContainerId));
    });
  };
  return changeToggleButtonState;
}

// 画面内の全てのチェックボックスを返す
function getAllCheckBoxInScreen() {
  return getAllWidgets(function(widget) {
    return widget.type === "checkbox"
  });
}

// 指定IDに前方一致するチェックボックスを返す
function getCheckboxById(id, allCheckBoxInScreen) {
  var checkboxSuffix = "$005d$002f$0040id";
  if (!allCheckBoxInScreen) {
    allCheckBoxInScreen = getAllCheckBoxInScreen();
  }
  if (!allCheckBoxInScreen) {
    return null;
  }
  var checkbox;
  require(["dojo/_base/array"], function(array) {
    checkbox = array.filter(allCheckBoxInScreen, function(widget) {
      return widget.id && widget.id.lastIndexOf(id, 0) === 0 &&
        widget.id.substr(-checkboxSuffix.length) === checkboxSuffix;
    });
  });
  return checkbox;
}

// チェックボックスのクリアボタン押下時にチェックボックスの
// 全選択・全解除を行なう関数をセットする
function setCheckboxToggleButtonClickEventFunc(targets) {
  var containerIndex = "${__position.count}";
  require(["dijit/registry"], function(registry) {
    var allCheckBoxInScreen = getAllCheckBoxInScreen();
    for (var id in targets) {
      var reloadItemName = targets[id];
      if (id.indexOf(containerIndex) === -1) {
        setCheckboxToggleButtonClickEventFuncNormal(registry, id, reloadItemName, allCheckBoxInScreen);
      } else {
        // 繰り返しコンテナ内のチェックボックス
        var checkboxInContainerId = id.split(containerIndex);
        var i=1;
        while (true) {
          var checkboxId = checkboxInContainerId[0] + i + checkboxInContainerId[1];
          checkboxId = checkboxId.split("${fn:escapeXml(c.id)}");
          var buttonId = "btnClear_" + checkboxId[0].substring(0, checkboxId[0].lastIndexOf("$005b"));
          var checkboxToggleButton = registry.byId(buttonId);
          if (!checkboxToggleButton) {
            break;
          }
          setCheckboxToggleButtonClickEventFuncNormal(registry, checkboxId[0], reloadItemName, allCheckBoxInScreen);
          i = i + 1;
        }
      }
    }
  });
}

function setCheckboxToggleButtonClickEventFuncNormal(registry, id, reloadItemName, allCheckBoxInScreen) {
  var checkboxId;
  if (id.indexOf("${fn:escapeXml(c.id)}") !== -1) {
    checkboxId = id.split("${fn:escapeXml(c.id)}");
  } else {
    checkboxId = [id];
  }
  var buttonId = "btnClear_" + checkboxId[0].substring(0, checkboxId[0].lastIndexOf("$005b"));
  var checkboxToggleButton = registry.byId(buttonId);
  // 全選択・クリア対象のチェックボックスを取得
  var targetCheckboxes = getCheckboxById(checkboxId[0], allCheckBoxInScreen);
  getCheckboxToggleButtonClickEventFunc(buttonId, reloadItemName, checkboxToggleButton, targetCheckboxes);
}

function getCheckboxToggleButtonClickEventFunc(buttonId, reloadItemName, checkboxToggleButton, targetCheckboxes) {
  // 全選択・クリアボタンの状態を変更する関数
  var changeToggleButtonState = getChangeToggleButtonStateFunc(buttonId, targetCheckboxes);
  changeToggleButtonState();
  if (!checkboxToggleButton || !targetCheckboxes || targetCheckboxes.length === 0) {
    return;
  }
  // 対象のチェックボックスにも全選択・クリアボタンアイコン変更の関数をセットする
  for (var i=0,l=targetCheckboxes.length; i<l; i++) {
    targetCheckboxes[i].on("click", function() {
      changeToggleButtonState();
    });
  }
  // 全選択・クリアボタン押下時に実行する関数
  checkboxToggleButton.onClick = function(e) {
    var iconClass = checkboxToggleButton.get("iconClass");
    // ボタンアイコンによって状態を判断する
    var clearState = (iconClass === "dijitCheckBoxIcon"); // 全選択ボタンのアイコンクラス名
    // 全選択・クリアを実行
    var changeelem = doClearOrCheckItem(targetCheckboxes, {clear: clearState});
    if (changeelem !== null) {
      updateContent(null, changeelem);
    }
    // 現在のチェックボックスの状態によってボタンアイコンを変更する
    changeToggleButtonState();

    if (!reloadItemName || reloadItemName === "") {
      return;
    }
    var actionName = "action_";
    if (buttonId.indexOf("_cp$002f") != -1) {
      actionName += "Refresh";
      actionName = actionName + "_" + reloadItemName + "_" + iconClass;//2013.1.8 @since R6.8u3
    } else {
      actionName += ("Clear" + reloadItemName);
    }
    setScrollPosition(buttonId);
    e.target.form.SENDACTION.name = actionName;
    buttonOff();
    e.target.form.submit();
  }
}

// サブウィンドウ検索画面のリンクを非表示にする
function disableNoUseAnchor(target) {
  if (!target) {
    return;
  }
  // サブウィンドウ検索画面のリンクの id は、a_ で始まる
  // 親画面へ反映させるリンクかどうか正規表現でマッチさせる
  require(["dojo/dom-construct", "dojo/dom-style", "dojo/query"], function(domConstruct, domStyle, query) {
    var re = new RegExp("^a_.*\\$005d\\$002f" + target + "$|^a_.*\\$005d\\$002f" + target + "\\$.*");
    query("a[id^='a_']").forEach(function(node) {
      var parentNode = node.parentNode;
      domStyle.set(node, "display", "none");
      var span = query("span", node)[0];
      if (span) {
        domConstruct.place(span, parentNode);
        // 親画面へ反映させる項目名を持つリンクのみフォントの色を変更する
        if (node.id.match(re)) {
          domStyle.set(span, "color", "#FF6600");
        }
      }
    });
  });
}

// タイトルペインの open 属性を cookie に保存する関数を返す
function getTitlePaneOpenAttrFunction(titlePaneId) {
  return function() {
    require(["dijit/registry", "dojo/cookie", "dojo/ready"], function(registry, cookie, ready) {
      ready(function() {
        var titlePane = registry.byId(titlePaneId);
        if (titlePane) {
          // タイトルペインの open 属性の初期値を取得する
          var titlePaneOpen = titlePane.get("open");
          if (cookie(titlePaneId)) {
            // cookie に open 属性が保存されている場合は、cookie の値を使用する
            titlePaneOpen = (cookie(titlePaneId) === "true");
          }
          titlePane.set("open", titlePaneOpen);
          titlePane.on("click", function() {
            cookie(titlePaneId, titlePane.get("open"));
          });
        }
      });
    });
  };
}

var jfcBubble = {
  // メッセージ表示場所のデフォルト値(右下)
  positionDirection: "br-left",

  errors: function(errors) {
    if (!errors) {
      return;
    }
    var message;
    if (errors.jfcerror && errors.jfcerror.length > 0) {
      message = "";
      for (var i=0,l=errors.jfcerror.length; i<l; i++) {
        message += (errors.jfcerror[i].content + "<br>");
      }
      this.error(message);
    }
    if (errors.jfcwarn && errors.jfcwarn.length > 0) {
      message = "";
      for (var i=0,l=errors.jfcwarn.length; i<l; i++) {
        message += (errors.jfcwarn[i].content + "<br>");
      }
      this.warn(message);
    }
    if (errors.jfcinfo && errors.jfcinfo.length > 0) {
      message = "";
      for (var i=0,l=errors.jfcinfo.length; i<l; i++) {
        message += (errors.jfcinfo[i].content + "<br>");
      }
      this.info(message);
    }
  },

  error: function(message) {
    this.showToasterMessage(message, "error");
  },

  warn: function(message) {
    this.showToasterMessage(message, "warning");
  },

  info: function(message) {
    this.showToasterMessage(message, "message");
  },

  showToasterMessage: function(message, type) {
    if (!message || message === "") {
      return;
    }
    jfcMessageToaster.setContent(message, type);
    jfcMessageToaster.show();
  },

  setMessagePosition: function(position) {
    if (!position || position === "") {
      position = this.positionDirection;
    }
    jfcMessageToaster.set("positionDirection", position);
  }
};

var ModernCalendarUtil = new function() {
  var that = this;
  require(["dijit/layout/ContentPane", "dijit/popup", "dijit/TooltipDialog", "dojo/_base/event", "dojo/_base/lang", "dojo/dom", "dojo/dom-class", "dojo/dom-construct", "dojo/dom-style", "dojo/json", "dojo/on", "dojo/query", "dojo/request", "dojo/store/Memory", "dojo/store/Observable", "dojox/calendar/Calendar", "dojox/mobile/Tooltip"],
  function(ContentPane, popup, TooltipDialog, baseEvent, lang, dom, domClass, domConstruct, domStyle, JSON, on, query, request, Memory, Observable, Calendar, Tooltip) {
    that.createCalendar = function(calendarOption) {
      var calendar = new Calendar({
        dateInterval: calendarOption.dateInterval || "month",
        columnViewProps: {
          minHours: calendarOption.minHours === undefined ? 8 : calendarOption.minHours,
          maxHours: calendarOption.maxHours === undefined ? 24: calendarOption.maxHours
        },
        firstDayOfWeek: calendarOption.firstDayOfWeek === undefined ? 0 : calendarOption.firstDayOfWeek,
        style: "position: relative; width: " + calendarOption.width + "; height: " + calendarOption.height + "; text-align: left;"
      }, calendarOption.id);
      that.isMobile = calendarOption.isMobile || false;
      // モデル毎のカレンダの色を設定する
      that.setCalendarCssClassFunc(calendar);
      // カレンダのイベントを設定する
      that.setCalendarEvent(calendar, calendarOption.modelId, calendarOption.domainURL);
      // カレンダデータの更新可能判定関数をセットする
      that.setCalendarItemEditableFunc(calendar);
      // カレンダデータ詳細ダイアログを生成する
      that.createCalendarItemDialog(calendar, calendarOption);
      that.selectedDateEvent = { date: new Date() };
      that.requestTimerId = null;
      return calendar;
    };

    that.setCalendarCssClassFunc = function(calendar) {
      calendar.set("cssClassFunc", function(item) {
        if (!item.calendar || item.calendar === "") {
          return "Calendar1";
        }
        return item.calendar;
      });
    };

    that.setCalendarEvent = function(calendar, modelId, domainURL) {
      // カレンダのデータを取得する関数
      var getCalendarItems = that.getCalendarItemsFunc(calendar, modelId, domainURL);
      // カレンダの表示月変更時に開始日でカレンダのデータを取得する
      calendar.on("TimeIntervalChange", function(e) {
        getCalendarItems(e.startTime);
      });
      // カレンダデータ押下でダイアログを表示する
      that.setCalendarItemClickEvent(calendar);
      // カレンダデータのドラッグアンドドロップでの更新イベントを設定する
      that.setCalendarItemUpdateEvent(calendar, domainURL);
      // 週表示のカラムでは初期表示時に時間を現在時刻に合わせる
      that.setStartTimeOfDay(calendar);
      // カレンダグリッドのダブルクリックで新規登録の設定ダイアログを表示する
      if (!that.isMobile) {
        that.setCalendarDblClickEvent(calendar);
      }
    };

    that.getCalendarItemsFunc = function(calendar, modelId, domainURL) {
      var getCalendarUrl = that.getCalendarUrlFunc(domainURL);
      return function(date) {
        request(getCalendarUrl(modelId, date), {
          headers: {
            'X-Wagby-RESTAPIVersion': "v2",
          },
          handleAs: "json",
          withCredentials: true,
        }).then(function(data) {
          that.setCalendarStore(calendar, data);
        }, function(data) {
          console.error("get calendarItem err: ", data);
          if (data.message) {
            jfcBubble.error(data.message);
          }
        });
      };
    };

    // カレンダデータ押下で設定ダイアログを表示する
    that.setCalendarItemClickEvent = function(calendar) {
      calendar.on("itemClick", function(event) {
        that.openJfcCalendarItemDialog(event);
      });
      // カレンダのグリッド押下で設定ダイアログを非表示にする
      calendar.on("gridClick", function(event) {
        that.selectedDateEvent = event;
        that.closeJfcCalendarItemDialog();
      });
    };

    // カレンダデータ編集完了時に update の REST API を実行する
    that.setCalendarItemUpdateEvent = function(calendar, domainURL) {
      calendar.on("itemEditEnd", function(event) {
        that.updateCalendarItem(event, domainURL);
      });
    };

    that.updateCalendarItem = function(event, domainURL) {
      var item = that.getUpdateCalendarItem(event);
      if (!item || !that.isCalendarItemChanged(item)) {
        return;
      }
      var baseUrl = "rest/" + item.modelId + "/editical/";
      if (domainURL) {
        baseUrl = domainURL + baseUrl;
      }
      var calendarItem = JSON.stringify(that.createCalendarItem(item));
      request(baseUrl + item.pkey, {
        data: calendarItem,
        handleAs: "json",
        headers: {
          'X-Wagby-RESTAPIVersion': "v2",
          'Content-Type': "application/json; charset=utf-8",
        },
        method: "PUT",
        withCredentials: true,
      }).then(function(data) {
        if (data.errors) {
          jfcBubble.errors(data.errors);
        }
      }, function(data) {
        that.rollbackItemData(item);
        if (data.response.data.errors) {
          jfcBubble.errors(data.response.data.errors);
        }
      });
    };

    that.getUpdateCalendarItem = function(event) {
      var item = event.item;
      var modelIdPkey = that.getModelIdPkey(item.id);
      if (!modelIdPkey) {
        return null;
      }
      return {
        id: item.id,
        modelId: modelIdPkey.modelId,
        pkey: modelIdPkey.pkey,
        startTime: _setDateWithFormat(item.startTime, "yyyy-MM-dd HH:mm:ss"),
        endTime: _setDateWithFormat(item.endTime, "yyyy-MM-dd HH:mm:ss"),
        savedStartTime: _setDateWithFormat(new Date(event.source._editStartTimeSave), "yyyy-MM-dd HH:mm:ss"),
        savedEndTime: _setDateWithFormat(new Date(event.source._editEndTimeSave), "yyyy-MM-dd HH:mm:ss")
      };
    };

    that.isCalendarItemChanged = function(item) {
      if (item.startTime === item.savedStartTime &&
           item.endTime === item.savedEndTime) {
        return false;
      }
      return true;
    };

    that.setCalendarItemEditableFunc = function(calendar) {
      calendar.isItemEditable = function(item, renderKind) {
        if (!item || that.isMobile) {
          return false;
        }
        // 更新画面の URL が無い場合は、データ更新不可
        if (!item.updateUrl) {
          return false;
        }
        return true;
      }
    };

    that.insertCalendarItem = function(item) {
      var content = that.createCalendarItem(data.entityp, item);
      request("rest/" + item.modelId + "/new", {
        data: JSON.stringify(content),
        handleAs: "json",
        headers: {
          'X-Wagby-RESTAPIVersion': "v2",
          'Content-Type': "application/json; charset=utf-8",
        },
        method: "POST",
        withCredentials: true,
      }).then(function(data) {
        refreshCalendarItem(item, data.entity);
      }, function(error) {
        console.error(data);
        if (data.response.data.errors) {
          jfcBubble.errors(data.response.data.errors);
        }
      });
    };

    that.createCalendarItem = function(item) {
      return {
        'start': item.startTime,
        'end': item.endTime
      };
    };

    that.rollbackItemData = function(item) {
      var store = dijitCalendar.get("store");
      var calendaritem = store.get(item.id);
      if (!calendaritem) {
        return;
      }
      calendaritem.startTime = item.savedStartTime.replace(" ", "T");
      calendaritem.endTime = item.savedEndTime.replace(" ", "T");
      store.put(calendaritem);
    };

    that.refreshCalendarItem = function(item, entity) {
      var store = dijitCalendar.get("store");
      if (item.id !== "") {
      var obj = store.get(item.id);
        if (obj) {
          obj.startTime = new Date(item.startTime);
          obj.endTime = new Date(item.endTime);
          store.put(obj);
        }
      } else {
        store.add({
          id: item.modelId + ":" + entity.pkey,
          summary: item.summary || "",
          startTime: new Date(item.startTime),
          endTime: new Date(item.endTime),
          allDay: item.allDay || false,
          description: item.description || "",
          location: item.location || "",
          calendar: item.calendar || "Calendar1"
        });
      }
    };

    that.setStartTimeOfDay = function(calendar) {
      calendar.on("RendererCreated", function(e) {
        calendar.columnView.set('startTimeOfDay', {hours: new Date().getHours(), duration: 20});
        var renderer = e.renderer.renderer;
        on(renderer.domNode, "touchend", lang.hitch(calendar, function(e) {
          baseEvent.stop(e);
          calendar.onItemClick({
            triggerEvent: e,
            renderer: renderer,
            item: renderer.item._item
          });
        }));
      });
    };

    that.openNewCalendarItemDialog = function(event) {
      if (!event) {
        event = that.selectedDateEvent;
      }
      that.openJfcCalendarItemDialog(event, {
        id: "",
        summary: "",
        startTime: _setDateWithFormat(event.date, "yyyy-MM-dd 09:00:00"),
        endTime: _setDateWithFormat(event.date, "yyyy-MM-dd 18:00:00"),
        allDay: false,
        staff: "",
        location: "",
        url: "",
        description: ""
      });
    }

    that.setCalendarDblClickEvent = function(calendar) {
      calendar.on("gridDoubleClick", function(event) {
        that.openNewCalendarItemDialog(event);
      });
    };

    that.setJfcCalendarItemAllDayEvent = function(jfcRegisterMobileCalendarItemAllDay) {
      var chkAllDay;
      var txtStartDate;
      var txtStartTime;
      var txtEndDate;
      var txtEndTime;
      if (jfcRegisterMobileCalendarItemAllDay) {
        chkAllDay = jfcRegisterMobileCalendarItemAllDay;
        txtStartDate = jfcRegisterMobileCalendarItemStartDate;
        txtStartTime = jfcRegisterMobileCalendarItemStartTime;
        txtEndDate = jfcRegisterMobileCalendarItemEndDate;
        txtEndTime = jfcRegisterMobileCalendarItemEndTime;
      } else {
        chkAllDay = jfcCalendarItemAllDay;
        txtStartDate = jfcCalendarItemStartDate;
        txtStartTime = jfcCalendarItemStartTime;
        txtEndDate = jfcCalendarItemEndDate;
        txtEndTime = jfcCalendarItemEndTime;
      }
      // 終日フラグ押下時
      chkAllDay.on('click', function(event) {
        var startDate = txtStartDate.get("value");
        // 開始時刻
        txtStartTime.set("value", startDate);
        // 終了日
        var endDate = convText2Date(txtStartDate.get("displayedValue") + " 00:00:00");
        endDate = new Date(endDate.setDate(endDate.getDate() + 1));
        txtEndDate.set("value", endDate);
        // 終了時刻
        txtEndTime.set("value", endDate);
      });
    }

    that.getCalendarBaseUrl = function(domainURL, modelId) {
      var url = "rest/" + modelId + "/ical/";
      if (domainURL) {
        return domainURL + url;
      }
      return url;
    };

    that.getCalendarUrlFunc = function(domainURL) {
      return function(modelId, date) {
        if (!date) {
          return null;
        }
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        return that.getCalendarBaseUrl(domainURL, modelId) + year + "-" + month + "-01";
      };
    };

    that.getCalendarItemsFromData = function(data) {
      var calendarItems = [];
      var items = data.listp.item;
      for (var i=0,l=items.length; i<l; i++) {
        var item = items[i];
        if (item.calendaritem.length === 0) {
          continue;
        }
        for (var j=0,m=item.calendaritem.length; j<m; j++) {
          var calendaritem = item.calendaritem[j];
          calendarItems.push({
            id: calendaritem.modelid + ":" + calendaritem.calendarid,
            modelId: calendaritem.modelid,
            calendarId: calendaritem.calendarid,
            primaryKeyName: calendaritem.primarykeyname,
            primaryKeyNames: calendaritem.primarykeynames,
            primaryKeyValues: calendaritem.primarykeyvalues,
            summary: calendaritem.summary || "",
            startTime: that.getISODatetimeFormatValue(calendaritem.start) || "",
            endTime: that.getISODatetimeFormatValue(calendaritem.end) || "",
            allDay: calendaritem.allDay || false,
            staff: calendaritem.staff || "",
            description: calendaritem.description || "",
            location: calendaritem.location || "",
            url: calendaritem.url || "",
            showUrl: calendaritem.showurl || "",
            updateUrl: calendaritem.updateurl || "",
            deleteUrl: calendaritem.deleteurl || "",
            calendar: calendaritem.calendar || "Calendar1"
          });
        }
      }
      return calendarItems;
    };

    that.getISODatetimeFormatValue = function(strDate) {
      if (!strDate || strDate === "") {
        return null;
      }
      // 日付と時刻を空白ではなく「T」で連結する
      return strDate.replace(/\s/, "T");
    };

    that.getModelIdPkey = function(calendarItemId) {
      if (!calendarItemId || calendarItemId === "" || calendarItemId.indexOf(":") === -1) {
        return null;
      }
      var modelIdPkey = calendarItemId.split(":"); // modelId:pkey
      return {
        modelId: modelIdPkey[0],
        pkey: modelIdPkey[1] || 0
      };
    };

    // カレンダ設定ダイアログ表示関数
    that.openJfcCalendarItemDialog = function(event, item) {
      if (!item && event) {
        item = event.item;
      }
      // jholiday のデータはダイアログを開かない
      if (item && item.modelId && item.modelId === 'jholiday') {
        return;
      }
      // カレンダ設定ダイアログを開く
      if (!that.isMobile) {
        popup.open({
          popup: that.jfcCalendarItemDialog,
          x: event.triggerEvent.x || event.triggerEvent.clientX,
          y: event.triggerEvent.y || event.triggerEvent.clientY
        });
      } else {
        var node;
        if (event.renderer) {
          node = event.source.scrollContainer;
          if (!node) {
            node = event.renderer.summaryLabel;
          }
        } else {
          node = dom.byId("jfcToolBarBtnNew");
        }
        that.jfcCalendarItemDialog.show(node);
      }
      // カレンダ設定ダイアログにデータをセットする
      that.setCalendarItemDataToDialog(item);
      that.setJfcCalendarItemDialogButtonDisabled(item);
    };

    // カレンダ設定ダイアログ非表示関数
    that.closeJfcCalendarItemDialog = function() {
      if (!that.isMobile) {
        popup.close(that.jfcCalendarItemDialog);
      } else {
        that.jfcCalendarItemDialog.hide();
      }
    };

    that.getCalendarItemTableRows = function() {
      if (that.calendarItemTableRows) {
        return that.calendarItemTableRows;
      }
      var rows = query('tr', 'jfcCalendarItemDialogTableTbody');
      for (var i=0,l=6; i<l; i++) {
        rows.shift();
      }
      that.calendarItemTableRows = rows;
      return that.calendarItemTableRows;
    };

    that.setJfcCalendarItemDialogRowsDisplay = function(display) {
      domStyle.set('showJfcCalendarBtnContainer', 'display', display);
      var rows = that.getCalendarItemTableRows();
      for (var i=0,l=rows.length; i<l; i++) {
        domStyle.set(rows[i], 'display', display);
      }
    };

    that.setJfcCalendarItemDialogInsert = function() {
      domStyle.set('insertJfcCalendarBtnContainer', 'display', '');
      that.setJfcCalendarItemDialogRowsDisplay('none');
      that.setCalendarItemDialogReadonly(false);
    };

    that.setJfcCalendarItemDialogShow = function() {
      domStyle.set('insertJfcCalendarBtnContainer', 'display', 'none');
      that.setJfcCalendarItemDialogRowsDisplay('');
      that.setCalendarItemDialogReadonly(true);
    }

    that.setCalendarItemDialogReadonly = function(readOnly) {
      // タイトル
      jfcCalendarItemSummary.set("readOnly", readOnly);
      // 開始日
      jfcCalendarItemStartDate.set("readOnly", readOnly);
      // 終了日
      jfcCalendarItemEndDate.set("readOnly", readOnly);
      // 開始時刻
      jfcCalendarItemStartTime.set("readOnly", readOnly);
      // 終了時刻
      jfcCalendarItemEndTime.set("readOnly", readOnly);
      // 終日フラグ
      jfcCalendarItemAllDay.set("readOnly", readOnly);
    }

    that.setCalendarItemDataToDialog = function(item) {
      var lbxJfcCalendarViewModelDisabled = true;
      var modelIdPkey = that.getModelIdPkey(item.id);
      if (!modelIdPkey) {
        // モデルIDと主キーが無い場合は、新規登録なのでモデル選択リストボックスを入力可とする
        lbxJfcCalendarViewModelDisabled = false;
        that.setJfcCalendarItemDialogInsert();
      } else {
        // モデルIDが取得できた場合は、更新なので対象モデルを選択状態にする
        lbxJfcCalendarViewModel.set("value", modelIdPkey.modelId);
        that.setJfcCalendarItemDialogShow();
      }
      lbxJfcCalendarViewModel.set("readOnly", lbxJfcCalendarViewModelDisabled);

      // モデルID:主キー
      jfcCalendarItemId.set("value", item.id);
      // タイトル
      jfcCalendarItemSummary.set("value", item.summary);
      // 開始日
      jfcCalendarItemStartDate.set("value", _setDateWithFormat(item.startTime, "yyyy-MM-dd"));
      // 終了日
      jfcCalendarItemEndDate.set("value", _setDateWithFormat(item.endTime, "yyyy-MM-dd"));
      // 開始時刻
      jfcCalendarItemStartTime.set("value", "T" + _setDateWithFormat(item.startTime, "HH:mm"));
      // 終了時刻
      jfcCalendarItemEndTime.set("value", "T" + _setDateWithFormat(item.endTime, "HH:mm"));
      // 終日
      jfcCalendarItemAllDay.set("value", item.allDay);
      // 担当者
      jfcCalendarItemStaff.set("value", item.staff);
      // 場所
      jfcCalendarItemLocation.set("value", item.location);
      // URL
      jfcCalendarItemUrl.set("value", item.url);
      // 備考
      jfcCalendarItemDescription.set("value", item.description);
    };

    that.setJfcCalendarItemDialogButtonDisabled = function(item) {
      if (item.id === "") {
        // 新規登録
        var value = that.lbxCalendarView.get("value");
        that.setBtnInsertJfcCalendarItemDisabled(value);
        return;
      }
      // 詳細画面表示ボタン
      var showBtnDisabled = false;
      if (!item.showUrl) {
        showBtnDisabled = true;
      }
      btnShowJfcCalendarItem.set("disabled", showBtnDisabled);

      // 更新画面表示ボタン
      var updateBtnDisabled = false;
      if (!item.updateUrl) {
        updateBtnDisabled = true;
      }
      btnUpdateJfcCalendarItem.set("disabled", updateBtnDisabled);

      // 削除ボタン
      var deleteBtnDisabled = false;
      if (!item.deleteUrl) {
        deleteBtnDisabled = true;
      }
      btnDeleteJfcCalendarItem.set("disabled", deleteBtnDisabled);
    };

    that.getCalendarItemFromStore = function(calendar, id) {
      if (!calendar) {
        return null;
      }
      var store = calendar.get("store");
      if (!store) {
        return null;
      }
      return store.get(id);
    };

    that.openPage = function(url) {
      if (url) {
        window.location.href = url;
      }
    };

    that.getShowUrlFromForm = function(calendar) {
      var calendaritem = that.getCalendarItemFromForm(calendar);
      if (!calendaritem || !calendaritem.showUrl || calendaritem.showUrl === "") {
        return null;
      }
      return calendaritem.showUrl + "?" +
        that.getPrimaryKeyValueParameter(calendaritem.primaryKeyNames, calendaritem.primaryKeyValues);
    };

    that.getUpdateUrlFromForm = function(calendar) {
      var calendaritem = that.getCalendarItemFromForm(calendar);
      if (!calendaritem || !calendaritem.updateUrl || calendaritem.updateUrl === "") {
        return null;
      }
      return calendaritem.updateUrl + "?action_Update=&" +
        that.getPrimaryKeyValueParameter(calendaritem.primaryKeyNames, calendaritem.primaryKeyValues);
    };

    that.getJfcCalendarTitle = function(calendaritem) {
      if (calendaritem.summary) {
        return calendaritem.summary;
      }
      if (!that.isMobile) {
        return jfcCalendarItemSummary.get("value");
      } else {
        return jfcRegisterMobileCalendarItemSummary.get("value");
      }
    }

    that.getJfcCalendarStartDateTime = function(calendaritem) {
      if (calendaritem.startTime) {
        return _setDateWithFormat(calendaritem.startDate, "yyyy-MM-dd") +
          _setDateWithFormat(calendaritem.startTime, " HH:mm:ss");
      }
      if (!that.isMobile) {
        return _setDateWithFormat(jfcCalendarItemStartDate.get("value"), "yyyy-MM-dd") +
          _setDateWithFormat(jfcCalendarItemStartTime.get("value"), " HH:mm:ss");
      } else {
        return _setDateWithFormat(jfcRegisterMobileCalendarItemStartDate.get("value"), "yyyy-MM-dd") +
          _setDateWithFormat(jfcRegisterMobileCalendarItemStartTime.get("value"), " HH:mm:ss");
      }
    }

    that.getJfcCalendarEndDateTime = function(calendaritem) {
      if (calendaritem.endTime) {
        return _setDateWithFormat(calendaritem.endDate, "yyyy-MM-dd") +
          _setDateWithFormat(calendaritem.endTime, " HH:mm:ss");
      }
      if (!that.isMobile) {
        return _setDateWithFormat(jfcCalendarItemEndDate.get("value"), "yyyy-MM-dd") +
          _setDateWithFormat(jfcCalendarItemEndTime.get("value"), " HH:mm:ss");
      } else {
        return _setDateWithFormat(jfcRegisterMobileCalendarItemEndDate.get("value"), "yyyy-MM-dd") +
          _setDateWithFormat(jfcRegisterMobileCalendarItemEndTime.get("value"), " HH:mm:ss");
      }
    }

    that.isJfcCalendarItemAllDay = function() {
      if (!that.isMobile) {
        return jfcCalendarItemAllDay.get("checked");
      } else {
        return jfcRegisterMobileCalendarItemAllDay.get("checked");
      }
    }

    that.getInsertUrlFromLbxCalendarView = function(calendaritem) {
      var selectedOption = that.lbxCalendarView.getOptions(that.lbxCalendarView.get("value"));
      if (!selectedOption) {
        return capFirst(calendaritem.modelId) + ".do";
      }
      return selectedOption.inserturl;
    },

    that.getInsertUrlFromForm = function(calendar) {
      var calendaritem;
      if (!that.isMobile) {
        calendaritem = that.getCalendarItemFromForm(calendar);
      } else {
        calendaritem = that.getRegisterMobileCalendarItemFromForm(calendar);
      }
      if (!calendaritem || !calendaritem.modelId || calendaritem.modelId === "") {
        return null;
      }
      // タイトル
      var jfcCalendarTitle = that.getJfcCalendarTitle(calendaritem);
      // 開始日時
      var jfcCalendarStartDateTime = that.getJfcCalendarStartDateTime(calendaritem);
      // 終了日時
      var jfcCalendarEndDateTime = that.getJfcCalendarEndDateTime(calendaritem);
      var url = that.getInsertUrlFromLbxCalendarView(calendaritem) + '?action_Insert=&jfcCalendarTitle=' + jfcCalendarTitle +
        '&jfcCalendarStartDateTime=' + jfcCalendarStartDateTime + '&jfcCalendarEndDateTime=' + jfcCalendarEndDateTime;
      // 終日フラグ
      if (that.isJfcCalendarItemAllDay(calendaritem)) {
        url = url + '&jfcCalendarAllDay=1';
      }
      return url
    };

    that.getPrimaryKeyValueParameter = function(primaryKeyNames, primaryKeyValues) {
      if (!primaryKeyNames || primaryKeyNames.length === 0 ||
           !primaryKeyValues || primaryKeyValues.length === 0) {
        return "";
      }
      var primaryKeyValueParameter = primaryKeyNames[0] + "=" + primaryKeyValues[0];
      for (var i=1,l=primaryKeyNames.length; i<l; i++) {
        primaryKeyValueParameter += "&" + primaryKeyNames[i] + "=" + primaryKeyValues[i];
      }
      return primaryKeyValueParameter;
    };

    that.getCalendarItemFormValues = function() {
      return jfcCalendarItemForm.get("value");
    }

    that.getRegisterMobileCalendarItemFormValues = function() {
      return jfcRegisterMobileCalendarItemForm.get("value");
    }

    that.getJfcCalendarItemId = function(formValues) {
      return formValues.jfcCalendarItemId;
    }

    that.getRegisterMobileCalendarItemFromForm = function(calendar) {
      var formValues = that.getRegisterMobileCalendarItemFormValues();
      if (!formValues.jfcRegisterMobileCalendarItemId) {
        return formValues;
      }
      var calendaritem = that.getCalendarItemFromStore(calendar, formValues.jfcRegisterMobileCalendarItemId);
      if (!calendaritem) {
        return formValues;
      }
      calendaritem.startTime = _setDateWithFormat(formValues.startDate, "yyyy-MM-dd") + "T" + _setDateWithFormat(formValues.startTime, "HH:mm");
      calendaritem.endTime = _setDateWithFormat(formValues.endDate, "yyyy-MM-dd") + "T" + _setDateWithFormat(formValues.endTime, "HH:mm");
      calendaritem.summary = formValues.summary;
      calendaritem.staff = formValues.staff;
      calendaritem.description = formValues.description;
      calendaritem.location = formValues.location;
      calendaritem.url = formValues.url;
      calendaritem.allDay = jfcRegisterMobileCalendarItemAllDay.get("checked");
      return calendaritem;
    }

    that.getCalendarItemFromForm = function(calendar) {
      var formValues = that.getCalendarItemFormValues();
      var calendaritem = that.getCalendarItemFromStore(calendar, that.getJfcCalendarItemId(formValues));
      if (!calendaritem) {
        return formValues;
      }
      calendaritem.startTime = _setDateWithFormat(formValues.startDate, "yyyy-MM-dd") + "T" + _setDateWithFormat(formValues.startTime, "HH:mm");
      calendaritem.endTime = _setDateWithFormat(formValues.endDate, "yyyy-MM-dd") + "T" + _setDateWithFormat(formValues.endTime, "HH:mm");
      calendaritem.summary = formValues.summary;
      calendaritem.staff = formValues.staff;
      calendaritem.description = formValues.description;
      calendaritem.location = formValues.location;
      calendaritem.url = formValues.url;
      var allDay;
      if (!that.isMobile) {
        allDay = jfcCalendarItemAllDay.get("checked");
      } else {
        allDay = jfcRegisterMobileCalendarItemAllDay.get("checked");
      }
      calendaritem.allDay = allDay;
      return calendaritem;
    };

    that.openShowPage = function(calendar) {
      that.openPage(that.getShowUrlFromForm(calendar));
    };

    that.openUpdatePage = function(calendar) {
      that.openPage(that.getUpdateUrlFromForm(calendar));
    };

    // 削除ボタン押下時のイベント
    that.deleteCalendarItemFromForm = function(calendar, calendarOption) {
      if (!confirm(res.CONFIRM_DELETE)) {
        return;
      }
      that.deleteCalendarItem(calendar, calendarOption);
      that.closeJfcCalendarItemDialog();
    };

    that.deleteCalendarItem = function(calendar, calendarOption) {
      var calendaritem = that.getCalendarItemFromForm(calendar)
      if (!calendaritem) {
        return;
      }
      var url = "rest/" + calendaritem.modelId + "/edit/" + calendaritem.calendarId;
      if (calendarOption.domainURL) {
        url = calendarOption.domainURL + url;
      }
      request(url, {
        headers: {
          'X-Wagby-RESTAPIVersion': "v2",
        },
        handleAs: "json",
        method: "DELETE",
        withCredentials: true,
      }).then(function(data) {
        if (data && data.errors) {
          if (data.errors.jfcinfo && data.errors.jfcinfo.length > 0) {
            // サーバでの削除処理が正常終了した場合に画面のカレンダデータを削除する
            var store = calendar.get("store");
            store.remove(calendaritem.id);
          }
          jfcBubble.errors(data.errors);
        }
      }, function(data) {
        console.error("delete calendarItem error: ", data);
        if (data && data.response && data.response.data && data.response.data.errors) {
          jfcBubble.errors(data.response.data.errors);
        } else {
          jfcBubble.error(res.ERROR_MSG_DELETE_CALENDAR_ITEM);
        }
      });
    };

    that.insertCalendarItemFromForm = function(calendar) {
      var url = that.getInsertUrlFromForm(calendar);
      that.openPage(url);
    };

    that.getConditionWidgetChangeEventFunc = function(calendar) {
      var getCalendarUrl = that.getCalendarUrlFunc();
      return function(modelId, date, condition) {
        if (that.requestTimerId) {
          clearTimeout(that.requestTimerId);
        }
        that.requestTimerId = setTimeout(function() {
          var url = getCalendarUrl(modelId, date);
          request(url, {
            query: condition,
            handleAs: "json",
            headers: {
              'X-Wagby-RESTAPIVersion': "v2",
              "Content-Type": "application/x-www-form-urlencoded",
            },
            method: "POST",
            withCredentials: true,
          }).then(function(data) {
            that.setCalendarStore(calendar, data);
          }, function(data) {
            console.error("searchCalendar err: ", data);
            if (data.message) {
              jfcBubble.error(data.message);
            }
          });
        }, 100);
      };
    };

    that.setCalendarStore = function(calendar, data) {
      var store = calendar.get("store");
      if (store) {
        store = null;
      }
      calendar.set("store", new Observable(new Memory({
        'data': that.getCalendarItemsFromData(data),
      })));
    };

    that.getMobileCalendarItemContentTemplate = function() {
      var dialogTemplate = '<form data-dojo-type="dijit/form/Form" data-dojo-id="jfcCalendarItemForm" id="jfcCalendarItemForm" action="" method="post" style="font-size: x-small;padding-bottom: 0;">';
      dialogTemplate = dialogTemplate + that.getCalendarItemContentTemplateTable();
      dialogTemplate = dialogTemplate + '<div style="padding: 10px 0 0 0; text-align: right;">'
+ '<span id="showJfcCalendarBtnContainer"><button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnShowJfcCalendarItem" type="button" style="height: auto;font-size:x-small;"><div>'
+ res.LABEL_CALENDAR_DIALOG_BTN_SHOW +
'</div></button><button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnUpdateJfcCalendarItem" type="button" style="height: auto;font-size:x-small;">'
+ res.LABEL_CALENDAR_DIALOG_BTN_UPDATE +
'</button><button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnDeleteJfcCalendarItem" type="button" style="height: auto;font-size:x-small;">'
+ res.BUTTON_DELETE +
'</button></span><span id="insertJfcCalendarBtnContainer"><button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnInsertJfcCalendarItem" type="button" style="height: auto;font-size:x-small;">'
+ res.LABEL_CALENDAR_DIALOG_BTN_INSERT +
'</button></span><button data-dojo-type="dojox/mobile/Button" data-dojo-id="btnCancelJfcCalendarItem" type="button" style="height: auto;font-size:x-small;" data-dojo-props="onClick: function() { ModernCalendarUtil.closeJfcCalendarItemDialog(); }">'
+ res.BUTTON_CANCEL +
'</button></div><input data-dojo-type="dijit/form/TextBox" type="hidden" data-dojo-id="jfcCalendarItemId" name="jfcCalendarItemId"></form>';
      return dialogTemplate;
    }

    that.getCalendarItemContentTemplate = function() {
      var dialogTemplate = '<form data-dojo-type="dijit/form/Form" data-dojo-id="jfcCalendarItemForm" id="jfcCalendarItemForm" action="" method="post" style="padding-bottom: 0;">';
      dialogTemplate = dialogTemplate + that.getCalendarItemContentTemplateTable();
      dialogTemplate = dialogTemplate + '<div style="padding: 10px 0 0 0; text-align: right;">'
+ '<span id="showJfcCalendarBtnContainer"><button data-dojo-type="dijit/form/Button" data-dojo-id="btnShowJfcCalendarItem" type="button"><div>'
+ res.LABEL_CALENDAR_DIALOG_BTN_SHOW +
'</div></button><button data-dojo-type="dijit/form/Button" data-dojo-id="btnUpdateJfcCalendarItem" type="button"><div style="width: 80px;">'
+ res.LABEL_CALENDAR_DIALOG_BTN_UPDATE +
'</div></button><button data-dojo-type="dijit/form/Button" data-dojo-id="btnDeleteJfcCalendarItem" type="button"><div style="width: 60px;">'
+ res.BUTTON_DELETE +
'</div></button></span><span id="insertJfcCalendarBtnContainer"><button data-dojo-type="dijit/form/Button" data-dojo-id="btnInsertJfcCalendarItem" type="button"><div style="width: 110px;">'
+ res.LABEL_CALENDAR_DIALOG_BTN_INSERT +
'</div></button></span><button data-dojo-type="dijit/form/Button" data-dojo-id="btnCancelJfcCalendarItem" type="button" data-dojo-props="onClick: function() { ModernCalendarUtil.closeJfcCalendarItemDialog(); }">'
+ res.BUTTON_CANCEL +
'</button></div><input data-dojo-type="dijit/form/TextBox" type="hidden" data-dojo-id="jfcCalendarItemId" name="jfcCalendarItemId"></form>';
      return dialogTemplate;
    }

    that.getCalendarItemContentTemplateTable = function() {
      var dialogTemplate = '<table class="display_table"><tbody id="jfcCalendarItemDialogTableTbody"><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_MODELNAME +
'</th><td><select data-dojo-type="wagby/Select" data-dojo-id="lbxJfcCalendarViewModel" name="modelId" style="width: 150px;"></select></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_TITLE +
'</th><td><input type="text" data-dojo-type="dijit/form/TextBox" data-dojo-id="jfcCalendarItemSummary" name="summary" data-dojo-props="required: true, readOnly: true, selectOnClick: true" style="width: 99%;"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_STARTDATETIME +
'</th><td><input type="text" data-dojo-type="wagby/DateTextBox" data-dojo-id="jfcCalendarItemStartDate" name="startDate" data-dojo-props="dateFormat: \'yyyy-MM-dd\', required: true, readOnly: true" style="width: 150px;"/><input type="text" data-dojo-type="dijit/form/TimeTextBox" data-dojo-id="jfcCalendarItemStartTime" name="startTime" data-dojo-props="readOnly: true"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_ENDDATETIME +
'</th><td><input type="text" data-dojo-type="wagby/DateTextBox" data-dojo-id="jfcCalendarItemEndDate" name="endDate" data-dojo-props="dateFormat: \'yyyy-MM-dd\', required: true, readOnly: true" style="width: 150px;"/><input type="text" data-dojo-type="dijit/form/TimeTextBox" data-dojo-id="jfcCalendarItemEndTime" name="endTime" data-dojo-props="readOnly: true"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_ALLDAYFLAG +
'</th><td><input type="checkbox" data-dojo-type="dijit/form/CheckBox" data-dojo-id="jfcCalendarItemAllDay" id="jfcCalendarItemAllDay" name="allDay" data-dojo-props="readOnly: true"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_STAFF +
'</th><td><input type="text" data-dojo-type="dijit/form/TextBox" data-dojo-id="jfcCalendarItemStaff" name="staff" data-dojo-props="readOnly: true, selectOnClick: true" style="width: 100%;"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_PLACE +
'</th><td><input type="text" data-dojo-type="dijit/form/TextBox" data-dojo-id="jfcCalendarItemLocation" name="location" data-dojo-props="readOnly: true, selectOnClick: true" style="width: 100%;"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_URL +
'</th><td><input type="text" data-dojo-type="dijit/form/TextBox" data-dojo-id="jfcCalendarItemUrl" name="url" data-dojo-props="readOnly: true, selectOnClick: true" style="width: 100%;"/></td></tr><tr class="display_field"><th class="display_label">'
+ res.LABEL_CALENDAR_DIALOG_MEMO +
  '</th><td><textarea data-dojo-type="dijit/form/SimpleTextarea" data-dojo-id="jfcCalendarItemDescription" name="description" data-dojo-props="readOnly: true, rows: 5" style="width: 97%;"></textarea></td></tr></tbody></table>';
      return dialogTemplate;
    }

    that.createCalendarItemDialog = function(calendar, calendarOption) {
      if (!that.isMobile) {
        that.jfcCalendarItemDialog = new TooltipDialog({
          id: "jfcCalendarItemDialog",
        });
        that.jfcCalendarItemDialog.on("Load", function(data) {
          that.setCalendarItemDialogEvent(calendar, calendarOption);
        });
        that.jfcCalendarItemDialog.set("content", that.getCalendarItemContentTemplate());
      } else {
        that.jfcCalendarItemDialog = jfcCalendarItemDialog;
        var cp = new ContentPane();
        cp.on("Load", function() {
          that.setCalendarItemDialogEvent(calendar, calendarOption);
        });
        domConstruct.place(cp.domNode, that.jfcCalendarItemDialog.domNode, "last");
        cp.set("content", that.getMobileCalendarItemContentTemplate());
      }
    };

    that.setCalendarItemDialogEvent = function(calendar, calendarOption) {
      // 詳細画面表示ボタン押下イベント
      btnShowJfcCalendarItem.on("click", function() {
        that.openShowPage(calendar);
      });
      // 更新画面表示ボタン押下イベント
      btnUpdateJfcCalendarItem.on("click", function() {
        that.openUpdatePage(calendar);
      });
      // 削除ボタン押下イベント
      btnDeleteJfcCalendarItem.on("click", function() {
        that.deleteCalendarItemFromForm(calendar, calendarOption);
      });
      // 新規登録画面表示ボタン押下イベント
      btnInsertJfcCalendarItem.on('click', function() {
        that.insertCalendarItemFromForm(calendar);
      });
      // 終日フラグ押下時のイベント
      that.setJfcCalendarItemAllDayEvent();
      // カレンダ設定ダイアログのモデルリストのデータを取得する
      that.setCalendarViewModelData(calendarOption);
    }

    // モデル名選択リストボックス変更時に新規登録画面表示の
    // ボタンの押下可・不可を切り替える
    that.setLbxCalendarViewOnChangeEvent = function() {
      that.lbxCalendarView.on("change", function(value) {
        that.setBtnInsertJfcCalendarItemDisabled(value);
      });
    };

    that.setBtnInsertJfcCalendarItemDisabled = function(value) {
      var disabled = false;
      var selectedOption = that.lbxCalendarView.getOptions(value);
      if (!selectedOption || !selectedOption.inserturl) {
        // 新規登録画面のURLがない場合はボタンを押下不可にする
        disabled = true;
      }
      btnInsertJfcCalendarItem.set("disabled", disabled);
    },

    that.setCalendarViewModelData = function(calendarOption, lbxMobileCalendarViewModel) {
      that.lbxCalendarView;
      if (lbxMobileCalendarViewModel) {
        that.lbxCalendarView = lbxMobileCalendarViewModel;
      } else {
        that.lbxCalendarView = lbxJfcCalendarViewModel;
      }
      var options = that.lbxCalendarView.get("options");
      if (options && options.length > 0) {
        return;
      }
      that.setLbxCalendarViewOnChangeEvent();
      var url = "rest/" + calendarOption.modelId + "/ical/models";
      if (calendarOption.domainURL) {
        url = calendarOption.domainURL + url;
      }
      request(url, {
        headers: {
          'X-Wagby-RESTAPIVersion': "v2",
        },
        handleAs: "json",
        withCredentials: true,
      }).then(function(data) {
        options = [];
        if (data && data.length > 0) {
          for (var i=0,l=data.length; i<l; i++) {
            var calendarviewModel = data[i];
            options.push({
              label: calendarviewModel.modelname,
              value: calendarviewModel.modelid,
              inserturl: calendarviewModel.inserturl,
            });
          }
        }
        that.lbxCalendarView.set("options", options);
      }, function(data) {
        console.error("setCalendarViewModelData error: ", data);
        if (data.message) {
          jfcBubble.error(data.message);
        }
      });
    };
  });
};

function activateTabContainsErrorWidget(widget) {
  var contentPane = widget.getParent();
  if (contentPane.declaredClass !== "dijit.layout.ContentPane") {
    return;
  }
  var tabContainer = contentPane.getParent();
  if (tabContainer.declaredClass !== "dijit.layout.TabContainer") {
    return;
  }
  tabContainer.selectChild(contentPane);
  activateTabContainsErrorWidget(tabContainer);
}

function focusErrorWidget() {
  var widgets = getAllWidgets();
  require(["dojo/_base/array"], function(array) {
    var errorWidgets = array.filter(widgets, function(widget) {
      return widget.isValid && !widget.isValid();
    });
    var errorWidget = errorWidgets[0];
    activateTabContainsErrorWidget(errorWidget);
    errorWidget.focus();
  });
}

function isFormValid(f) {
  var isFormValid = true;
  require(["dijit/registry"], function(registry) {
    var formWidget = registry.byId(f.id);
    if (formWidget && formWidget.declaredClass &&
        formWidget.declaredClass === "dijit.form.Form") {
      isFormValid = formWidget.validate();
      if (!isFormValid) {
        focusErrorWidget();
      }
    }
  });
  return isFormValid;
}

function doSubmitForm(form, actionName, isNoValidate) {
  var actionParam = "action_";
  if (actionName === undefined || actionName === null) {
    if (form.id.lastIndexOf("condition", 0) === 0) {
      actionParam = actionParam + "Search_Condition";
    } else {
      actionParam = actionParam + "Send";
    }
    actionName = actionParam;
  }
  if (window.isSubmitIfError) {
    isNoValidate = window.isSubmitIfError(actionName);
  }
  if (window.doSubmit && !window.doSubmit(form, isNoValidate)) {
    if (form.target === "_blank") {
      form.target = '_self';
    }
    return;
  }
  if (!window.doSubmit_skipButtonOff &&
      form.target !== "_blank" &&
      actionName && actionName !== "action_Download" && actionName.indexOf("action_Print") === -1) {
    buttonOff();
  }
  var id;
  require(["dojo/cookie"], function(cookie) {
    id = cookie("scrollAnchorId");
  });
  if (actionName && actionName !== "") {
    form.SENDACTION.name = actionName;
    // 一覧更新のコピー、新規ボタン押下時はスクロールを維持する
    if (!id || !(id.indexOf("ULCopy") !== -1 || id.indexOf("ULInsert") !== -1)) {
      removeScrollPosition();
    }
  }
  form.submit();
  if (form.target === "_blank") {
    form.target = '_self';
  }
  window.doSubmit_skipButtonOff = false;
  changeTargetCtrlDisabled();
  if (actionName && actionName !== "") {
    setTimeout(function() {
      form.elements[actionName].name = 'SENDACTION';
    }, 10);
  }
}

function doConfirmSubmitForm(form, actionName, message) {
  if (actionName === "action_ULExecute") {
    if (!isFormValid(form)) {
      return;
    }
  }
  showConfirmDialog(message, function() {
    doSubmitForm(form, actionName, true);
  });
}

function disablePankuzu() {
  require(["dojo/dom-attr", "dojo/dom-style", "dojo/query"], function(domAttr, domStyle, query) {
    query("ul[id='pankuzu'] a").forEach(function(node) {
      domAttr.set(node, "disabled", "true");
      domAttr.set(node, "href", "javascript:void(0)");
      node.onclick = function(event) { event.preventDefault(); };
    });
  });
}
function decodeHtml(s) {
    return s.replace(/&#0?39;/g, "'").replace(/&#0?34;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>');
}

var FixTableHeaderRowColumn = function() {
  this.initialize.apply(this, arguments);
}
FixTableHeaderRowColumn.prototype = {
  //コンストラクタ
  initialize: function(args) {
    // ヘッダ行固定とする一覧の id 属性接頭辞
    this.modelId = args.modelId || "";
    // フッタ(集計欄)のラベル幅
    this.FOOTER_LABEL_WIDTH = 45;
    // スクロールバー表示時のパディング幅
    this.SCROLLBAR_WIDTH = 17;
    // テーブルを囲むdivタグ
    this.tableContainer;
  },

  init: function() {
    var that = this;
    require(["dojo/dom", "dojo/dom-style", "dojo/query"], function(dom, domStyle, query) {
      // 左右ヘッダ行テーブル
      that.header1_left = dom.byId(that.modelId + "_header1_left");
      that.header1 = dom.byId(that.modelId + "_header1");
      // 左右値行テーブル
      that.body1_left = dom.byId(that.modelId + "_body1_left");
      that.body1 = dom.byId(that.modelId + "_body1");
      // 集計欄表示時の外枠
      that.body0_left = dom.byId(that.modelId + "_body0_left");
      that.body0 = dom.byId(that.modelId + "_body0");
      // 左右フッタ(集計欄)行テーブル
      that.footer1_left = dom.byId(that.modelId + "_footer1_left");
      that.footer1 = dom.byId(that.modelId + "_footer1");
      if (!that.body1) {
        return;
      }
      // テーブルの列幅を固定する
      that.fixTableColumnSize();

      // 列固定の場合、左側のテーブルを固定する
      if (that.header1_left || that.body1_left) {
        that.fixLeftTable();
      }
      // テーブルを固定する
      if (that.header1 || that.body1) {
        that.fixTable();
      }
      // 分割したテーブルの接続部分の角丸設定を無効にする
      that.setBorderRadius();
    });
  },

  fixTableColumnSize: function() {
    if (this.header1_left || this.body1_left) {
      // 左側のテーブルの列幅をセットする
      this.setTableColumnSize(this.header1_left, this.body1_left, this.footer1_left);
    }
    if (this.header1 || this.body1) {
      // テーブルの列幅をセットする
      this.setTableColumnSize(this.header1, this.body1, this.footer1);
    }
    // 分割したテーブルを固定レイアウトにする
    this.setTableLayoutFixed();
  },

  fixLeftTable: function() {
    if (this.header1_left) {
      var tableContainer = this.header1_left.parentNode.parentNode;
      if (tableContainer) {
        require(["dojo/dom-style"], function(domStyle) {
          var display = domStyle.get(tableContainer, "display");
          if (display !== "flex") {
            domStyle.set(tableContainer, "display", "flex");
          }
        });
      }
      // 左右のヘッダ行の高さを合わせる
      this.setTableRowSize(this.header1_left, this.header1);
      if (!this.body1_left) {
        return;
      }
    }
    // 左右のテーブルの値行の高さを合わせる
    this.setTableRowSize(this.body1_left, this.body1);
    // 左側のテーブルは縦スクロールバーを非表示にする
    var that = this;
    require(["dojo/dom-style", "dojo/on"], function(domStyle, on) {
      domStyle.set(that.body1_left, "overflowY", "hidden");
      // フッタテーブルがある場合横スクロールバーも非表示にする
      var overflowX = "auto";
      if (that.footer1_left) {
        overflowX = "hidden";
      }
      domStyle.set(that.body1_left, "overflowX", overflowX);
      // 左右のテーブルの縦スクロールを同期させる
      var bodyLeft = that.body1_left;
      var bodyRight = that.body1;
      if (that.body0_left) {
        // 集計欄がある場合
        domStyle.set(that.body0_left, "overflowY", "hidden");
        bodyLeft = that.body0_left;
        bodyRight = that.body0;
      }
      on(bodyRight, "scroll", function() {
        bodyLeft.scrollTop = bodyRight.scrollTop;
      });
    });
    // 左側のテーブルのスクロールイベントを設定する
    this.setScrollEvent(this.header1_left, this.body1_left, this.footer1_left);
  },

  fixTable: function() {
    // ボディ部に縦スクロールバーが表示された場合、ヘッダ部にスクロールバーの幅を加える
    var that = this;
    require(["dojo/dom-style", "dojo/query"], function(domStyle, query) {
      var body1Height = domStyle.get(that.body1, "height");
      var body0Height;
      if (that.body0) {
        body0Height = domStyle.get(that.body0, "maxHeight");
      }
      query("table[class*='display_table']", that.body1).forEach(function(node) {
        var body1TableHeight = domStyle.get(node, "height");
        if (that.header1 && body1TableHeight) {
          // 縦スクロールバー表示幅の分 div タグの幅を短くする
          if (body0Height && (body1TableHeight > body0Height) ||
              body1Height && (body1TableHeight > body1Height)) {
            var headerWidth = "99%";
            var headerClientWidth = that.header1.clientWidth || 0;
            if (headerClientWidth > 0) {
              headerWidth = (headerClientWidth - that.SCROLLBAR_WIDTH) + "px";
            }
            domStyle.set(that.header1, "width", headerWidth);
            // スクロールバー表示時のパディング幅
            var scrollbarPadding = that.SCROLLBAR_WIDTH + "px";
            // 横スクロールバーが表示されている場合、パディング幅を調整する
            if (node.clientWidth > that.body1.clientWidth) {
              var padding = node.clientWidth - that.body1.clientWidth;
              if (padding < 24) {
                scrollbarPadding = padding + "px";
              }
              domStyle.set(that.header1, "marginRight", scrollbarPadding);
              domStyle.set(that.body1, "marginRight", scrollbarPadding);
            }
            if (body0Height) {
              domStyle.set(that.body0, "marginRight", scrollbarPadding);
            }
          }
        }
      });
      that.setPaddingForHorizontalScroll(domStyle);
    });
    // テーブルのスクロールイベントを設定する
    this.setScrollEvent(this.header1, this.body1, this.footer1);
  },

  setPaddingForHorizontalScroll: function(domStyle) {
    var that = this;
    if (!this.body1_left || that.body0) {
      return;
    }
    var isSetPaddingBodyLeft = false;
    // 左側のテーブルに横スクロールバーが表示されている場合、スクロールバーの高さ分パディングを加える
    var body1LeftScrollWidth = that.body1_left.scrollWidth;
    var body1LeftClientWidth = that.body1_left.clientWidth;
    if (body1LeftScrollWidth > body1LeftClientWidth) {
      domStyle.get(that.body1_left, "paddingBottom", that.SCROLLBAR_WIDTH);
      isSetPaddingBodyLeft = true;
    }
    var body1ScrollWidth = that.body1.scrollWidth;
    var body1ClientWidth = that.body1.clientWidth;
    if (body1ScrollWidth > body1ClientWidth) {
      // 右側のテーブルに横スクロールバーが表示されている場合、スクロールバーの高さ分パディングを加える
      domStyle.get(that.body1, "paddingBottom", that.SCROLLBAR_WIDTH);
    } else if (isSetPaddingBodyLeft) {
      // 左側のテーブルに横スクロールバーが表示されている場合、右側のテーブルの縦表示エリアを縮める
      domStyle.set(that.body1, "maxHeight", (that.body1.clientHeight - that.SCROLLBAR_WIDTH) + "px");
    }
  },

  setTableColumnSize: function(header, body, footer) {
    var that = this;
    if (!(header || body)) {
      return;
    }
    require(["dojo/dom-attr", "dojo/dom-style", "dojo/query"], function(domAttr, domStyle, query) {
      var headerTable;
      var bodyTableTdQuery = "tr[class*='display_field']:";
      // ヘッダテーブルの有無により値行の対象を変更する
      if (header) {
        headerTable = header;
        bodyTableTdQuery += "first-child > td:not([style*='display: none'])";
      } else {
        headerTable = body;
        bodyTableTdQuery += "nth-child(2) > td:not([style*='display: none'])";
      }
      // ヘッダ行の列を取得する
      var headerColumns = query("table[class*='display_table'] tr:first-child > th:not([style*='display: none'])", headerTable);
      var bodyColumns = query(bodyTableTdQuery, body);
      var footerColumns = null;
      if (footer) {
        footerColumns = query("table[class*='display_table'] tr:first-child > td:not([style*='display: none'])", footer);
      }

      headerColumns.forEach(function(th, index) {
        var bodyColumn = bodyColumns[index];
        var footerColumn;
        if (footer) {
          footerColumn = footerColumns[index];
        }
        var width = that.getMaxColumnWidth(th, bodyColumn, footerColumn);
        that.setColumnWidth(th, width);
        that.setColumnWidth(bodyColumn, width);
        that.setColumnWidth(footerColumn, width);
      });
    });
  },

  getMaxColumnWidth: function(headerColumn, bodyColumn, footerColumn) {
    var headerWidth = this.getMaxWidth(headerColumn);
    var footerWidth = 0;
    if (this.isFooterColumnAggregateLabel(footerColumn)) {
      // 集計欄がある場合、先頭列は集計ラベルを表示するため、
      // ラベル表示用に最低幅を確保しておく
      footerWidth = this.FOOTER_LABEL_WIDTH;
    } else {
      footerWidth = this.getMaxWidth(footerColumn);
    }
    return Math.max(headerWidth, this.getMaxWidth(bodyColumn), footerWidth);
  },

  isFooterColumnAggregateLabel: function(footerColumn) {
    if (!footerColumn) {
      return false;
    }
    if (footerColumn.children.length === 0) {
      return false;
    }
    return footerColumn.children[0].tagName === "SPAN";
  },

  getMaxWidth: function(td) {
    if (!td) {
      return 0;
    }
    var maxWidth = 0;
    require(["dojo/dom-attr", "dojo/dom-style"], function(domAttr, domStyle) {
      var attrWidth = domAttr.get(td, "width");
      if (attrWidth && attrWidth.indexOf("%") !== -1) {
        maxWidth = attrWidth;
      } else {
        if (attrWidth) {
          attrWidth = parseInt(attrWidth.replace("px", ""), 10) || 0;
        }
        var styleWidth = parseInt(domStyle.get(td, "width"), 10) || 0;
        var clientWidth = td.clientWidth || 0;
        if (td.children && td.children.length > 0 &&
            (td.children[0].tagName === "SPAN" || td.children[0].tagName === "DIV")) {
          var cssClass = domAttr.get(td.children[0], "class");
          if (cssClass && (cssClass.indexOf("dijitCheckBox") !== -1 || cssClass.indexOf("dijitButton") !== -1)) {
            clientWidth = td.children[0].offsetWidth;
            styleWidth = clientWidth;
          }
        }
        var styleMaxWidth = domStyle.get(td, "maxWidth") || 0;
        if (styleMaxWidth) {
          maxWidth = styleMaxWidth;
        } else {
          if (attrWidth > maxWidth) {
            maxWidth = attrWidth;
          }
          if (styleWidth > maxWidth) {
            maxWidth = styleWidth;
          }
          if (clientWidth > maxWidth) {
            maxWidth = clientWidth;
          }
        }
      }
    });
    return maxWidth;
  },

  setColumnWidth: function(column, width) {
    if (!column) {
      return;
    }
    require(["dojo/dom-style"], function(domStyle) {
      domStyle.set(column, "width", width + "px");
    });
  },

  setTableRowSize: function(leftTable, rightTable) {
    if (!(leftTable && rightTable)) {
      return;
    }
    var that = this;
    require(["dojo/dom-attr", "dojo/dom-style", "dojo/query"], function(domAttr, domStyle, query) {
      // 左側のテーブルの行を取得する
      var leftTableRows = query("table[class*='display_table'] > tbody > tr", leftTable);
      // 右側のテーブルの行を取得して左右の行で大きい方へ合わせる
      query("table[class*='display_table'] > tbody > tr", rightTable).forEach(function(rightTr, index) {
        var leftTr = leftTableRows[index];
        if (leftTr) {
          var height = that.getMaxHeight(leftTr);
          var rightTrHeight = that.getMaxHeight(rightTr);
          if (rightTrHeight > height) {
            height = rightTrHeight;
          }
          domStyle.set(leftTr, "height", height + "px");
          domStyle.set(rightTr, "height", height + "px");
        }
      });
    });
  },

  getMaxHeight: function(tr) {
    if (!tr) {
      return 0;
    }
    var maxHeight = 0;
    require(["dojo/dom-attr", "dojo/dom-style"], function(domAttr, domStyle) {
      var attrHeight = parseInt(domAttr.get(tr, "height"), 10) || 0;
      var styleHeight = parseInt(domStyle.get(tr, "height"), 10) || 0;
      var clientHeight = tr.clientHeight || 0;
      if (attrHeight > maxHeight) {
        maxHeight = attrHeight;
      }
      if (styleHeight > maxHeight) {
        maxHeight = styleHeight;
      }
      if (clientHeight > maxHeight) {
        maxHeight = clientHeight;
      }
    });
    return maxHeight;
  },

  setTableLayoutFixed: function() {
    var that = this;
    // 固定レイアウトを解除するために設定変更対象のテーブルを配列に保持する
    this.targetTables = [];
    require(["dojo/_base/array", "dojo/dom-style", "dojo/query"], function(array, domStyle, query) {
      if (that.header1_left) {
        Array.prototype.push.apply(that.targetTables, query("table[class*='display_table']", that.header1_left));
      }
      if (that.header1) {
        Array.prototype.push.apply(that.targetTables, query("table[class*='display_table']", that.header1));
      }
      if (that.body1_left) {
        Array.prototype.push.apply(that.targetTables, query("table[class*='display_table']", that.body1_left));
      }
      if (that.body1) {
        Array.prototype.push.apply(that.targetTables, query("table[class*='display_table']", that.body1));
      }
      if (that.footer1_left) {
        Array.prototype.push.apply(that.targetTables, query("table[class*='display_table']", that.footer1_left));
      }
      if (that.footer1) {
        Array.prototype.push.apply(that.targetTables, query("table[class*='display_table']", that.footer1));
      }
      array.forEach(that.targetTables, function(table) {
        domStyle.set(table, "tableLayout", "fixed");
      });
    });
  },

  releaseTableLayoutFixed: function() {
    var that = this;
    require(["dojo/_base/array", "dojo/dom-style"], function(array, domStyle) {
      array.forEach(that.targetTables, function(table) {
        domStyle.set(table, "tableLayout", "auto");
      });
    });
  },

  setScrollEvent: function(header, body, footer) {
    if (!(header || footer)) {
      return;
    }
    var scrollNode = footer || body;
    var that = this;
    require(["dojo/on"], function(on) {
      if (footer) {
        on(body, "scroll", function() {
          footer.scrollLeft = body.scrollLeft;
        });
        on(footer, "scroll", function() {
          setTimeout(function() {
            header.scrollLeft = footer.scrollLeft;
            body.scrollLeft = footer.scrollLeft;
          }, 130);
        });
      } else {
        on(body, "scroll", function() {
          header.scrollLeft = body.scrollLeft;
        });
      }
    });
  },

  setBorderRadius: function() {
    // 集計欄の表示がある場合、分割されたテーブルの接地部分の角丸設定を無効にする
    if (!this.footer1) {
      return;
    }
    var that = this;
    require(["dojo/dom-style", "dojo/query"], function(domStyle, query) {
      // 値表示のテーブル
      if (that.body1_left) {
        query("table[class*='display_table']", that.body1_left).style("borderBottomLeftRadius", "0px");
        query("table[class*='display_table'] tr:last-child", that.body1_left).style("borderBottomLeftRadius", "0px");
        query("table[class*='display_table'] tr:last-child > td:first-child", that.body1_left).style("borderBottomLeftRadius", "0px");
      } else {
        query("table[class*='display_table']", that.body1).style("borderBottomLeftRadius", "0px");
        query("table[class*='display_table'] tr:last-child", that.body1).style("borderBottomLeftRadius", "0px");
        query("table[class*='display_table'] tr:last-child > td:first-child", that.body1).style("borderBottomLeftRadius", "0px");
      }
      query("table[class*='display_table']", that.body1).style("borderBottomRightRadius", "0px");
      query("table[class*='display_table'] tr:last-child", that.body1).style("borderBottomRightRadius", "0px");
      query("table[class*='display_table'] tr:last-child > td:last-child", that.body1).style("borderBottomRightRadius", "0px");

      // 集計欄
      if (that.footer1_left) {
        query("table[class*='display_table']", that.footer1_left).style("borderTopLeftRadius", "0px");
        query("table[class*='display_table'] tr:first-child", that.footer1_left).style("borderTopLeftRadius", "0px");
        query("table[class*='display_table'] tr:first-child > td:first-child", that.footer1_left).style("borderTopLeftRadius", "0px");
        query("table[class*='display_table']", that.footer1_left).style("borderTopRightRadius", "0px");
        query("table[class*='display_table'] tr:first-child", that.footer1_left).style("borderTopRightRadius", "0px");
        query("table[class*='display_table'] tr:first-child > td:last-child", that.footer1_left).style("borderTopRightRadius", "0px");
        query("table[class*='display_table']", that.footer1_left).style("borderBottomRightRadius", "0px");
        query("table[class*='display_table'] tr:last-child", that.footer1_left).style("borderBottomRightRadius", "0px");
        query("table[class*='display_table'] tr:last-child > td:last-child", that.footer1_left).style("borderBottomRightRadius", "0px");
        query("table[class*='display_table'] ", that.footer1).style("borderBottomLeftRadius", "0px");
        query("table[class*='display_table'] tr:last-child", that.footer1).style("borderBottomLeftRadius", "0px");
        query("table[class*='display_table'] tr:last-child > td:first-child", that.footer1).style("borderBottomLeftRadius", "0px");
      }
      query("table[class*='display_table']", that.footer1).style("borderTopLeftRadius", "0px");
      query("table[class*='display_table'] tr:first-child", that.footer1).style("borderTopLeftRadius", "0px");
      query("table[class*='display_table'] tr:first-child > td:first-child", that.footer1).style("borderTopLeftRadius", "0px");
      query("table[class*='display_table']", that.footer1).style("borderTopRightRadius", "0px");
      query("table[class*='display_table'] tr:first-child", that.footer1).style("borderTopRightRadius", "0px");
      query("table[class*='display_table'] tr:first-child > td:last-child", that.footer1).style("borderTopRightRadius", "0px");
    });
  }
}

CtrlDisableManagerList = new Array();

function addCtrlDisableManager(cdm) {
    CtrlDisableManagerList.push(cdm); 
}

function changeTargetCtrlDisabled() {
   for (i in CtrlDisableManagerList) {
      (CtrlDisableManagerList[i]).changeTargetCtrlDisabled();
   }
}

/**
 * オプション表示(日付)の和暦の1年を元年へ変更する関数
 */
function replaceFirstYearOfImperialEra(dateStr) {
  if (!isReplaceFirstYearOfImperialEra) {
    return dateStr;
  }
  var replacedDateStr = dateStr;
  var firstYearOfImperialEra = new RegExp("^（(" + warekiFullnameStr + ")1年(.*)）");
  if (firstYearOfImperialEra.test(dateStr)) {
    replacedDateStr = dateStr.replace(firstYearOfImperialEra, "（$1元年$2）");
  }
  return replacedDateStr;
}

function convClassname4Relax(s) {
  if (!s || s === "") {
    return s;
  }
  var convStr = "";
  for (var i=0,l=s.length; i<l; i++) {
    var c = s.charAt(i);
    if (c === "_") {
      while (i+1 < s.length && (c = s.charAt(++i)) === "_") ;
      if (c !== "_") {
        convStr += c.toUpperCase();
      }
    } else {
      convStr += c;
    }
  }
  return convStr;
}

function capFirst(str) {
  if (!str || str === "") {
    return str;
  }
  var name = convClassname4Relax(str);
  return name.substring(0, 1).toUpperCase() + name.substring(1);
}

function showConfirmDialog(msg, okCallback, cancelCallback) {
  showDijitConfirm({
    "message": msg,
    "onExecute": okCallback,
    "onCancel": cancelCallback,
  });
}

var confirmDialog;
var confirmDialogArgs;
function showDijitConfirm(args) {
  if (!window.confirmDialog) {
    confirmDialogArgs = {
      "title": getPagetitle(),
      "type": args.type || "Confirm",
      "icon": args.icon,
      "style": args.style,
      "message": args.message || "",
      "onExecute": args.onExecute,
      "onCancel": args.onCancel,
      "onShow": args.onShow,
      "onHide": args.onHide,
    };
    createConfirmDialog(confirmDialogArgs, function(dialog) {
      window.confirmDialog = dialog;
      dialog.show();
    });
  } else {
    confirmDialogArgs.type = args.type;
    confirmDialogArgs.icon = args.icon;
    window.confirmDialog.setEventCallbackFunc(args);
    window.confirmDialog.updateMessage(args.message);
    window.confirmDialog.show();
  }
}

var alertDialog;
function showAlertDialog(message, callback) {
  if (!window.alertDialog) {
    createConfirmDialog({
      "title": getPagetitle(),
      "type": "alert",
      "message": message || "",
    }, function(dialog) {
      window.alertDialog = dialog;
      var callbackFunc = {};
      if (callback) {
        callbackFunc.onExecute = callback;
        callbackFunc.onHide = callback;
      }
      dialog.setEventCallbackFunc(callbackFunc);
      dialog.show();
    });
  } else {
    window.alertDialog.updateMessage(message);
    var callbackFunc = {};
    if (callback) {
      callbackFunc.onExecute = callback;
      callbackFunc.onHide = callback;
    }
    window.alertDialog.setEventCallbackFunc(callbackFunc);
    window.alertDialog.show();
  }
}

function createConfirmDialog(args, callback) {
  var that = this;
  require(["dijit/ConfirmDialog", "dojo/aspect", "dojo/dom-construct", "dojo/dom-style"], function(ConfirmDialog, aspect, domConstruct, domStyle) {
    var dialog = new ConfirmDialog({
      title: args.title || getAppname(),
      style: args.style || "width: 350px",
      autofocus: false,
      actionBarTemplate: args.actionBarTemplate || "<div class='dijitDialogPaneActionBar' data-dojo-attach-point=\"actionBarNode\">\n\t<button data-dojo-type='dijit/form/Button' id='jfc" + args.type + "DialogBtnOk' type='submit' data-dojo-attach-point=\"okButton\"></button>\n\t<button data-dojo-type='dijit/form/Button' id='jfc" + args.type + "DialogBtnCancel' type='button'\n\t\t\tdata-dojo-attach-point=\"cancelButton\" data-dojo-attach-event='click:onCancel'></button>\n</div>\n",
    });
    // サブメニューを上に表示している場合、ダイアログが表示されるとスクロール位置が
    // 画面下部になるため、ダイアログ表示前のスクロール位置を保持しておく
    var scrollY = 0;
    if (window.submenuDisplayArea === "top") {
      aspect.before(dialog, "show", function() {
        scrollY = window.scrollY;
      });
    }
    domStyle.set(dialog.actionBarNode, {
      'border': "none",
      'background-color': "#fff",
      'text-align': "right",
      'padding': "10px"
    });
    domStyle.set(dialog.okButton.focusNode, 'min-width', "70px");
    domStyle.set(dialog.cancelButton.focusNode, 'min-width', "70px");
    dialog.okButton.set("label", args.okButtonLabel || res.BUTTON_OK);
    dialog.cancelButton.set("label", args.cancelButtonLabel || res.BUTTON_CANCEL);

    var messageDom = domConstruct.create("span", { innerHTML: args.message || "" }, dialog.containerNode);
    dialog.updateMessage = function(message) {
      messageDom.innerHTML = message || "";
    }
    var confirmIcon = domConstruct.create("i", {
      "class": "fas fa-exclamation-triangle jfcConfirmIcon",
      "style": "display: none;",
    }, dialog.containerNode, "first");
    var alertIcon = domConstruct.create("i", {
      "class": "fas fa-minus-circle jfcAlertIcon",
      "style": "display: none;",
    }, dialog.containerNode, "first");
    var infoIcon = domConstruct.create("i", {
      "class": "fas fa-info-circle jfcAlertIcon",
      "style": "display: none;color: #3333CC;",
    }, dialog.containerNode, "first");
    var questionIcon = domConstruct.create("i", {
      "class": "fas fa-question-circle jfcAlertIcon",
      "style": "display: none;color: #3333CC;",
    }, dialog.containerNode, "first");

    dialog.on("Show", function() {
      var display = "";
      var icon = args.icon;
      if (args.type && args.type.lastIndexOf("alert", 0) === 0) {
        if (! icon) {
          icon = "alert";
        }
        display = "none";
      } else {
        if (! icon) {
          icon = "confirm";
        }
      }
      if (icon === "none") {
      } else if (icon === "alert") {
        domStyle.set(alertIcon, "display", "block");
      } else if (icon === "confirm") {
        domStyle.set(confirmIcon, "display", "block");
      } else if (icon === "info") {
        domStyle.set(infoIcon, "display", "block");
      } else if (icon === "question") {
        domStyle.set(questionIcon, "display", "block");
      }
      if (icon !== "alert") {
        domStyle.set(alertIcon, "display", "none");
      }
      if (icon !== "confirm") {
        domStyle.set(confirmIcon, "display", "none");
      }
      if (icon !== "info") {
        domStyle.set(infoIcon, "display", "none");
      }
      if (icon !== "question") {
        domStyle.set(questionIcon, "display", "none");
      }
      domStyle.set(dialog.cancelButton.domNode, "display", display);
      dialog.okButton.focus();
      if (window.submenuDisplayArea === "top") {
        window.scrollTo(0, scrollY);
      }
    });
    that.createDialogSetEventCallbackFunc(dialog);
    dialog.setEventCallbackFunc(args);
    if (callback) {
      callback(dialog);
    }
  });
}

function createDialogSetEventCallbackFunc(dialog) {
  dialog.on("Execute", function() {
    dialog.onExecuteFunc();
  });
  dialog.on("Cancel", function() {
    dialog.onCancelFunc();
  });
  dialog.on("Show", function() {
    dialog.onShowFunc();
  });
  dialog.on("Hide", function() {
    dialog.onHideFunc();
  });
  dialog.setEventCallbackFunc = function(args) {
    dialog.onExecuteFunc = args.onExecute || function(){};
    dialog.onCancelFunc = args.onCancel || function(){};
    dialog.onShowFunc = args.onShow || function(){};
    dialog.onHideFunc = args.onHide || function(){};
  }
}

function getAppname() {
  var appname = " ";
  require(["dojo/dom"], function(dom) {
    var appnameinfo = dom.byId("appnameinfo");
    if (appnameinfo) {
      appname = appnameinfo.innerHTML;
    }
  });
  return appname;
}

function getPagetitle() {
  var pagetitle;
  require(["dojo/query"], function(query) {
    var pagetitleDom = query("div.pagetitle");
    if (pagetitleDom && pagetitleDom.length > 0) {
      pagetitle = pagetitleDom[0].innerHTML;
    }
  });
  return pagetitle;
}

function getOpenSearchListOverlayFunc(args) {
  if (!args) {
    return function(){};
  }
  var overlay;
  require(['dijit/registry'], function(registry) {
    overlay = registry.byId(args.overlayId);
  });
  if (!overlay) {
    return function(){};
  }
  var grid = args.getGridFunc;
  if (!grid) {
    return;
  }
  return function() {
	idElement = args.idElement;
    contentElement = args.contentElement;
    grid.setContentValueFunc(function(row) {
      if (row) {
        args.setValueFunc(row.data[args.valueId], row.data[args.contentId]);
      }
      overlay.hide();
    });
    overlay.show();
    setTimeout(function() {
      grid.setOverlaySearchEvent();
    }, 10);
  }
}

function setJfcToolBarBtnSearchClickEvent() {
  require(['dojo/_base/connect', 'dojo/dom-style', 'dojo/query', 'dijit/registry', 'dojo/ready'], function(connect, domStyle, query, registry, ready) {
    var changeToolBarBtnSearchProperties = function(moveTo) {
      var toolBarBtnSearch = registry.byId('jfcToolBarBtnSearch');
      if (!toolBarBtnSearch) {
        return;
      }
      var moveNext = "showList";
      var transitionDir = 1;
      if (moveTo !== "condition") {
        moveNext = "condition";
        transitionDir = -1;
      }
      toolBarBtnSearch.set("moveTo", moveNext);
      toolBarBtnSearch.set("transitionDir", transitionDir);
    }
    var getDisplayResultCountFunc = function() {
      var resultcounts = query("div.display_resultcount");
      if (!resultcounts || resultcounts.length === 0) {
        return function(){}
      }
      var resultcountDiv = resultcounts[0];

      return function(moveTo) {
        var display = "";
        if (moveTo === "condition") {
          // 検索画面の場合は検索件数を非表示にする
          display = "none";
        }
        domStyle.set(resultcountDiv, "display", display);
      }
    }

    ready(function() {
      var conditionView = registry.byId('condition');
      var showListView = registry.byId('showList');
      if (!conditionView || !showListView) {
        return;
      }
      // 検索件数表示・非表示の関数
      var displayResultCountFunc = getDisplayResultCountFunc();

      // 検索条件入力フォームビュー表示前のイベント
      connect.connect(conditionView, "onBeforeTransitionIn", null,
        function(moveTo, dir, transition, context, method) {
          // 検索条件入力フォームビュー表示前に検索件数を非表示にする
          displayResultCountFunc(moveTo);
      });
      // 検索条件入力フォームビュー表示後のイベント
      connect.connect(conditionView, "onAfterTransitionIn", null,
        function(moveTo, dir, transition, context, method) {
          // 検索ボタンのプロパティを変更する
          changeToolBarBtnSearchProperties(moveTo);
      });
      // 一覧表示ビュー表示後のイベント
      connect.connect(showListView, "onAfterTransitionIn", null,
        function(moveTo, dir, transition, context, method) {
          // 検索件数を表示する
          displayResultCountFunc(moveTo);
          // 検索ボタンのプロパティを変更する
          changeToolBarBtnSearchProperties(moveTo);
      });
    });
  });
}

function setTouchScrollDisableEvent() {
  require(["dijit/registry", "dojo/dom-class", "dojo/query", "dojo/ready"], function(registry, domClass, query, ready) {
    ready(function() {
      var mainScrollableView = registry.byId('mainScrollableView');
      if (!mainScrollableView) {
        return;
      }
      query("div.mblRoundRect").forEach(function(node) {
        if (node.children && node.children.length > 0 && domClass.contains(node.children[0], "mblScrollableView")) {
          setScrollDisableFunc(mainScrollableView, node.previousElementSibling);
        }
      });
    });

    var setScrollDisableFunc = function(mainScrollableView, containerTitle) {
      if (!domClass.contains(containerTitle, "mblRoundRectCategory")) {
        return;
      }
      var title = registry.byId(containerTitle.id);
      if (!title) {
        return;
      }
      var stopScroll = false;
      title.on("click", function() {
        stopScroll = !stopScroll;
        mainScrollableView.set("disableTouchScroll", stopScroll);
      });
    }
  });
}

function setCheckboxSearchButtonClickEventFunc(id, callbackFunc, registry) {
  var btn = registry.byId(id);
  if (!btn) {
    return;
  }
  btn.on("click", callbackFunc);
}

function setCheckboxSearchButtonEventFunc(btnId, labelid, relationIdref, relationPkey, form, props, actionParamFunc) {
  require(["dijit/registry", "dojo/dom-construct", "dojo/query"], function(registry, domConstruct, query) {
    if (btnId.indexOf("${__position.count}") === -1) {
      setCheckboxSearchButtonClickEventFunc(
        btnId,
        getCheckboxSearchButtonClickEventFunc(labelid.split("${fn:escapeXml(c.id)}"), relationIdref, relationPkey, form, domConstruct, query, registry, props, actionParamFunc),
        registry
      );
    } else {
      var buttonId = btnId.split("${__position.count}");
      query("input[name^='" + buttonId[0] + "'][name$='" + buttonId[1] + "']").forEach(function(node, index) {
        var checkboxId = labelid.replace("${__position.count}", index + 1);
        checkboxId = checkboxId.split("${fn:escapeXml(c.id)}");
        setCheckboxSearchButtonClickEventFunc(
          node.name,
          getCheckboxSearchButtonClickEventFunc(checkboxId, relationIdref, relationPkey, form, domConstruct, query, registry, props, actionParamFunc, index + 1),
          registry
        );
      });
    }
  });
}

function getCheckboxSearchButtonClickEventFunc(checkboxId, relationIdref, relationPkey, form, domConstruct, query, registry, props, actionParamFunc, containerPosition) {
  var windowName = getCheckboxSearchWindowName(checkboxId);
  return function() {
    var selectedPkeys = [];
    var queryString = "input[type='checkbox'][name^='" + checkboxId[0] + "'][name$='" + checkboxId[1] + "']:checked";
    query(queryString).forEach(function(node) {
      selectedPkeys.push(node.value);
    });
    var actionName = "searchList" + relationIdref + ".do";
    if (typeof actionParamFunc === 'function') {
      actionName = actionName + actionParamFunc(form, containerPosition)
          + "&__jfc_use_cb=true"
    } else {
      actionName = actionName + "?__jfc_use_cb=true"
    }
    if (selectedPkeys.length !== 0) {
      for (var i=0,l=selectedPkeys.length; i<l; i++) {
        actionName = actionName + "&" + relationPkey + "_jsh_cb=" + selectedPkeys[i];
      }
    }
    createCheckcboxSearchWindowSetSelectedValueFunc(form, checkboxId, domConstruct, query, registry);
    openSearchWindow(actionName,
                     windowName,
                     null,
                     null,
                     null,
                     props);
  }
}

function getCheckboxSearchWindowName(checkboxId) {
  if (!checkboxId || checkboxId.length === 0 || !checkboxId[0]) {
    return null;
  }
  var modelAndItemId = checkboxId[0].split("$002f");
  if (!modelAndItemId || modelAndItemId.length === 0) {
    return null;
  }
  var windowName = null;
  if (modelAndItemId.length === 2 && modelAndItemId[1]) {
    // 通常項目の場合、モデルID_p_項目ID
    windowName = modelAndItemId[0];
    windowName = windowName + "_" + modelAndItemId[1].split("$005b")[0];
  } else if (modelAndItemId.length === 3 &&
             modelAndItemId[1] && modelAndItemId[2]) {
    // コンテナ内の項目の場合、コンテナID_項目ID
    windowName = modelAndItemId[1].split("$005b")[0];
    windowName = windowName + "_" + modelAndItemId[2].split("$005b")[0];
  }
  return windowName;
}

function createCheckcboxSearchWindowSetSelectedValueFunc(form, checkboxId, domConstruct, query, registry) {
  var actionName = "";
  if (form.id && form.id.lastIndexOf("condition", 0) === 0) {
    // 検索画面では選択したチェックボックスの値設定時の画面リロードで
    // 検索処理が行なわれないようアクション文字列を設定する
    actionName = "action_Refresh";
  }
  window.setCheckcboxSearchWindowSelectedValue = function(selectedPkeys) {
    if (!selectedPkeys) {
      return;
    }
    query("input[name^='"+checkboxId[0]+"'][name$='"+checkboxId[1]+"']").forEach(function(node) {
      var widget = registry.byId(node.id);
      if (selectedPkeys[node.value]) {
        delete selectedPkeys[node.value];
        if (!widget.get("checked")) {
          widget.set("checked", true);
        }
      } else {
        widget.set("checked", false);
      }
    });
    for (var pkey in selectedPkeys) {
      domConstruct.create("input", {
        type:"hidden",
        name: checkboxId[0] + pkey + checkboxId[1],
        value: pkey
      }, "jfc_hidden_item");
    }
    if (window.originalAction) {
      form.action = window.originalAction;
    }
    doSubmitForm(form, actionName, true);
  }
}

function setJfcBtnMenuEvent(dom, domStyle, fx, registry) {
  var jfcBtnMenu = registry.byId("jfcBtnMenu");
  if (!jfcBtnMenu) {
    return;
  }
  var borderlayout = registry.byId("dojolayout");
  var leadingarea = dom.byId('jfcLeadingarea');
  var jfcMenuDisplay = false; // サブメニューエリア表示フラグ

  // leadingarea を表示する関数
  var showMenuarea = function() {
    if (leadingarea) {
      fx.wipeIn({ node: leadingarea }).play();
    }
    borderlayout.layout();
    jfcMenuDisplay = true;
  }

  // leadingarea を隠す関数
  var hideMenuarea = function() {
    if (leadingarea) {
      fx.wipeOut({ node: leadingarea }).play();
      domStyle.set(leadingarea, "display", "none");
    }
    borderlayout.layout();
    jfcMenuDisplay = false;
  }

  var toggleMenuarea = function(e) {
    if (jfcMenuDisplay) {
      hideMenuarea();
      setJfcLeadingAreaDisplayProperty("none")
    } else {
      showMenuarea();
      setJfcLeadingAreaDisplayProperty("block")
    }
  }
  jfcBtnMenu.on("click", function(e) {
    toggleMenuarea();
  });
}

function showSubmenuTree() {
  require(["dijit/Tree", "dijit/registry", "dojo/cookie", "dojo/dom", "dojo/request", "dojo/store/Memory", "dijit/tree/ObjectStoreModel"],
  function(Tree, registry, cookie, dom, request, Memory, ObjectStoreModel) {
    window.submenuDisplayArea = "side";
    var jfcSubmenuTreeArea = dom.byId("jfcSubmenuTreeArea");
    if (!jfcSubmenuTreeArea) {
      window.submenuDisplayArea = "top";
      return;
    }
    showJfcLeadingArea(registry, cookie);
    request("rest/submenu", {
      headers: {
        'Content-Type': "application/json; charset=utf-8",
      },
      handleAs: "json"
    }).then(function(data) {
      var store = createStore(data);
      if (store) {
        createSubmenuTree(createModel(store));
      }
    }, function(err) {
      console.error("err: ", err);
    });

    var createStore = function(data) {
      if (data.status !== "success") {
        console.error("data.status error: ", data);
        return null;
      }
      var store = new Memory({
        data: data.submenu,
        getChildren: function(object) {
          return this.query({parent: object.id});
        },
      });
      return store;
    }

    var createModel = function(store) {
      var model = new ObjectStoreModel({
        store: store,
        query: {id: 'all'},
        mayHaveChildren: function(item) {
          if (item.type === "model") {
            return false;
          }
          return true;
        }
      });
      return model;
    }

    var createSubmenuTree = function(model) {
      if (!model) {
        return;
      }
      var tree = new Tree({
        id: "jfcSubmenuTree",
        model: model,
        persist: true,
        showRoot: false,
        onClick: function(item) {
          if (!item.url) {
            return;
          }
          goPage(item.url);
        },
        getIconClass: function(item, opened){
          if (item.type === "model") {
            return "dijitLeaf";
          }
          return opened ? "dijitFolderOpened" : "dijitFolderClosed";
        },
      });
      if (!tree) {
        return;
      }
      tree.placeAt(jfcSubmenuTreeArea);
      tree.startup();
    }
  });
}

function setJfcLeadingAreaDisplayProperty(display) {
  require(["dojo/cookie"], function(cookie) {
    cookie("displayJfcLeadingarea", display, { expires: 365 });
  });
}

function showJfcLeadingArea(registry, cookie) {
  var displayJfcLeadingarea = cookie("displayJfcLeadingarea");
  if (displayJfcLeadingarea === undefined) {
    return;
  }
  var jfcBtnMenu = registry.byId("jfcBtnMenu");
  if (!jfcBtnMenu) {
    return;
  }
  if (displayJfcLeadingarea === "block") {
    jfcBtnMenu.onClick();
  }
}

function setJfcKeyEventHandler(baseEvent, keys, on, dom, registry, query) {
  var keyEventHandlers = getKeyEventHandlers(keys);
  if (!keyEventHandlers || Object.keys(keyEventHandlers).length === 0) {
    return;
  }
  on(document, "keydown", function(event) {
    var keyCode = event.keyCode + "";
    var keyEventHandler = keyEventHandlers[keyCode];
    if (!keyEventHandler) {
      return;
    }
    if (event.target.tagName === "INPUT" && !(event.keyCode >= keys.F1 && event.keyCode <= keys.F12)) {
      return;
    }
    keyEventHandler(event, dom, registry, query);
    baseEvent.stop(event);
  });
}

function openLocation(href) {
  if (window.confirm_destruction && !window.confirm_destruction()) {
    return;
  }
  location.href = href;
}

function setMainMenuSelectedTabId(menuId) {
  setSelectedTabId("mainMenuSelectedTab", menuId);
}

var scriptEditorDialog;
function setScriptEditorToTextarea(condition) {
  require(["dijit/registry", "dojo/query", "wagby/ScriptEditorDialog"], function(registry, query, ScriptEditorDialog) {
    scriptEditorDialog = new ScriptEditorDialog();
    var setOpenScriptEditorEvent = function(id) {
      var textarea = registry.byId(id);
      if (!textarea) {
        return;
      }
      textarea.on("focus", function() {
        scriptEditorDialog.setScriptWidget(textarea);
        scriptEditorDialog.show();
      });
    }
    var queryString = "textarea";
    if (condition) {
      queryString = queryString + condition;
    }
    query(queryString).forEach(function(node) {
      setOpenScriptEditorEvent(node.id);
    });
  });
}

function setAvatarImage(dom, domClass, domConstruct, registry, request) {
  var jfcDrpDwnBtnGloballink = registry.byId("jfcDrpDwnBtnGloballink");
  if (!jfcDrpDwnBtnGloballink) {
    return;
  }
  domClass.remove(jfcDrpDwnBtnGloballink.iconNode, "dijitNoIcon");
  getAvatarImageSrc(dom, request, function(avatarImgSrc) {
    domConstruct.create("img", {
      "class": "avatar",
      "src": avatarImgSrc
    }, jfcDrpDwnBtnGloballink.iconNode);
  });
}

function getAvatarImageSrc(dom, request, callback) {
  var avatarText = getAvatarTextFromCache(dom);
  if (avatarText) {
    callback(avatarText)
  } else {
    getAvatarTextFromServer(request, callback);
  }
}

function getAvatarTextFromCache(dom) {
  if (!window.localStorage) {
    return null;
  }
  var jfcUserId = dom.byId("jfcUserId");
  if (!jfcUserId) {
    return null;
  }
  var user = jfcUserId.innerHTML;
  var avatarText = window.localStorage.getItem(getAvatarCacheKey(user));
  if (!avatarText) {
    return null;
  }
  return getBase64ImgSrc(avatarText);
}

function getAvatarTextFromServer(request, callback) {
  var defaultAvatarSrc = "img/defaultAvatar.png";
  request("rest/session/avatarImage", {
    headers: {
      'Content-Type': "application/x-www-form-urlencoded",
      'X-Wagby-RESTAPIVersion': "v2"
    },
    "handleAs": "json",
  }).then(function(avatar) {
    if (avatar) {
      callback(getBase64ImgSrc(avatar.avatarImage));
      setAvatarTextToCache(avatar);
    } else {
      callback(defaultAvatarSrc);
    }
  }, function(err) {
    callback(defaultAvatarSrc);
  });
}

function setAvatarTextToCache(avatar) {
  if (!window.localStorage) {
    return null;
  }
  window.localStorage.setItem(getAvatarCacheKey(avatar.username), avatar.avatarImage);
}

function getBase64ImgSrc(text, type) {
  var imgType = "png";
  if (type) {
    imgType = type;
  }
  return "data:image/" + imgType + ";base64," + text;
}

function getAvatarCacheKey(user) {
  return "wagbyAvatarImage-" + user;
}

function setUpdateListDeleteCheckboxClickEvent() {
  var setCheckboxClickEventFunc = function(checkbox, widgets) {
    checkbox.on("click", function(e) {
      for (var i=0,l=widgets.length; i<l; i++) {
        widgets[i].set("required", !e.target.checked);
      }
    });
  }
  var unsetRequiredWidegetsInDeleteRow = function(checkbox, widgets) {
    if (!checkbox.get("checked")) {
      return;
    }
    for (var i=0,l=widgets.length; i<l; i++) {
      widgets[i].set("required", false);
    }
  }

  require(["dojo/_base/array", "dojo/query", "dijit/registry"], function(array, query, registry) {
    query("input[type='checkbox'][name^='jfcdelete_']", "centerarea").forEach(function(node) {
      var widgets = registry.findWidgets(node.parentNode.parentNode.parentNode);
      var deleteCheckbox = array.filter(widgets, function(widget) {
        return widget.name && widget.name.lastIndexOf("jfcdelete_", 0) === 0;
      });
      var requiredWidgets = array.filter(widgets, function(widget) {
        return widget.required;
      });
      if (deleteCheckbox && deleteCheckbox.length > 0 &&
          requiredWidgets && requiredWidgets.length > 0) {
        setCheckboxClickEventFunc(deleteCheckbox[0], requiredWidgets);
        unsetRequiredWidegetsInDeleteRow(deleteCheckbox[0], requiredWidgets);
      }
    });
  });
}

var setShowNumOfRemainingCharEventToItems = function(id) {
  if (Array.isArray(id)) {
    for (var i=0,l=id.length; i<l; i++) {
      setShowNumOfRemainingCharEventToItem(id[i]);
    }
  } else {
    setShowNumOfRemainingCharEventToItem(id);
  }
}

var setShowNumOfRemainingCharEventToContainerItems = function(id) {
  if (!id) {
    return;
  }
  if (Array.isArray(id)) {
    for (var i=0,l=id.length; i<l; i++) {
      setShowNumOfRemainingCharEventToContainerItem(id[i].prefix, id[i].suffix);
    }
  } else {
    setShowNumOfRemainingCharEventToContainerItem(id.prefix, id.suffix);
  }
}

var setShowNumOfRemainingCharEventToContainerItem = function(prefix, suffix) {
  require(["dijit/registry"], function(registry) {
    var i = 1;
    while(true) {
      var id = prefix + i + suffix;
      var widget = registry.byId(id);
      if (!widget) {
        break;
      }
      setShowNumOfRemainingCharEventToItem(id);
      i = i + 1;
    }
  });
}

var setShowNumOfRemainingCharEventToItem = function(id) {
  require(["dijit/registry", "dojo/dom", "dojo/dom-attr", "dojo/dom-style", "dojo/query"], function(registry, dom, domAttr, domStyle, query) {
    var widget = registry.byId(id);
    if (!widget || !widget.maxLength) {
      return;
    }
    var remainingDisplayArea = dom.byId(id + "_remainingCharacter");
    if (!remainingDisplayArea) {
      return;
    }

    var getValueFunction = function(widget) {
      if (widget.declaredClass === "dijit.Editor") {
        return function() {
          return widget.get("value");
        }
      } else {
        return function(e) {
          return e.target.value;
        }
      }
    }

    var getRemainRate = function(strLength) {
      return Math.floor((widget.maxLength - strLength) / widget.maxLength * 100);
    }

    var getIconProps = function(strLength) {
      var iconProps = {
        "iconClass": "thermometer-full",
        "iconColor": "#09A318",
      };
      var remainRate = getRemainRate(strLength);
      if (remainRate > 50 && remainRate <= 75) {
        iconProps.iconClass = "thermometer-three-quarters";
      } else if (remainRate > 25 && remainRate <= 50) {
        iconProps.iconClass = "thermometer-half";
      } else if (remainRate > 10 && remainRate <= 25) {
        iconProps.iconClass = "thermometer-quarter";
        iconProps.iconColor = "#F4C722";
      } else if (remainRate > 0 && remainRate <= 10) {
        iconProps.iconClass = "thermometer-quarter";
        iconProps.iconColor = "#F92500";
      } else if (remainRate === 0) {
        iconProps.iconClass = "thermometer-empty";
        iconProps.iconColor = "#F92500";
      }
      return iconProps;
    }

    var changeIcon = function(strLength) {
      query("i", remainingDisplayArea.parentNode).forEach(function(node) {
        var iconProps = getIconProps(strLength);
        domStyle.set(node, "color", iconProps.iconColor);
        domAttr.set(node, "class", "fas fa-" + iconProps.iconClass + " fa-3x");
      });
    }

    var widgetMaxLength = widget.maxLength;
    var changeRemainingStatus = function(value) {
      var strLength = value.length;
      remainingDisplayArea.textContent = widgetMaxLength - strLength;
      changeIcon(strLength);
    }
    changeRemainingStatus(widget.get("value"));

    var getValueFunc = getValueFunction(widget);
    var eventName;
    if (widget.declaredClass === "dijit.Editor") {
      eventName = "DisplayChanged";
    } else {
      eventName = "keyup";
    }

    widget.on(eventName, function(e) {
      var value = getValueFunc(e);
      if (!value && value !== "") {
        return;
      }
      changeRemainingStatus(value);
    });
  });
}

function setBatchBtnDisabledEvent() {
  require(["dijit/registry", "dojo/_base/array", "dojo/_base/event", "dojo/on", "dojo/query"],
  function(registry, array, event, on, query) {
    const batchBtnNameRE = RegExp("All\\d*$");
    var getBatchButtons = function() {
      return array.filter(query("input[type='button'][name^='btn']"), function(node) {
        return batchBtnNameRE.test(node.name);
      }).map(function(node) {
        return registry.byNode(node.parentNode);
      });
    }

    var getBatchTargetChecks = function() {
      return array.map(query("input[type='checkbox'][name$='_jsh_cb']"), function(node) {
        return registry.byId(node.id);
      });
    }

    var isBatchTargetChecked = function() {
      return array.some(batchTargetChecks, function(chk) {
        return chk.get("checked");
      });
    }

    var setBatchButtonDisabled = function(checked) {
      var disabled;
      if (checked) {
        disabled = false;
      } else {
        disabled = !isBatchTargetChecked();
      }
      var title = "";
      if (disabled) {
        title = res.INFO_MSG_SELECT_BATCH_TARGET;
      }
      for (var i=0,l=batchButtons.length; i<l; i++) {
        if (!batchButtons[i]) {
          console.error("batch button undefined");
          continue;
        }
        batchButtons[i].set("disabled", disabled);
        batchButtons[i].set("title", title);
      }
    }

    var setBatchTargetCheckClickEvent = function() {
      for (var i=0,l=batchTargetChecks.length; i<l; i++) {
        setCheckboxClickEvent(batchTargetChecks[i]);
      }
      array.map(query("input[type='checkbox'][name='toggle_allcheck']"), function(node) {
        return registry.byId(node.id);
      }).forEach(function(chk) {
        setCheckboxClickEvent(chk);
      });
    }

    var setCheckboxClickEvent = function(checkbox) {
      checkbox.on("click", function(e) {
        e.stopPropagation();
        setBatchButtonDisabled(e.target.checked);
      });
    }

    var setBatchTargetCheckColumnClickEvent = function() {
      query("td.display_field_checkbox").forEach(function(td, row) {
        setTdClickEvent(td, row);
      });
    }

    var setTdClickEvent = function(td, row) {
      on(td, "click", function(e) {
        event.stop(e);
        var checked = !batchTargetChecks[row].get("checked");
        batchTargetChecks[row].set("checked", checked);
        setBatchButtonDisabled(checked);
      });
    }

    var batchButtons = getBatchButtons();
    if (batchButtons.length === 0) {
      return;
    }
    var batchTargetChecks = getBatchTargetChecks();
    if (batchTargetChecks.length === 0) {
      return;
    }
    setBatchTargetCheckClickEvent();
    setBatchTargetCheckColumnClickEvent();
    setBatchButtonDisabled();
  });
}

function setJgroupnodeOrgChartButtonClickEventFunc(btnId, labelid, form) {
  require(["dijit/ConfirmDialog", "dijit/registry", "dojo/dom-construct", "dojo/dom-style", "dojo/query"],
  function(ConfirmDialog, registry, domConstruct, domStyle, query) {
    var btn = registry.byId(btnId);
    if (!btn) {
      return;
    }
    btn.on("click", function() {
      groupHierarchyDialog.show();
    });

    var checkboxId = labelid.split("${fn:escapeXml(c.id)}");
    var orgChart;

    var groupHierarchyDialog = new ConfirmDialog({
      "content": "<div id=\"jfcGroupnodeOrgChartContainer\"></div>",
      "title": res.LABEL_JFCGROUPNODE_GROUP_HIERARCHY_TAB,
    });
    groupHierarchyDialog.on("Show", function() {
      createOrgChart();
      setCheckedGroupInOrgChart();
    });
    groupHierarchyDialog.okButton.on("click", function() {
      setSelectedGroupid();
    });

    function createOrgChart() {
      if (datasource == null) {
        return;
      }
      domConstruct.empty("jfcGroupnodeOrgChartContainer");
      orgChart = $("#jfcGroupnodeOrgChartContainer").orgchart({
        'data': datasource,
        'hideRootNode': true,
        'nodeSelectToggle': true,
        'parentNodeSymbol': null,
      });
      $('.leftEdge').removeClass('leftEdge');
      $('.rightEdge').removeClass('rightEdge');
      // root ノードと下線を非表示にする
      query("#jfcGroupnodeOrgChartContainer > div.orgchart > table > tr:first-child,#jfcGroupnodeOrgChartContainer > div.orgchart > table > tr:nth-child(2),#jfcGroupnodeOrgChartContainer > div.orgchart > table > tr:nth-child(3)").forEach(function(rootNode) {
        domStyle.set(rootNode, "display", "none");
      });
    }

    function setCheckedGroupInOrgChart() {
      query("input[name^='" + checkboxId[0] + "'][name$='" + checkboxId[1] + "']").forEach(function(node) {
        $("#" + node.value).addClass('focused');
      });
    }

    function setSelectedGroupid() {
      var selectedIds = getSelectedIds();
      query("input[name^='" + checkboxId[0] + "'][name$='" + checkboxId[1] + "']").forEach(function(node) {
        var widget = registry.byId(node.id);
        if (widget) {
          if (selectedIds[node.value]) {
            delete selectedIds[node.value];
            if (!widget.get("checked")) {
              widget.set("checked", true);
            }
          } else {
            widget.set("checked", false);
          }
        }
      });
      for (var id in selectedIds) {
        domConstruct.create("input", {
          type:"hidden",
          name: checkboxId[0] + id + checkboxId[1],
          value: id,
        }, "jfc_hidden_item");
      }
      doSubmitForm(form, null, true);
    }

    function getSelectedIds() {
      var selectedIds = {};
      var selectedNodes = orgChart.$chart.find('.node.focused');
      if (!selectedNodes || selectedNodes.length === 0) {
        return selectedIds;
      }
      for (var i=0,l=selectedNodes.length; i<l; i++) {
        var node = selectedNodes[i];
        selectedIds[node.id] = true;
      }
      return selectedIds;
    }

  });
}

function interpretContentByLocale(resource, JSON) {
  if (!resource) {
    return "";
  }
  if (!(resource.lastIndexOf("{", 0) === 0 && resource.lastIndexOf("}") === resource.length - 1)) {
    return resource;
  }
  var content = JSON.parse(resource);
  var locale = browser_locale;
  if (locale && locale.length > 2) {
    locale = locale.substring(0, 2);
  }
  return content[locale] || "";
}

function setSeparatePhonenumberEventToWidgets(id, libphonenumber, registry, query) {
  if (!id || id === "") {
    return;
  }
  var splitString;
  if (id.indexOf("${__pos.count}") > 0) {
    splitString = "${__pos.count}";
  } else if (id.indexOf("${__position.count}") > 0) {
    splitString = "${__position.count}";
  }
  if (!splitString) {
    setSeparatePhonenumberEventToWidget(id, libphonenumber, registry);
  } else {
    var multipleItemId = id.split(splitString);
    query("input[id^='" + multipleItemId[0] + "'][id$='" + multipleItemId[1] + "']").forEach(function(node) {
      setSeparatePhonenumberEventToWidget(node.id, libphonenumber, registry);
    });
  }
}

function setSeparatePhonenumberEventToWidget(id, libphonenumber, registry) {
  var widget = registry.byId(id);
  if (!widget) {
    return;
  }
  var PNF = libphonenumber.PhoneNumberFormat;
  var phonenumberUtil = libphonenumber.PhoneNumberUtil.getInstance();
  widget.on("blur", function() {
    var value = this.get("value");
    if (!value || value === "") {
      return;
    }
    var number = phonenumberUtil.parseAndKeepRawInput(value, 'JP');
    this.set("value", phonenumberUtil.format(number, PNF.NATIONAL));
  });
}

function setAutofillFurigana(args) {
  require(["dojo/query"], function(query) {
    var suffixId = "$005d$002f";
    if (args.prefixId) {
      var isFocusSet = true;
      var queryString = "input[id^='" + args.prefixId + "'][id$='" + suffixId + args.srcId + "']";
      query(queryString).forEach(function(node, i) {
        setAutofillFuriganaToWidgets(node.id, args.prefixId + (i + 1) + suffixId + args.dstId, args.isKatakana, isFocusSet);
        isFocusSet = false;
      });
    } else {
      setAutofillFuriganaToWidgets(args.srcId, args.dstId, args.isKatakana, true);
    }
  });
}

function setAutofillFuriganaToWidgets(srcId, dstId, isKatakana, isFocusSet) {
  require(["./system/autokana.js", "dijit/registry"], function(AutoKana, registry) {
    var srcWidget = registry.byId(srcId);
    var dstWidget = registry.byId(dstId);
    if (srcWidget && dstWidget) {
      AutoKana.bind(srcId, dstId, { katakana: isKatakana });
    }
    if (isFocusSet) {
      focusFirstElement();
    }
  });
}

function createGetRelationValuesFunc(formId, url) {
  require(["dijit/registry", "dojo/dom", "dojo/dom-construct", "dojo/dom-style", "dojo/query", "dojo/request"], function(registry, dom, domConstruct, domStyle, query, request) {
    var form = registry.byId(formId);
    if (!form) {
      window.getRelationValues = function(){}
      return;
    }

    var setStatusMessage = function(key, value) {
      if (!value.messages) {
        return;
      }
      domConstruct.empty(key);
      for (var i=0,l=value.messages.length; i<l; i++) {
        domConstruct.create("div", { textContent: value.messages[i] }, key);
      }
    }

    var getErrorIdPrefix = function(key) {
      if (!key) {
        return;
      }
      var errorIdPrefix = key.split("jfcstatus");
      if (!errorIdPrefix || errorIdPrefix.length !== 2) {
        return;
      }
      return errorIdPrefix[0];
    }

    var setErrorMessage = function(key, value) {
      if (!value.error) {
        return;
      }
      var errorIdPrefix = getErrorIdPrefix(key);
      if (!errorIdPrefix) {
        return;
      }
      // エラーメッセージを設定
      var errorId = errorIdPrefix + "jfcerror";
      domStyle.set(errorId, "display", "");
      domConstruct.empty(errorId);
      setRelationValue(errorId, value.error.label);
      // エラーにマウスオーバー時のツールチップメッセージを設定
      var errorTooltipId = errorIdPrefix + "jfcerrorTooltip";
      setStatusMessage(errorTooltipId, value.error);
    }

    var setStatusInfo = function(key, value) {
      setStatusMessage(key, value);
      setErrorMessage(key, value);
    }

    var setRadioButtonChecked = function(widget, value) {
      query("input[name='" + widget.name + "']", widget.focusNode.form).forEach(function(node) {
        if (node.value == value) {
          var radioWidget = registry.byId(node.id);
          if (radioWidget) {
            radioWidget.set("checked", true);
          }
        }
      });
    }

    var setRelationValue = function(key, value) {
      var target = registry.byId(key);
      if (target) {
        if (target.declaredClass === "dijit.form.RadioButton") {
          setRadioButtonChecked(target, value);
        } else {
          if (value && target.declaredClass === "wagby.NumberTextBox") {
            value = Number(value);
          }
          target.set("value", value);
        }
      } else {
        target = dom.byId(key);
        if (target) {
          target.textContent = value;
        }
      }
    }

    var setRelationValues = function(data) {
      for (var key in data) {
        var value = data[key];
        if (key.lastIndexOf("jfcstatus") !== -1) {
          setStatusInfo(key, value);
        } else {
          setRelationValue(key, value);
        }
      }
    }

    var isIgnoreInput = function(elem) {
      if ((typeof elem.name) == 'undefined' ||
          elem.name == '' || elem.name == 'SENDACTION' || elem.name.indexOf('action_') == 0 ||
          elem.type == 'button' || elem.type == 'file' ||
          elem.type == 'image' || elem.type == 'reset' ||
          elem.type == 'submit') {
        return true;
      }
      if ((elem.type == 'radio' || elem.type == 'checkbox') && !elem.checked) {
        return true;
      }
      return false;
    }

    var getValues = function(form) {
      var values = {};
      for (i = 0,l=form.elements.length; i<l; i++) {
        var elem = form.elements[i];
        if (isIgnoreInput(elem)) {
          continue;
        }
        values[elem.name] = elem.value;
      }
      return values;
    }

    window.getRelationValues = function() {
      var values = getValues(form.domNode);
      request(url, {
        data: values,
        method: "POST",
        handleAs: "json",
      }).then(function(data) {
        setRelationValues(data);
      }, function(err) {
console.log("err: ", err);
        showAlertDialog(res.ERROR_MSG_GET_RELATION_ERROR);
      });
    }
  });
}
